

import bpy,math,os,sys
from bpy.types import NodeTree, Node
from bpy.props import*
from mathutils import*

from time import sleep, ctime
import multiprocessing
from multiprocessing import cpu_count


if("PYLIB.global_var" in sys.modules):
    print("find PYLIB.global_var",);
    LIB = sys.modules["PYLIB.global_var"];
else:
    import PYLIB.global_var as LIB;
    
from ..function_node import *

if("IMDJS_nodes_m.global_var" in sys.modules):
    print("find IMDJS_nodes_m.global_var",);
    G = sys.modules["IMDJS_nodes_m.global_var"];
else:
    import IMDJS_nodes_m.global_var as G;
    
try:
    from PYLIB.PYLIB_draw import ΔΔ画B样条曲线过控制点LIB;
except:    
    from ..PYLIB.PYLIB_draw import ΔΔ画B样条曲线过控制点LIB;

#--------------------------------------------------------------------------
path目录mod = os.path.dirname(__file__); #本py文件所在目录
文件夹此mod=os.path.basename(path目录mod);  #imdjs_nodes

    #from IMDJS_nodes_m.function_node import G.Li当前帧GG[0]

    
from .IMDJS_tree import 卐颜色接口卐NodeSocket,卐IMDJS_nodes,卐IMDJS_NODES,卐IMDJS_NODES_PSR ;
from .IMDJS_set_data import ΔAPPLYCurveSK;
from ..operator_node import *;
from ..operator_node import path目录NODE;
try:
    import PYLIB.global_var as LIB;
except:
    from ..PYLIB.PYLIB_main import LIB;
dllpathB = os.path.abspath("B:/cloth_node64.dll");
dllpath64 = os.path.abspath("%s/cloth_node64.dll" % path目录NODE);

CLIB = os.path.abspath("B:/IMDJS_function64.dll");
CLIB64 = os.path.abspath("%s/IMDJS_function64.dll" % path目录NODE);

#from ..operator_node import 卐PICK_TIME卐Operator,卐PSR物体设定卐PropertyGroup,卐UPDATE节点debug卐Operator;#ΔΔUPDATE_初始化,

#////////////////////////////////////////////////
def Δ刷新子级PSR(self,o父):
    for o子 in o父.children:
        o子.location=o子.location;
        """暂时只刷新位移
        o子.scale=o子.scale;
        o子.rotation_quaternion=o子.rotation_quaternion;
        o子.rotation_euler=o子.rotation_euler;
        """
        Δ刷新子级PSR(self,o子);

#==============================================================
def Δ应用初始化单个PSR(self,o,i物序):
    #if(o.name in self.cp物序此节点关键帧记录.keys()):
    if(i物序<len(self.cp物序此节点关键帧记录)):
        pg关键帧记录=self.cp物序此节点关键帧记录[i物序];
        if(self.bp传位):
            if(o.location.x!=pg关键帧记录.fvp3loc[0] or o.location.y!=pg关键帧记录.fvp3loc[1] or o.location.z!=pg关键帧记录.fvp3loc[2]):
                o.location=pg关键帧记录.fvp3loc;
                Δ刷新子级PSR(self,o);
                #print("TRANS LOC",o.location ,pg关键帧记录.fvp3loc);

        if(self.bp传缩):
            if(o.scale.x !=pg关键帧记录.fvp3scale[0] or o.scale.y !=pg关键帧记录.fvp3scale[1] or o.scale.z!=pg关键帧记录.fvp3scale[2] ):
                o.scale =pg关键帧记录.fvp3scale;
                Δ刷新子级PSR(self,o);
        if(self.bp传旋):
            #print("TRANS Q",);
            if(o.rotation_mode=="XYZ"):
                if(o.rotation_euler.x !=pg关键帧记录.fvp3euler[0] or o.rotation_euler.y !=pg关键帧记录.fvp3euler[1]or o.rotation_euler.z!=pg关键帧记录.fvp3euler[2]):
                    o.rotation_euler =pg关键帧记录.fvp3euler;
                    print("set euler",o.rotation_euler );
                    #o.rotation_euler = [  math.radians(rot[0]),math.radians(rot[1]),math.radians(rot[2])];
            elif(o.rotation_mode=="QUATERNION"):
                if(o.rotation_quaternion[0] !=pg关键帧记录.fvp4q[0]or o.rotation_quaternion[1] !=pg关键帧记录.fvp4q[1]or o.rotation_quaternion[2] !=pg关键帧记录.fvp4q[2]or o.rotation_quaternion[3] !=pg关键帧记录.fvp4q[3]):
                    o.rotation_quaternion =pg关键帧记录.fvp4q;
                    Δ刷新子级PSR(self,o);
                    #print("SET Q",);

    else:
        if(self.bp传位 or self.bp传缩 or self.bp传旋):
            print("NOT INIT PSR==",o.name,"start==",self.name);
            #self.report({"ERROR"},"!!!NOT INIT PSR");#"INFO" "ERROR" "DEBUG" "WARNING"
            return ;
        self.report({"ERROR"},"!!I bigger than cp len");#"INFO" "ERROR" "DEBUG" "WARNING"
            

#==============================================================
def ΔΔ开始单个(self,nt,o群父,o,i物序,i延时):
    #----在开始帧前初始化PSR--------------------------------------------------------
    #print("FPS==",G.Li当前帧GG[0] , self.ip节点时间);
    if (G.Li当前帧GG[0] <= self.ip节点时间):
        Δ应用初始化单个PSR(self,o,i物序);#●●这个拖慢
        #print("INIT-----",self.name);
        """"""
        if(self.bp是隐):
            if(o.hide!=self.bp显隐):o.hide=self.bp显隐;
            if(o.hide_render!=self.bp显隐):o.hide_render=self.bp显隐;
            def Δ隐藏子(o):
                if(self.bp是子):
                    for o子 in o.children:
                        if(o子.hide!=self.bp显隐):o子.hide=self.bp显隐;
                        if(o子.hide_render!=self.bp显隐):o子.hide_render=self.bp显隐;
                        Δ隐藏子(o子);
            Δ隐藏子(o);

        #----检测下个节点是否SK-------------------------------------------------------
        ns本节点output= self.outputs["OUTPUT"];
        for link in ns本节点output.links:
            n下一个=link.to_node;
            if(n下一个.bl_idname=="IMDJS_CurveSK"):
                ΔAPPLYCurveSK(n下一个,o);
        
        #print("TIME==",G.Li当前帧GG[0] , self.ip节点时间,self.label);
        if(G.Li当前帧GG[0] == self.ip节点时间):
            self.ip从开始第几个节点=-1;
            if(G.LntIMDJS节点GG==[]):
                print("FLASH Pre fill^^^^",);
                Δ填充LntIMDJS节点GG();#刚开始时 Χ这里换场景崩溃

            LIB.dllIMDJS.ΔΔUPDATE本链节点时刻(c_void_p(nt.as_pointer()),c_void_p(self.as_pointer()));

        """
        try:#TEMP■■
            self.ip节点时间=0;
            self.ip实际帧=self.ip开始帧;
        except:
            self.ip实际帧=self.ip实际帧;
            self.ip节点时间=0;
        G.Lb是要updateGG[0]=False;
        """
        #print("",self.ip实际帧);

    else:
        #----升级下一个节点------------------------------------------------------------
        i从开始第几个loc=0;
        for link in self.outputs["OUTPUT"].links:
            if(link.to_socket.identifier!="INPUT"):continue;
            n下一个=link.to_node;
            
            if(n下一个.bl_idname in ["IMDJS_NodeLocation","IMDJS_NodePSR"]):
                n下一个.ip从开始第几个节点=i从开始第几个loc;
                i从开始第几个loc+=1;
            
            #print("next n==",n下一个);
            #n下一个.Δ升级节点(nt,self,o群父,o,i物序,i延时);#单个物
            n下一个.Δ升级节点(nt,self,o群父,o,i物序,i延时);
        #print("o START==",o.name);


#====进程函数===================================================
def ΔΔΔ每进程函数单个(self,nt,o父,Lo每进程物,n群组输入):
    #print("Lo每进程物",Lo每进程物);#return ;
    cp群组=n群组输入.cp群组物体;i组长=len(cp群组);
    Ls组物=cp群组.keys();#print("Ls组物==",Ls组物);
    for i物序,o in enumerate(Lo每进程物):
        """■■
        if(o.dupli_group ):#暂时只处理一层群组物
            #Do群父o子[o]=[];Do群父o子[o].extend(o.dupli_group.objects);
            if(not self.bp组物一起升级):
                if(not self.bp是延时):
                    for o组物 in o.dupli_group.objects:
                        ΔΔ开始单个(self,o,o组物,0);
                else:
                    for o组物 in o.dupli_group.objects:
                        ΔΔ开始单个(self,o,o组物,Li节点群组物延时[i]);
        """
        if(not self.bp组物一起升级):
            if(n群组输入.ip延时==0):
                ΔΔ开始单个(self,nt,o父,o,i物序,0);
            else:
                if(n群组输入.bp已经初始化):
                    if(o.name in Ls组物):
                        pg=cp群组[o.name];
                        #print("int==",pg.fp距离权重,n群组输入.ip延时,i组长);
                        i延时=int(pg.fp距离权重*n群组输入.ip延时*i组长);
                        #print("delay==",i延时,o.name,pg.fp距离权重);
                    else:
                        print("this object is not in group:%s"%o.name);
                else:
                    i延时=i物序*n群组输入.ip延时;
                ΔΔ开始单个(self,nt,o父,o,i物序,i延时);
                #print("delay OUT==",Li节点群组物延时[i],o.name);
    #print("START SINGLE",);

#======================================================
def ΔΔ开始多个(self,nt,Do群父Lo子,Lo多个物G):
    #----在第壹帧时初始化PSR-----------------------------------------------------
    if (G.Li当前帧GG[0] <= self.ip节点时间):
        for o in Lo多个物G:
            Δ应用初始化单个PSR(self,o);

    #----升级下一个节点------------------------------------------------------------
    for link in self.outputs["OUTPUT"].links:
        if(link.to_socket.identifier!="INPUT"):continue;
        link.to_node.Δ升级节点多个(scene,Do群父Lo子,Lo多个物G);#多个物

#==============================================================
def ΔΔΔ升级节点start(self,nt,scene):
    #print("START",len(self.inputs["INPUT"].links));#√
    if(self.bp是禁用节点):
        if(self.use_custom_color!=self.bp是禁用节点):
            self.use_custom_color=self.bp是禁用节点;
        if(self.color!=(1.0, 0.0, 0.0) ):##红色
            self.color=(1.0, 0.0, 0.0);
        return ;

    #----每个新场景都刷新物体GG-------------------------------------------------------
    #----如果有群组节点连接---------------------------------------------------------
    #print("IMPUT",self.inputs["INPUT"],self.label);
    if(self.inputs["INPUT"].links):
        #self.ip实际帧 = self.ip节点时间;
        #----填充DsGG物-------------------------------------------------------------
        n群组输入=self.inputs["INPUT"].links[0].from_node;
        #print("GROUP==",n群组输入.name);
        if(not n群组输入 or n群组输入.bl_idname!="IMDJS_NodeOutPutGroup"):
            print("NO GROUP INPUT",);
            return ;

        Ls物名本群组=n群组输入.cp群组物体.keys();

        Ds物名i延时本群组={};
        for i,s物名 in enumerate(Ls物名本群组):
            pg=n群组输入.cp群组物体[i];
            Ds物名i延时本群组[s物名]=pg.ip延时;
        #--------------------------------------------------------------------------
        if(LIB.dllIMDJS==None):
            LIB.dllIMDJS=dllΔΔ载入dllLIB(LIB,"dllIMDJS",CLIB,CLIB64);
            LIB.dllIMDJS.ΔΔ场景建立父子LIB(c_void_p(bpy.context.as_pointer()));

            print("REBUILD++++",);
        if(len(G.LoN物GG)==0):
            print("LoNGG  ZERO",G.LoN物GG);
            Δ填充LntIMDJS节点GG();

        try:
            G.Dnt树Dn开始节点Lo节点群组物GG[nt];
        except:
            G.Dnt树Dn开始节点Lo节点群组物GG[nt]={};#G.Dnt树Dn开始节点Li节点群组物延时GG[nt]={};
        try:
            G.Dnt树Dn开始节点Lo节点群组物GG[nt][self];
        except:
            G.Dnt树Dn开始节点Lo节点群组物GG[nt][self]=[];#G.Dnt树Dn开始节点Li节点群组物延时GG[nt][self]=[];
            print("__init__~~~~",);
            #G.Lo强制刷新物GG[self.name]=[];
        #----加入新开始n----------------------------------------------------------------
        if(G.Ln开始ntGG==[]):
            for nt in G.LntIMDJS节点GG:
                for n in nt.nodes:
                    if(n. use_custom_color==True):
                        n. use_custom_color=False;
                    if(n.bl_idname == "IMDJS_NodeStart"):  
                        b有开始n=False;
                        for n2 in G.Ln开始ntGG:
                            if(n == n2[0]):
                                b有开始n=True;
                                break;
                        if(b有开始n==False):
                            G.Ln开始ntGG.append([n,nt]);
        #----不等------------------------------------------------------------
        o父=None;b要刷新=False;Lo物名本群组g=G.Dnt树Dn开始节点Lo节点群组物GG[nt][self];
        i组物数=len(Lo物名本群组g);
        #if(i组物数==0):b要刷新=True;
        i组物名数=len(Ls物名本群组);
        #----判断是否要刷新  Dnt树Dn开始节点Lo节点群组物GG----------------------------------
        if(i组物名数>0):
            if(i组物数!=len(Ls物名本群组) ):
                print("not 1",i组物数,len(Ls物名本群组));
                b要刷新=True;
            else:
                if(G.Dnt树Dn开始节点Lo节点群组物GG[nt][self][0].name!=Ls物名本群组[0]):
                    b要刷新=True;print("not 2",G.Dnt树Dn开始节点Lo节点群组物GG[nt][self][0].name,Ls物名本群组[0]);

        #--------------------------------------------------------------------------
        if(b要刷新==True):
            #return ;
            print("DsGG!=Ls",self.name,i组物数,len(Ls物名本群组));
            if(self.name!=self.label):
                self.label=self.name;
            #print("LsNGG==",G.LoN物GG);#Χ如果没有从function_node导入总局变量,这里会崩溃
            #bpy.ops.op.imdjs_reflash_group(bp不弹出=True);
            #Ls物名本群组=n群组输入.cp群组物体.keys();
            G.Dnt树Dn开始节点Lo节点群组物GG[nt][self].clear();#G.Dnt树Dn开始节点Li节点群组物延时GG[nt][self].clear();
            #G.Lo强制刷新物GG.clear();
            #----填充本节点群组物GG-------------------------------------------------------
            #print("DsGG==",G.Ds物oGG);
            for s物名 in Ls物名本群组:
                if(s物名 in G.Ds物oGG):
                    o=G.Ds物oGG[s物名];
                    if(o not in G.Dnt树Dn开始节点Lo节点群组物GG[nt][self]):
                        print("Dnt==",G.Dnt树Dn开始节点Lo节点群组物GG[nt].keys());
                        print("DntD==",G.Dnt树Dn开始节点Lo节点群组物GG[nt][self]);
                        G.Dnt树Dn开始节点Lo节点群组物GG[nt][self].append(o);
                        #if(self.bp是延时):
                        #G.Dnt树Dn开始节点Li节点群组物延时GG[nt][self].append(Ds物名i延时本群组[o.name]);
                        print("APPEND O ==> ",o.name,self.name);
                        #print("===",G.Dnt树Dn开始节点Lo节点群组物GG[nt][self]);
                
                #----如果在列表不在全局就添加全局--------------------------------------------------
                else:
                    if(s物名 in scene.objects.keys()):
                        ΔΔ填充LoN物GG单个(scene.objects[s物名]);
                        print("FILL O ==> ",scene.objects[s物名],self.name);
                    else:
                        print("object is not in list will remove~~~",s物名,self.name);
                        idx=n群组输入.cp群组物体.keys().index(s物名);
                        n群组输入.cp群组物体.remove(idx);
                        ΔΔ删除LoN物GG单个(scene.objects[s物名]);
                """"""
            #--------------------------------------------------------------------------
            #o父=G.Dnt树Dn开始节点Lo节点群组物GG[nt][self][0].parent;#第一个群组物的父,如果有的话
        #====强制刷新物====================================================
        #if(G.Lo强制刷新物GG==[]):
        if(self.sp强制刷新物!=""):
            if(self.sp强制刷新物  in G.Ds物oGG):
                o=G.Ds物oGG[self.sp强制刷新物];
                if(o not in G.Lo强制刷新物GG):
                    G.Lo强制刷新物GG.append(o);print("add force",o);#■■暂时只载入一个物

        #----单进程运行----------------------------------------------------------
        ΔΔΔ每进程函数单个(self,nt,o父,G.Dnt树Dn开始节点Lo节点群组物GG[nt][self],n群组输入);
        """
        #----多个---------------------------------------------------------------
        Do群父Lo子={};#暂时无用
        if(self.bp组物一起升级):
            ΔΔ开始多个(self,nt,Do群父Lo子,G.Dnt树Dn开始节点Lo节点群组物GG[nt][self]);
        #print("o Ls==",o.name);
        #print("UPDATA NEXT",);
        """

#////////////////////////////////////////////////
def  ΔUPDATE强制刷新(self,context):
    G.Lo强制刷新物GG.clear();
    if(self.sp强制刷新物 in G.Ds物oGG):
        G.Lo强制刷新物GG.append(G.Ds物oGG[self.sp强制刷新物]);
        #print("add foce==",G.Ds物oGG[self.sp强制刷新物]);

def  ΔUPDATE开始帧(self,context):
    if(G.Lb是要updateGG[0]==True):#确保在其它函数执行时不updata
        if(LIB.dllIMDJS==None):LIB.dllIMDJS=dllΔΔ载入dllLIB(LIB,"dllIMDJS",CLIB,CLIB64);
        space = context.space_data;
        LIB.dllIMDJS.ΔΔUPDATE本链节点时刻(c_void_p(space.node_tree.as_pointer()),c_void_p(self.as_pointer()));
        """
        self.ip实际帧 = self.ip节点时间;
        if(self.outputs["OUTPUT"].links):
            Δ迭代下一个(self);
        """
        G.Lb是要updateGG[0]=True;
        
#////画画////////////////////////////////////////
from bpy_extras import view3d_utils
global areaG;areaG=None;
class 卐画画曲线切换卐Operator(bpy.types.Operator):
    bl_idname = "op.draw_curve_toggle"
    bl_label = "draw_curve_toggle"
    bl_description = "draw_curve_toggle"

    #cp群组物体= CollectionProperty(type=卐群组物体卐PropertyGroup);

    _handle = None;

    vZ=Vector((0.0,0.0,0.0));Lv2屏位=[None,None];

    #======================================================
    @classmethod
    def poll(cls, context):
        return context.mode=="OBJECT";

    def modal(self, context, event):
        global  areaG;
        #if (context.area):context.area.tag_redraw();
        #----刷新界面--------------------------------------------------------
        """"""
        if(not areaG):
            screen=bpy.context.screen;
            for a in screen.areas:
                if(a.type=="VIEW_3D"):
                    areaG=a;
                    a.tag_redraw();
        else:
            areaG.tag_redraw();#为了不用每次都找 area
        
        #----停止--------------------------------------------------------------
        """"""
        if(LIB.Li显示LIB[0]==-1):
            bpy.types.SpaceView3D.draw_handler_remove(self._handle, 'WINDOW');
            LIB.Li显示LIB[0]=0;
            #print("REMOVE modal==",self._handle);
            ΔΔ清除glLIB();
            print("remove handle 1 ~~~~",len(LIB.Lv位实物LIB));
            
            #return {"CANCELLED"};
            return {"FINISHED"};
        
        return {"PASS_THROUGH"};
        
    #==============================================================
    def invoke(self, context, event):
        print("BP invoke==",LIB.Li显示LIB[0],len(LIB.Lv位实物LIB),LIB.Lv位实物LIB);#return {"FINISHED"};
        if(LIB.Li显示LIB[0]<1):#0 或 -1
            LIB.Li显示LIB[0]=1;
            self.nThis=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
            if( self.nThis):
                ΔUPDATE生成曲线路径 ( self.nThis,context);
            #----增加手柄----------------------------------------------------------------
            self._handle = bpy.types.SpaceView3D.draw_handler_add(ΔΔ画线LIB,(self, context), 'WINDOW', 'POST_PIXEL');
            context.window_manager.modal_handler_add(self);#(self==Operator) to call  Return type: boolean
            print("add handle+++",);
        
        else:
            LIB.Li显示LIB[0]=-1;

        return {"RUNNING_MODAL"};

        
bpy.utils.register_class(卐画画曲线切换卐Operator) ;
#==============================================================
def  ΔUPDATE生成曲线路径 (self,context):
    if(self.bp是曲线插值):
        self.C物序cp曲线缓存.clear();self.cp节点序时刻ξ.clear();ΔΔ清除glLIB();
        if(LIB.dllIMDJS==None):LIB.dllIMDJS=dllΔΔ载入dllLIB(LIB,"dllIMDJS",CLIB,CLIB64);
        """
        if(len(self.C物序cp曲线缓存)>0):
            #print("have cp ",len(self.C物序cp曲线缓存),self.C物序cp曲线缓存[0] );
            for pg in self.C物序cp曲线缓存:
                LIB.L条序Lv物位蓝LIB.append(Vector((pg.fvp3loc[0],pg.fvp3loc[1],pg.fvp3loc[2])));

            return ;
        """
        #----群组物-------------------------------------------------------------
        n群组输入=self.inputs["INPUT"].links[0].from_node;
        #print("GROUP==",n群组输入.name);
        if(not n群组输入 or n群组输入.bl_idname!="IMDJS_NodeOutPutGroup"):
            print("NO GROUP INPUT",);
            return ;

        #==============================================================
        space = context.space_data;cvpNt=c_void_p(space.node_tree.as_pointer());
        #┃---┃-----┃
        #节点     节点        节点
        v零=Vector((-100000.0, -100000.0, -100000.0));
        Ls物名本群组=n群组输入.cp群组物体.keys();
        print("Ls物名本群组==",Ls物名本群组);
        #--------------------------------------------------------------------------
        cvpA=c_void_p(self.as_pointer());
        Li节点数i曲线点总数=(c_int*2)();
        LIB.dllIMDJS.ΔΔ计算链节点数与路径点数(cvpNt,cvpA,len(Ls物名本群组),Li节点数i曲线点总数);    
        print("Li节点数i曲线点总数==",Li节点数i曲线点总数[0],Li节点数i曲线点总数[1]);#√ 3  10
        for i物序,s物名 in enumerate(Ls物名本群组):
            pgCP=self.C物序cp曲线缓存.add();
            pgCP.name=s物名;pgCP.idx=i物序; #●●必须要赋值才 有属性
            for i in range(Li节点数i曲线点总数[1]+1):#●●比原来的多一个点
                pgPSR=pgCP.cpPSR.add();pgPSR.fvp3loc=v零;pgPSR.fvp3euler=v零;pgPSR.idx=-1;
      
        #self.cp节点序时刻ξ.clear();
        for i in range(Li节点数i曲线点总数[0]):
            pg=self.cp节点序时刻ξ.add();pg.idx=-1;#节点ξ

        #--------------------------------------------------------------------------
        Lf3节点END_LOCΠ_=((c_float*3)*Li节点数i曲线点总数[0])();Lf3曲线点位resultΠ_=((c_float*3)*(Li节点数i曲线点总数[1]+1))();
        Lf3节点END_ROTΠ_=((c_float*3)*Li节点数i曲线点总数[0])();Lf3曲线旋转resultΠ_=((c_float*3)*(Li节点数i曲线点总数[1]+1))();
        L=[];L2=[];
        for i物序,s物名 in enumerate(Ls物名本群组):
            l=[];l2=[];
            if(s物名 in G.Ds物oGG):
                cvpO=c_void_p(G.Ds物oGG[s物名].as_pointer());
                LIB.dllIMDJS.ΔΔ计算本链节点曲线loc(cvpA,cvpO,i物序,Li节点数i曲线点总数[1],Lf3节点END_LOCΠ_,Lf3曲线点位resultΠ_,Lf3节点END_ROTΠ_,Lf3曲线旋转resultΠ_);#写入属性
                for f3 in Lf3节点END_LOCΠ_:
                    #print("f3==",f3[0],f3[1],f3[2]);
                    l.append(Vector([f3[0],f3[1],f3[2]]));#点序[v,v,...]
                for f3 in Lf3曲线点位resultΠ_:
                    l2.append(Vector([f3[0],f3[1],f3[2]]));
                L.append(l);L2.append(l2);#物序[点序[v,v,...],[v,v,...],...]
        ΔΔ画B样条曲线过控制点LIB(L,L2);

        print("draw 1---------------------",LIB.b显示LIB[0],len(LIB.Lv位实物LIB));
        #print("len fn3==",len(Lf3节点END_LOCΠ_),len(Lf3曲线点位resultΠ_));
        #--------------------------------------------------------------------------

        #for pg in self.C物序cp曲线缓存:print("pg==",*pg.fvp3loc);
        #LIB.dllIMDJS.ΔΔ生成曲线路径(c_void_p(space.node_tree.as_pointer()),c_void_p(self.as_pointer()));
    else:
        self.C物序cp曲线缓存.clear();self.cp节点序时刻ξ.clear();ΔΔ清除glLIB();
        #LIB.b显示LIB[0]=self.bp是显示路径=False;
        #bpy.ops.op.draw_curve_toggle("INVOKE_DEFAULT");
        #LIB.Li显示LIB[0]=-1;
        print("==",LIB.b显示LIB[0],self.bp是显示路径);
  
#==============================================================
def  ΔUPDATE画曲线路径 (self,context):#勾选
    #ΔΔ画B样条曲线过控制点LIB(Lv位实物LIB,LIB.L条序Lv物位蓝LIB);
    #print("lenV==",len(Lv位实物LIB),len(LIB.Lv位实物LIB));
    
    if(LIB.L条序Lv物位蓝LIB==[] or len(self.C物序cp曲线缓存)==0):
        self.C物序cp曲线缓存.clear();self.cp节点序时刻ξ.clear();ΔΔ清除glLIB();
        if(self.bp是显示路径):
            LIB.b显示LIB[0]=self.bp是显示路径;
            ΔUPDATE生成曲线路径 (self,context);
            print("generate path",);

    else:
        #----画-----------------------------------------------------------------
        LIB.b显示LIB[0]=self.bp是显示路径;

        bpy.ops.op.draw_line_lib("INVOKE_DEFAULT");
        print("draw 2---------------------",LIB.b显示LIB[0],len(LIB.Lv位实物LIB));
        context.area.spaces.active=context.space_data;
    

class 卐开始卐IMDJS_NODES(Node,卐IMDJS_NODES):
    bl_idname = "IMDJS_NodeStart"
    bl_label = "START ->>>"
    bl_width_default=200;
    bl_width_min=200;
    bl_width_max=500;

    sp节点类型 = StringProperty(default="START");

    bp组物一起升级=BoolProperty(name='',description='',default=False,subtype='NONE',update=None,get=None,set=None);
    #bp是延时=BoolProperty(name='delay',description='',default=False,subtype='NONE',update=None,get=None,set=None);
    bp是pre=BoolProperty(name='is PRE',description='is the frame_change_pre handle',default=True,subtype='NONE',update=None,get=None,set=None);
    #----CURVE---------------------------------------------------------------
    bp是曲线插值=BoolProperty(name='is curve',description='is curve interplolation',default=False,subtype='NONE',update=ΔUPDATE生成曲线路径,get=None,set=None);
    bp是显示路径=BoolProperty(name='show path',description='show path',default=False,subtype='NONE',update=ΔUPDATE画曲线路径,get=None,set=None);
    #--------------------------------------------------------------------------
    sp强制刷新物=StringProperty(name='force object',description='force to reflash this  object',default='',maxlen=0,subtype='NONE',update=ΔUPDATE强制刷新,get=None,set=None);
    #--------------------------------------------------------------------------
    spDebug=StringProperty(name='error info',description='what is wrong?',default='',maxlen=0,subtype='NONE',update=None,get=None,set=None);
    #--------------------------------------------------------------------------
    bp传位=BoolProperty(name='',description='',default=False,subtype='NONE',update=None,get=None,set=None);
    bp传缩=BoolProperty(name='',description='',default=False,subtype='NONE',update=None,get=None,set=None);
    bp传旋=BoolProperty(name='',description='',default=False,subtype='NONE',update=None,get=None,set=None);

    bp是隐=BoolProperty(name='',description='',default=False,subtype='NONE',update=None,get=None,set=None);
    bp显隐=BoolProperty(name='',description='',default=False,subtype='NONE',update=None,get=None,set=None);
    bp是子=BoolProperty(name='',description='',default=True,subtype='NONE',update=None,get=None,set=None);
    #----缓存-------------------------------------------------------------------
    cp节点序时刻ξ=CollectionProperty(type=卐name卐PropertyGroup,name='开始时刻loc',description='');
    C物序cp曲线缓存=CollectionProperty(type=卐Cpsr记录卐PropertyGroup,name='缓存曲线loc',description='');

    #--------------------------------------------------------------------------
    ip核心数 = IntProperty(default=2);
    ip平均每核分配物数= IntProperty(default=0);
    #----TEMP-----------------------------------------------------------------
    #ip开始帧 = IntProperty(default=1);

    #--------------------------------------------------------------------------
    def init(self,context):
        卐IMDJS_NODES.init(self, context);
        self.bp是禁用节点=False;
        INPUT=self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"INPUT");
        #self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"EFFECTOR");#效果器
        START=self.inputs.new("NodeSocketIntUnsigned","START TIME","start_frame");
        START.hide_value=True;
        self.outputs.new(卐颜色接口卐NodeSocket.bl_idname,"OUTPUT");
        #----初始化值--------------------------------------------------------------
        INPUT.ip接口开始时刻=1;#print("ADD SOCK",INPUT.ip接口开始时刻);
        self.sp节点类型 = "UPDATABLE";
        self.label=self.name;
        self.ip节点时间=1;

        #pg=self.C物序cp曲线缓存.add();pg.name="MY";pg.fvp3loc=Vector((1.1,2.2,3.3));
        #pg2=self.cp节点序时刻ξ.add();pg2.name="YOU";pg2.location=Vector((3.1,8.2,7.3));

    #======================================================
    def Δ升级节点(self,nt,scene):
        ΔΔΔ升级节点start(self,nt,scene);
        #print("update start",);
        #print("",hasattr(self,'ip实际帧'));
        #if(not hasattr(self,'ip实际帧')):print("no real frame attri",self.ip实际帧);

        #if(not hasattr(self,'ip节点时间')):

        #print("start output==",self.ip实际帧);

    #--------------------------------------------------------------------------
    def draw_buttons(self,context,layout):
        uil行=layout.row(align=False);
        #uil行.prop(data=self,property="bp组物一起升级",text='update with group objects',text_ctxt='',translate=True,icon='NONE',expand=False,slider=False,toggle=True,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);
        #uil行.prop(data=self,property="bp是延时",text='delay',text_ctxt='',translate=True,icon='NONE',expand=False,slider=False,toggle=True,icon_only=False,event=False,full_event=False,emboss=True);

        uil行=layout.row(align=True);
        uil行.prop(self, "bp传位", text = "trans LOC",icon="MAN_TRANS",toggle=True);uil行.prop(self, "bp传旋", text = "trans SCALE",icon="MAN_ROT",toggle=True); uil行.prop(self, "bp传缩", text = "trans ROT",icon="MAN_SCALE",toggle=True);

        uil行=layout.row(align=True);
        uil行.prop(self, "bp是隐", text = "mute",icon="NONE",toggle=False);
        if(self.bp是隐):
            uil行.prop(self, "bp显隐", text = "hide",icon="VISIBLE_IPO_OFF",toggle=True);
            uil行.prop(self, "bp是子", text = "to_child",icon="OOPS",toggle=True);

        uil行=layout.row(align=False);
        uil行.prop(self, "bp是pre", text = "is PRE",icon="NONE",toggle=True);
        uil行.prop(self, "bp是曲线插值", text = "curve",icon="MOD_CURVE",toggle=True);
        if(self.bp是曲线插值):
            #uil行.prop(self, "bp是显示路径", text = "show path",icon="NONE",toggle=False);
            uil行.operator(卐画画曲线切换卐Operator.bl_idname,text = "draw path", icon='GREASEPENCIL');

        layout.prop(self, "sp强制刷新物", text = "ForceObject",icon="NONE",toggle=False);

        uil行=layout.row(align=False);
        uil行.operator(卐GOTO本节点尾卐Operator.bl_idname, icon='LOOP_FORWARDS');

        uil行=layout.row(align=False);
        uil行.operator(卐初始化PSR卐Operator.bl_idname, icon='AXIS_SIDE');
        uil行.operator(卐PICK_TIME卐Operator.bl_idname, icon='EYEDROPPER');

        layout.operator(卐UPDATE节点debug卐Operator.bl_idname, icon='ERROR');
        layout.operator(卐画画2dlib卐Operator.bl_idname, icon='GREASEPENCIL');
        #--------------------------------------------------------------------------
        uil行D=layout.row(align=True);
        uil行D.prop(self, "spDebug", translate=True,icon="NONE",toggle=False);
        uil行D.enabled=False;

        uil行=layout.row(align=True);
        #uil行.prop(self, "ip实际帧", text = "start frame",slider=False);
        uil行.prop(self, "ip节点时间", text = "start frame",slider=True);

        #layout.prop(self, "ip实际帧", text = "real frame",slider=True);

"""
#==============================================================
class 卐重建CURVE卐Operator(bpy.types.Operator):
    bl_idname = "op.imdjs_rebuild_curve";
    bl_label = "rebuild curve";
    bl_options={'UNDO'};
    bl_context='object';

    sp=StringProperty(name="注意", description="", default="are you sure init PSR？");
    #--------------------------------------------------------------------------
    def draw(self, context):    self.layout.prop(self, "sp");

    def invoke(self, context, event):
        self.n开始=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        return context.window_manager.invoke_props_dialog(self,300,50);#召唤

    def execute(self, context):
        print("sp==",self.sp);
        if(self.n开始!=None):
            Li节点数i曲线点总数=(c_int*2)();
            LIB.dllTEST.ΔΔ计算链节点数与路径点数(cvpNt,cvpA,Li节点数i曲线点总数);
            i多或少loc=len(self.n开始.C物序cp曲线缓存)-(Li节点数i曲线点总数[1]+1);
            #----多就删除------------------------------------------------------------
            if(i多或少loc>0):
                for i in range(i多或少loc):
                    self.n开始.C物序cp曲线缓存.remove(C物序cp曲线缓存[-1]);
            elif(i多或少loc<0):
                for i in range(-i多或少loc):
                    self.n开始.C物序cp曲线缓存.add();


            Lf3节点END_LOCΠ_=((c_float*3)*Li节点数i曲线点总数[0])();Lf3曲线点位resultΠ_=((c_float*3)*(Li节点数i曲线点总数[1]+1))();
            LIB.dllTEST.ΔΔ计算本链节点曲线loc(cvpNt,cvpA,Li节点数i曲线点总数[1],Lf3节点END_LOCΠ_,Lf3曲线点位resultΠ_);

        return {"FINISHED"};
"""
#////////////////////////////////////////////////
def ΔΔ初始化PSR(self,context,nThis,o,b是群组加入):
    Ls已经初始化物=[];L初始化物序pg=[];
    if(nThis):
        self.n开始=nΔΔ找到开始节点up(nThis);
    if(self.n开始!=None):
        n群组输入=self.n开始.inputs["INPUT"].links[0].from_node;
        #--------------------------------------------------------------------------
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();
        #print("LoNGG==",G.LoN物GG);
        if(not n群组输入  ):
            self.report({"ERROR"},"!!!no group node");#"INFO" "ERROR" "DEBUG" "WARNING"
            return ;
        print("group==",n群组输入.name);
        #----找到群组物并初始化-------------------------------------------------------------
        #for n群组输入 in [n群组输入,n群组输出]:
        #if(n群组输入==None):continue;
        Ls物名本群组=n群组输入.cp群组物体.keys();self.n开始.bp传位=True;self.n开始.bp传缩=True;self.n开始.bp传旋=True;
        print("group objss==",Ls物名本群组);
        i成功初始化物数=0;
        #====假设o.name in Ls物名本群组 ==========================================
        def pgΔ初始化o(o):
            #if(not o.dupli_group ):#■■非群组物
            idx当前物ξ=Ls物名本群组.index(o.name);#当前物序
            if(n群组输入.bp只激活物==True):
                if(idx当前物ξ!=n群组输入.ip激活群组物体ξ):
                    return;
            #----少则add-------------------------------------------------------------
            i缺了多少物=(idx当前物ξ+1)-len( self.n开始.cp物序此节点关键帧记录);
            if(i缺了多少物>0):
                for i in range(i缺了多少物):
                    pg关键帧记录=self.n开始.cp物序此节点关键帧记录.add();#pg关键帧记录.name=o.name;
            
            pg关键帧记录=self.n开始.cp物序此节点关键帧记录[idx当前物ξ];
            #----记录PSR--------------------------------------------------------------
            #if(self.n开始.bp传位): 
            if(o.location !=pg关键帧记录.fvp3loc):
                pg关键帧记录.fvp3loc=o.location;

            #if(self.n开始.bp传缩):
            if(o.scale !=pg关键帧记录.fvp3scale):
                pg关键帧记录.fvp3scale=o.scale;

            #if(self.n开始.bp传旋):
            if(o.rotation_mode=="XYZ"):
                if(pg关键帧记录.fvp3euler!=o.rotation_euler[:3]):
                    pg关键帧记录.fvp3euler=o.rotation_euler[:3];
            elif(o.rotation_mode=="QUATERNION"):
                if(pg关键帧记录.fvp4q!=o.rotation_quaternion ):
                    pg关键帧记录.fvp4q=o.rotation_quaternion ; 
            print("pg关键帧记录==",pg关键帧记录.name);
            Ls已经初始化物.append(o.name);
            L初始化物序pg.append(pg关键帧记录);
            return pg关键帧记录;

            
        #==============================================================
        #----单个-------------------------------------------------------------
        if(o and o.name in Ls物名本群组 ):
            pg关键帧记录=pgΔ初始化o(o);
            if(pg关键帧记录):
                i成功初始化物数+=1;
                
        #----全部--------------------------------------------------------------
        else:
            pg关键帧记录=None;
            for i,o in enumerate(G.LoN物GG):
                if(o.name in Ls物名本群组 ):
                    if(pg关键帧记录==None):
                        pg关键帧记录=pgΔ初始化o(o);
                        if(pg关键帧记录):
                            i成功初始化物数+=1;
                    else:
                        pgΔ初始化o(o);
                        i成功初始化物数+=1;
        #----初始化--------------------------------------------------------------
        if(pg关键帧记录):
            for i,s in enumerate(Ls已经初始化物):
                self.report({"ERROR"},"init==%s    loc==%f,%f,%f"%(s,L初始化物序pg[i].fvp3loc[0],pg关键帧记录.fvp3loc[1],pg关键帧记录.fvp3loc[2]));#"INFO" "ERROR" "DEBUG" "WARNING"

        else:
            self.report({"ERROR"},"!!!no pg关键帧记录");#"INFO" "ERROR" "DEBUG" "WARNING"
            
class 卐初始化PSR卐Operator(bpy.types.Operator):
    bl_idname = "op.imdjs_init_psr";
    bl_label = "init PSR";
    bl_options={'UNDO'};
    bl_context='object';

    sp=StringProperty(name="注意", description="", default="are you sure init PSR？");
    #--------------------------------------------------------------------------
    def draw(self, context):    self.layout.prop(self, "sp");

    def invoke(self, context, event):
        self.n开始=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        return context.window_manager.invoke_props_dialog(self,300,50);#召唤

    def execute(self, context):
        print("sp==",self.sp);
        ΔΔ初始化PSR(self,context,self.n开始,None,False);#全部

        return {"FINISHED"};


D目录={"NodeCategory":["IMDJS_NodeCategoryLogic","START"]};
Ls条项=[卐开始卐IMDJS_NODES.bl_idname];#

#////END/////////////////////////////////////////////





