import bpy,math,os,sys
#/////.py ///////////////////////////////////////////////////////////
from bpy.types import NodeTree, Node
from bpy.props import*
from mathutils import*

try:
    import PYLIB.global_var as LIB;
except:
    from ..PYLIB.PYLIB_main import LIB;

try:
    from PYLIB.PYLIB_attribute import dllΔΔ载入dllLIB,dllΔΔ卸载dllLIB;
except:
    from ..PYLIB.PYLIB_attribute import dllΔΔ载入dllLIB,dllΔΔ卸载dllLIB;


from ..operator_cloth import *;
    
#from ..function_node import *

from .IMDJS_tree import 卐颜色接口卐NodeSocket,卐IMDJS_nodes,卐IMDJS_NODES,卐IMDJS_NODES_PSR ;

#from ..operator_node import 卐刷新所有群组名称卐Operator,卐同步游戏LOD卐Operator ,卐创建游戏LOD卐Operator;

from ..operator_node import dllpathB,dllpath64;

#////mt_nodes_attrset.py/////////////////////////////////////
class 卐模拟布料卐IMDJS_NODES(Node, 卐IMDJS_NODES):
    bl_idname = 'IMDJS_NodePhysiscsCloth'
    bl_label = 'coth_simulation'
    bl_icon = 'MOD_CLOTH'
    bl_width_default=250;
    bl_width_min=200;
    bl_width_max=500;
    
    sp节点类型 = StringProperty()
    sp信息 = StringProperty()
    bp开始了全局 = BoolProperty(name='',description='',default=False,subtype='NONE',update=None,get=None,set=None);
    bp是自碰撞 = BoolProperty(name='self collider',description='',default=True,subtype='NONE',update=None,get=None,set=None);    
    ip迭代次数=bpy.props.IntProperty(name='iteration',description='iteration of cloth simulation',default=3,min=1, max=10, step=1,);
    ip绑定面数= IntProperty(name="bind faces",description="set the number of near faces to be binded to this face",default= 10,min=1, max=100,) ;
    fp希疏比=FloatProperty(name="hash", description="hash percentage", default=0.2, min=0.01, max=0.5, precision=3, subtype="NONE", unit="NONE", update=None);
    #==============================================================
    def init(self, context):
        #self.b使用回放颜色 = False;
        卐IMDJS_NODES.init(self, context);

        self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"INPUT");
        self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"COLLIDER");

        START=self.inputs.new("NodeSocketIntUnsigned","START TIME","start_frame");#如果有link 开始时间按这个算
        START.hide_value=True;
        LIMIT=self.inputs.new("NodeSocketIntUnsigned","LIMIT TIME","limit_frame");#限制时间
        LIMIT.hide_value=True;
        self.outputs.new(卐颜色接口卐NodeSocket.bl_idname,"OUTPUT");
        
        self.outputs.new("NodeSocketIntUnsigned","NO_STOP").hide_value=True;
        self.label=self.name;self.use_custom_color=True;
        #----初始化值--------------------------------------------------------------
        INPUT.ip接口开始时刻=1;self.ip节点时间=500;
        
        self.cp物序此节点关键帧记录[self.name].fvp3loc=self.cp物序此节点关键帧记录[self.name].fvp3euler=( 0.0, 0.0,0.0);self.fvp4q=(1.0, 0.0, 0.0,0.0);
        self.cp物序此节点关键帧记录[self.name].fvp3scale=( 1.0, 1.0,1.0);self.ip指数=1;
        
    #☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐●━━━●━━━●☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐┃☐☐/┃☐☐/┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐┃☐/☐┃☐/☐┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐┃/☐☐┃/☐☐┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐●━━━●━━━●☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐┃☐☐/┃☐☐/┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐┃☐/☐┃☐/☐┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐┃/☐☐┃/☐☐┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐●━━━●━━━●☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    def Δ升级节点(self,nt,n开始,o群父,o,i物序,i延时):
        #print("update",);
        if(bΔΔ是禁用节点(nt,self,o群父,o,i延时) ):return ;
        id=o.data;
        try:
            o["gCLOTH"];
            if(o["gCLOTH"]["VERT_NUM"]!=len(id.vertices)):
                self.sp信息="vertex number is changed !";
                return sΔΔ节点出错变色(self,(True),self.sp信息);
        except:
            self.sp信息="cloth not init !";
            return sΔΔ节点出错变色(self,(True),self.sp信息);

        if(o.active_shape_key.name!="CLOTH_SIM"):
            Csk=o.data.shape_keys.key_blocks;
            try:
                o.active_shape_key_index=Csk.keys().index("CLOTH_SIM");
            except:
                sk=o.shape_key_add(name="CLOTH_SIM", from_mix=True);
                sk.value=1;
                o.active_shape_key_index=Csk.keys().index("CLOTH_SIM");

        if(self.sp信息!=""):
            self.sp信息="";

        #====如果有群组节点连接===============================================
        i碰撞物数=0;
        try:
            G.Ds碰撞节点cl群组物指针GG[self.name];
        except:
            G.Ds碰撞节点cl群组物指针GG[self.name]=(c_long*i碰撞物数)();#默然值 0

        if(self.inputs["COLLIDER"].links):
            #self.ip实际帧 = self.ip节点时间;
            n群组输入=self.inputs["COLLIDER"].links[0].from_node;
            #print("GROUP==",n群组输入.name);
            if(not n群组输入):
                print("NO GROUP COLLIDER",);
                return ;
            #----填充---------------------------------------------------------------
            if(len(G.LoN物GG)==0):
                print("LoNGG  ZERO",);
                Δ填充LntIMDJS节点GG();

            #----不等------------------------------------------------------------
            Ls碰撞物名group=n群组输入.cp群组物体.keys();
            i碰撞物数=len(Ls碰撞物名group);


            if(len(G.Ds碰撞节点cl群组物指针GG[self.name])!=i碰撞物数):
                #return ;
                print("DsGG!=Ls colli",self.name,G.Ds碰撞节点cl群组物指针GG[self.name],i碰撞物数,Ls碰撞物名group);
                print("LsNGG==",G.LoN物GG);#Χ如果没有从function_node导入总局变量,这里会崩溃
                #bpy.ops.op.imdjs_reflash_group(bp不弹出=True);
                #Ls碰撞物名group=n群组输入.cp群组物体.keys();
                G.Ds碰撞节点cl群组物指针GG[self.name]=(c_long*i碰撞物数)();#清空,重建

                #----填充本节点群组物GG-------------------------------------------------------
                i物ξ=0;
                for o碰撞 in G.LoN物GG:
                    if(o碰撞.name in Ls碰撞物名group):
                        G.Ds碰撞节点cl群组物指针GG[self.name][i物ξ]=o碰撞.as_pointer();#填充物体指针为long
                        i物ξ+=1;
                        print("APPEND O",o碰撞.name);
            #----检查碰撞物属性-----------------------------------------------------------
            #print("G.Ds物oGG",G.Ds物oGG,G.Ds物oGG[Ls碰撞物名group[0]]);#√
            if(G.Ds物oGG[Ls碰撞物名group[0]]["gCLOTH"]["CHECK_DISTANCE"][0]<=0):
                self.sp信息="shapekey  not in CLOTH_SIM!!!";
                return sΔΔ节点出错变色(self,(True),"shapekey  not in CLOTH_SIM!!!");
            try:    pass;    
            except:
                self.sp信息="collider is not inited yet!!!";
                return sΔΔ节点出错变色(self,(True),self.sp信息);

        #-------------------------------------------------------------------------
        #print(" dllCloth now ",G.Li当前帧GG[0] , self.ip节点时间, self.ip实际帧,LIB.dllCloth);

        i本节点开始时刻=self.inputs["INPUT"].ip接口开始时刻 = self.inputs["INPUT"].links[0].from_node.ip节点时间;
        self.ip实际帧 = i本节点开始时刻 + self.ip节点时间
        #====在本节点时间内==============================================
        #print("G.Li当前帧GG[0] == %d    i本节点开始时刻 == %d  self.ip实际帧==  %d "%(G.Li当前帧GG[0] ,i本节点开始时刻,self.ip实际帧) );
        if (G.Li当前帧GG[0] >= i本节点开始时刻 and G.Li当前帧GG[0] <= self.ip实际帧):
            if(LIB.dllCloth==None):LIB.dllCloth=dllΔΔ载入dllLIB(LIB,"dllCloth",dllpathB,dllpath64);
                    
            #LIB.dllCloth=dllΔΔ载入dllLIB(LIB,"dllCloth",dllpathB,dllpath64);
            #----本节点第一帧---父位置初始化---------------------------------------------
            if(G.Li当前帧GG[0] ==i本节点开始时刻+1):
                b是第一帧=True;print("CLOTH INIT",o.name);
                #if(LIB.dllCloth==None):
                    #LIB.dllCloth=dllΔΔ载入dllLIB(LIB,"dllCloth",dllpathB,dllpath64);
                    #print("import dllCloth ",G.Li当前帧GG[0] , self.ip节点时间);
                LIB.dllCloth.ΔΔΔ布料模拟(c_void_p(o.as_pointer()),G.Ds碰撞节点cl群组物指针GG[self.name],i碰撞物数,c_float(o.pp布料o.fp点积阈值),c_float(o.pp布料o.f碰撞法线偏移),self.ip迭代次数,self.bp是自碰撞,b是第一帧 ,2);#●●注意  G.Ds碰撞节点cl群组物指针GG[self.name] 不能传一个0 值的指针,一定会出错
                #o.data.update();
                
            else:
                #print("sim------->",);
                LIB.dllCloth.ΔΔΔ布料模拟(c_void_p(o.as_pointer()),G.Ds碰撞节点cl群组物指针GG[self.name],i碰撞物数,c_float(o.pp布料o.fp点积阈值),c_float(o.pp布料o.f碰撞法线偏移),self.ip迭代次数,self.bp是自碰撞,False,2);

            #print("run->->->",);

    #-------------------------------------------------------------------------
    def draw_buttons(self, context, layout):
        uil=layout.row();
        uil.prop(self, "ip实际帧", text = "C");uil.enabled=False;
        uil=layout.row();
        uil.prop(self, "sp信息", text = "debug");
        uil.enabled=False;
        uil=layout.row();
        layout.label(text='----common---------------------',text_ctxt='',translate=True,icon='NONE',icon_value=0);
        uil=layout.row(align=True);
        uil.prop(self, "ip绑定面数",translate=True,); 
        uil.prop(self, "fp希疏比",translate=True,);    
        uil=layout.row(align=True);
        uil.prop(self, "ip迭代次数", translate=True,);        
        uil.prop(self, "bp是自碰撞",translate=True,);        
            
        layout.label(text='----cloth------------------------',translate=True,icon='NONE',icon_value=0);
        uil=layout.row(align=True);
        uil.operator(operator=卐布料init卐Operator.bl_idname,translate=True,icon='NONE',emboss=True,icon_value=0);        
        uil.operator(operator=卐布料还原卐Operator.bl_idname,translate=True,icon='LOOP_BACK',emboss=True,icon_value=0);        
        #uil.operator(operator=卐布料清除数据卐Operator.bl_idname,translate=True,icon='NONE',emboss=True,icon_value=0);     
        uil=layout.row(align=True);        
        uil.operator(operator=卐TEST_cloth卐Operator.bl_idname,translate=True,icon='NONE',emboss=True,icon_value=0);         
        
        uil.operator(operator=卐画画法线卐Operator.bl_idname,text_ctxt='',translate=True,icon='GREASEPENCIL',emboss=True,icon_value=0).bp是colli=False;
        #def draw_buttons_ext(self, context, layout):
            #layout.prop(self, "sp信息", text = "debug");
            
        layout.label(text='----collider---------------------',text_ctxt='',translate=True,icon='NONE',icon_value=0);
        uil=layout.row(align=True);
        uil.operator(operator=卐碰撞物init卐Operator.bl_idname,text_ctxt='',translate=True,icon='NONE',emboss=True,icon_value=0);        
        uil.operator(operator=卐TEST碰撞卐Operator.bl_idname,text_ctxt='',translate=True,icon='NONE',emboss=True,icon_value=0);
        uil.operator(operator=卐画画法线卐Operator.bl_idname,text_ctxt='',translate=True,icon='GREASEPENCIL',emboss=True,icon_value=0).bp是colli=True; 
        
        #----时间-------------------------------------------------------------------
        uil行 = layout.row(align=True );
        uil行.prop(data=self,property="ip停止时间",text='stopTIME',text_ctxt='',translate=True,icon='PAUSE',expand=False,slider=False,toggle=False,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);
        if(self.ip停止时间==0): uil行.active=False;
        else: uil行.active=True;
        layout.prop(self, "ip节点时间", text = "TIME",slider=False);


        
D目录={"NodeCategory":["IMDJS_NodeCategoryPHYSICS","PHYSICS"]};
Ls条项=[卐模拟布料卐IMDJS_NODES.bl_idname];

#////end///////////////////////////////////////////













