import bpy,math,os,sys

from bpy.types import NodeTree, Node
from bpy.props import*
from mathutils import*


#if("function_node" in locals()):imp.reload(function_node);
#if(文件夹此mod+".function_node" not in locals()):

try:
    import PYLIB.global_var as LIB;
except:
    from ..PYLIB.PYLIB_main import LIB;

try:
    from PYLIB.PYLIB_attribute import dllΔΔ载入dllLIB,dllΔΔ卸载dllLIB;
except:
    from ..PYLIB.PYLIB_attribute import dllΔΔ载入dllLIB,dllΔΔ卸载dllLIB;

from ..function_node import *
from .IMDJS_tree import 卐颜色接口卐NodeSocket,卐IMDJS_nodes,卐IMDJS_NODES,卐IMDJS_NODES_PSR ;

from ..operator_node import *;
from .IMDJS_motion import 卐INSERT前面一个节点卐Operator;
#//////////////////////////////////////////////
class 卐设置ShapeKey卐IMDJS_NODES(Node, 卐IMDJS_NODES):
    bl_idname = "IMDJS_NodeSetSK"
    bl_label = 'set ShapeKey'
    #bl_icon = 'FORCE_VORTEX'

    sp物名 = StringProperty(default="");
    spSK名1 = StringProperty(default="");
    spSK名2 = StringProperty(default="");
    spSK名3 = StringProperty(default="");
    #o=bpy.context.active_object;
    #ip循环结束时刻 =None;
    bp有物=BoolProperty(default=False);

    def init(self, context):
        self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"INPUT");
        self.inputs.new("NodeSocketFloatFactor","SK_VALUE") ;
        #self.inputs.new("NodeSocketInt","NUM_CYCLE");
        #self.inputs.new("NodeSocketInt","NUM_INTERVAL");
        self.outputs.new(卐颜色接口卐NodeSocket.bl_idname,"OUTPUT");

    def Δ升级节点(self,nt,n开始,o群父,o,i物序,i延时):
        if(bΔΔ是禁用节点(nt,self,o群父,o,i延时) ):return ;
        ns输入=self.inputs["INPUT"]
        ns输入.ip接口开始时刻 = ns输入.links[0].from_socket.ip接口开始时刻;
        Lastnode = ns输入.links[0].from_node;

        float = self.inputs["SK_VALUE"];
        if (len(float.links) > 0):#有连接
            n节点前面 = float.links[0].from_node;
            if (n节点前面.sp节点类型 == "BREAK"):
                n节点前面.Δ升级节点();
            float.default_value = float.links[0].from_socket.default_value;#把对方的值 赋予自己

        ns下一个=self.outputs["OUTPUT"];

        if(self.ip节点时间==0):
            self.ip节点时间=100000;
        ns下一个.ip接口开始时刻 = ns输入.ip接口开始时刻 + self.ip节点时间;#决定 本节点结束时间
        #self.ip循环结束时刻 = ns输入.ip接口开始时刻 + self.ip节点时间;#决定 本节点结束时间

        if (G.Li当前帧GG[0]> ns输入.ip接口开始时刻 and G.Li当前帧GG[0]<=ns下一个.ip接口开始时刻 ):#在本节点时间内
            #print("UNDATE SK",G.Li当前帧GG[0],ns输入.ip接口开始时刻);
            #----变化一个SK------------------------------------------------------------
            if (self.spSK名1 and not self.spSK名2):
                o.data.shape_keys.key_blocks[self.spSK名1].value = float.default_value;
            #----变化多个SK------------------------------------------------------------
            elif (self.spSK名1 and  self.spSK名2 and not self.spSK名3 and  not float.links ):
                f一半时间=self.ip节点时间/2;
                i当前节点时间=(G.Li当前帧GG[0]-ns输入.ip接口开始时刻 );

                if(i当前节点时间>f一半时间):
                    i当前节点时间=f一半时间-(i当前节点时间-f一半时间);
                f当前Ξ本节点时间=i当前节点时间/f一半时间;
                o.data.shape_keys.key_blocks[self.spSK名1].value = f当前Ξ本节点时间;
                o.data.shape_keys.key_blocks[self.spSK名2].value = 1-f当前Ξ本节点时间;

            elif (self.spSK名1 and  self.spSK名2  and  self.spSK名3 and not float.links ):#spSK名1为基础SK
                f三分一时间=self.ip节点时间/3;
                i当前节点时间=(G.Li当前帧GG[0]-ns输入.ip接口开始时刻 );

                if(i当前节点时间<f三分一时间):
                    f当前Ξ本节点时间=i当前节点时间/f三分一时间;#三分一时间时为最大值
                    o.data.shape_keys.key_blocks[self.spSK名2].value = f当前Ξ本节点时间;#升
                    if(o.data.shape_keys.key_blocks[self.spSK名3].value>0):
                        o.data.shape_keys.key_blocks[self.spSK名3].value=0;
                    #print("A",f当前Ξ本节点时间);
                elif(i当前节点时间>=f三分一时间 and i当前节点时间<f三分一时间*2):#在中间
                    i当前节点时间=i当前节点时间-f三分一时间;
                    f当前Ξ本节点时间=i当前节点时间/f三分一时间;
                    o.data.shape_keys.key_blocks[self.spSK名2].value =1- f当前Ξ本节点时间;#降
                    o.data.shape_keys.key_blocks[self.spSK名3].value = f当前Ξ本节点时间;#升
                    #print("B",f当前Ξ本节点时间);
                elif(i当前节点时间>=f三分一时间*2):
                    i当前节点时间=i当前节点时间-f三分一时间*2;
                    f当前Ξ本节点时间=i当前节点时间/f三分一时间;
                    o.data.shape_keys.key_blocks[self.spSK名3].value = 1-f当前Ξ本节点时间;#降
                    if(o.data.shape_keys.key_blocks[self.spSK名2].value>0):
                        o.data.shape_keys.key_blocks[self.spSK名2].value=0;
                    #print("C",f当前Ξ本节点时间);
                #☐☐☐☐☐3分1时间☐☐☐☐☐☐☐☐
                #☐☐━━━━╋━━━━╋━━━━━━→☐时间增加方向☐
                #☐☐☐☐☐☐┃☐☐☐☐┃☐☐
                #☐☐☐☐☐/┃\☐☐/┃\☐☐☐☐
                #☐☐☐☐/☐┃☐\/☐┃☐\☐☐☐☐
                #☐☐☐/☐☐┃☐/\☐┃☐☐\☐☐☐
                #☐☐/☐☐☐┃/☐☐↘┃☐☐☐↘☐☐☐
                #spSK名2☐spSK名3☐☐☐☐☐☐☐☐

        #----如果有下一个节点 并且时间已过本节点时间  就升级它------------------------------------------------------------
        else:
            if(len(ns下一个.links) > 0):
                if (G.Li当前帧GG[0]>= ns下一个.ip接口开始时刻):
                    for link in ns下一个.links:
                        link.to_node.Δ升级节点(nt,n开始,o群父,o,i物序,i延时);

    # Additional buttons displayed on the node.
    def draw_buttons(self, context, layout):
        layout.prop_search(self, "sp物名",  context.scene, "objects", text="", icon = "OBJECT_DATA");#把context.scene.objects[某个].name  赋予self.sp物名
        if(self.sp物名):
            layout.prop_search(self, "spSK名1",  context.scene.objects[self.sp物名].data.shape_keys, "key_blocks", text="", icon = "SHAPEKEY_DATA");#把key_blocks[某个].name 赋予self.spSK名1
            if(self.spSK名1):
                layout.prop_search(self, "spSK名2",  context.scene.objects[self.sp物名].data.shape_keys, "key_blocks", text="", icon = "SHAPEKEY_DATA");
                if(self.spSK名2):
                    layout.prop_search(self, "spSK名3",  context.scene.objects[self.sp物名].data.shape_keys, "key_blocks", text="", icon = "SHAPEKEY_DATA");
        pass

        
#////////////////////////////////////////////////
class 卐REASSIGN_SK卐Operator(bpy.types.Operator):
    bl_idname = "op.reassign_shapekey";
    bl_label = "reassign_shapekey";
    bl_description= "reassign the shapekey of active object and store in the node  if the curve point is changed"
    bl_options={'UNDO'};
    bl_context='object';

    sp=StringProperty(name="note!", description="", default="are you sure reassign the SK of active object?");
    o=None;
    fp检测距离阈值=FloatProperty(name='',description='factor of distance to be detected',default=0.01,min=0.001,max=1.0,step=3,precision=3,subtype='NONE',unit='NONE',update=None,get=None,set=None);
    #--------------------------------------------------------------------------
    def draw(self, context):
        self.layout.prop(self, "sp");
        self.layout.prop(self, "fp检测距离阈值",text="factor of distance");
    def invoke(self, context, event):
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();

        self.nThis=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        self.n群组=nΔΔ找到群组节点( self.nThis);
        if(self.n群组):
            #for s物 in self.n群组.cp群组物体.keys():
            s物=self.n群组.cp群组物体[self.n群组.ip激活群组物体ξ].name;
            if(s物 in G.Ds物oGG):
                self.o=G.Ds物oGG[s物];

        return context.window_manager.invoke_props_dialog(self,300,50);#召唤

    def execute(self, context):
        #self.o=context.active_object;
        if(self.o==None):
            self.report({"ERROR"},"no object  is in the list");#"INFO" "ERROR" "DEBUG" "WARNING"
            return {"FINISHED"};
        if( self.nThis ):
            try:
                self.o["SHAPEKEY"];
            except:
                self.o["SHAPEKEY"]={};
            try:
                self.o["SHAPEKEY"][self.o.type];
            except:
                self.o["SHAPEKEY"][self.o.type]={};
            try:
                self.o["SHAPEKEY"][self.o.type][ self.nThis.name];
            except:
                self.report({"ERROR"},"there is no shapekey data is stored in this node!!!");#"INFO" "ERROR" "DEBUG" "WARNING"
                return {"FINISHED"};
            #self.o["SHAPEKEY"][self.o.type][ self.nThis.name]=[];#self.o.type:{s本节点名:[v,v,...]  }

            #----记录点位置-------------------------------------------------------------
            if(context.active_object.mode!="OBJECT"):
                bpy.ops.object.mode_set(mode="OBJECT");
            id=self.o.data;key=id.shape_keys;L点序f3Now=[];
            if(self.o.type ==self.o.type):
                #Lspmv=[sp   for sp in  id.splines[0].points];#●●假设只有一个样条
                if(not key ):
                    self.o.shape_key_add(name="base", from_mix=True);
                    self.o.shape_key_add(name="key1", from_mix=True);

                elif(len(key.key_blocks)==1):
                    self.o.shape_key_add(name="key1", from_mix=True);

                #self.o.active_shape_key_index=1;
                #if(self.o.active_shape_key.value!=1):self.o.active_shape_key.value=1;

                if(self.o.data.shape_keys .use_relative==False):
                    self.o.data.shape_keys .use_relative=True;

                skA=self.o.active_shape_key;
                if(self.o.active_shape_key_index!=0):
                    if(skA.value!=1.0):
                        skA.value=1.0;
                dt=skA.data;L点序f3旧=self.o["SHAPEKEY"][self.o.type][ self.nThis.name];
                i长dt=len(dt);
                #Lsk=key.key_blocks;
                #----新旧差别--------------------------------------------------------------
                Diξ新iξ旧={};#[[iξ新点,iξ旧],[iξ新点,iξ旧],...]
                Diξ新点f左Ξ右={};#新点索
                Diξ新点v新点位ι={};
                Diξ新点Lξi左i右={};
                for iξ新点,skp in enumerate(dt):
                    L点序f3Now.append([skp.co.x,skp.co.y,skp.co.z]);#[[x,y,z],[x,y,z],...]
                    iξ最近旧=iΔΔ找最近一个元素LIB(skp.co,L点序f3旧,self.fp检测距离阈值);
                    if(iξ最近旧!=-1):#如果没找到就保留原点位
                        Diξ新iξ旧[iξ新点]=iξ最近旧;
                    else:
                        Diξ新点f左Ξ右[iξ新点]=-1.0;
                #----多出来的新点--------------------------------------------------------
                #for iξ新点 in  Diξ新点f左Ξ右:
                for iξ新点,skp in enumerate(dt):
                    i左ξ=None;i右ξ=None;
                    if(iξ新点 not in Diξ新iξ旧):
                        i左ξ=iξ新点-1;
                        while(i左ξ not in Diξ新iξ旧):
                            if(0<=i左ξ):
                                i左ξ-=1;
                            else:
                                i左ξ=None;
                                break;
                            #print("new vert",iξ新点);

                        i右ξ=iξ新点+1;
                        while(i右ξ not in Diξ新iξ旧):
                            if(i右ξ<i长dt):
                                i右ξ+=1;
                            else:
                                i右ξ=None;
                                break;

                        Diξ新点Lξi左i右[iξ新点]=[i左ξ,i右ξ];
                #----Diξ新点v新点位ι-----------------------------------------------------------
                for iξ新点 in  Diξ新点f左Ξ右:
                    i左ξ,i右ξ=Diξ新点Lξi左i右[iξ新点];
                    if(i左ξ!=None  and i右ξ!=None ):
                        print("LR",i左ξ,i右ξ,i长dt);
                        f总长=f长__f3乛f3(dt[i左ξ].co,dt[i右ξ].co);
                        Diξ新点f左Ξ右[iξ新点]=f长__f3乛f3(dt[i左ξ].co,dt[iξ新点].co)/f总长;
                    elif(i左ξ!=None and  i右ξ==None):
                        Diξ新点v新点位ι[iξ新点]=v__f3一f3(dt[iξ新点].co,dt[i左ξ].co);
                    elif(i右ξ!=None and  i左ξ==None):
                        Diξ新点v新点位ι[iξ新点]=v__f3一f3(dt[iξ新点].co,dt[i右ξ].co);

                #旧    [0][1][2][3]☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
                #新    [2][1][0][4][3]☐☐☐☐☐☐☐☐☐☐☐☐☐
                #☐☐Χ☐☐Χ  Χ  new☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
                #记旧[0][1][2][3]☐☐☐☐☐☐☐☐☐☐☐☐☐
                #记新[2][1][0][4][3]☐☐☐☐☐☐☐☐☐☐☐☐☐☐
                #记新[0][1][2][3][4]

                def Δ重写点位(dt,n):
                    L点序f3新=[];L点序f3旧=self.o["SHAPEKEY"][self.o.type][n.name];
                    ii长旧=len(L点序f3旧);i长dt=len(dt);
                    if(i长dt==ii长旧):
                        self.report({"ERROR"},"the num of points doesn't change you don't need to reassign !!! %s"%(self.name));#"INFO" "ERROR" "DEBUG" "WARNING"
                        return ;
                    for iξ新点,skp in enumerate(dt):
                        if(iξ新点 in Diξ新iξ旧):
                            print("idx new",Diξ新iξ旧 ,iξ新点,ii长旧,);
                            L点序f3新.append(  L点序f3旧[  Diξ新iξ旧[iξ新点]  ]  );#把旧的记到新位置.●●有可能部分节点没有重写而记录长度不同
                        else:
                            i左ξ,i右ξ=Diξ新点Lξi左i右[iξ新点];
                            #----多出来的新点--------------------------------------------------------
                            if(i左ξ!=None and i右ξ!=None ):
                                v右乛左offset=v__f3一f3(L点序f3旧[Diξ新iξ旧[i右ξ] ] ,L点序f3旧[Diξ新iξ旧[i左ξ] ] )*Diξ新点f左Ξ右[iξ新点];
                                f3新位real=f3__f3十f3(L点序f3旧[Diξ新iξ旧[i左ξ] ],v右乛左offset);
                            elif(i左ξ!=None and i右ξ==None):
                                f3新位real=f3__f3十f3(L点序f3旧[Diξ新iξ旧[i左ξ] ],Diξ新点v新点位ι[iξ新点]);
                            elif(i右ξ!=None and i左ξ==None):
                                f3新位real=f3__f3十f3(L点序f3旧[Diξ新iξ旧[i右ξ] ],Diξ新点v新点位ι[iξ新点]);

                            L点序f3新.append(f3新位real);#增加一个记录

                    self.o["SHAPEKEY"][self.o.type][n.name]=L点序f3新;
                #----重写-----------------------------------------------------------------
                i重写个数=1;
                Δ重写点位(dt, self.nThis);
                for link in self.nThis.outputs["OUTPUT"].links:
                    n下一个=link.to_node;
                    while(n下一个):
                        if(n下一个.bl_idname=="IMDJS_CurveSK"):
                            Δ重写点位(dt,n下一个);
                            i重写个数+=1;
                            if(n下一个.outputs["OUTPUT"].links):
                                n下一个=n下一个.outputs["OUTPUT"].links[0].to_node;
                            else:
                                n下一个=None;
                        else:
                            n下一个=None;

                self.report({"ERROR"},"重写了 %d 个节点"%(i重写个数));#"INFO" "ERROR" "DEBUG" "WARNING"
        return {"FINISHED"};
        pass

#////////////////////////////////////////////////
class 卐PICK_SK卐Operator(bpy.types.Operator):
    bl_idname = "op.pick_shapekey";
    bl_label = "pick_shapekey";
    bl_description= "get the shapekey of active object and store in the node (act like key frame recording)"
    bl_options={'UNDO'};
    bl_context='object';

    sp=StringProperty(name="note!", description="", default="are you sure get the SK of active object?");
    o=None;
    #--------------------------------------------------------------------------
    def draw(self, context):    self.layout.prop(self, "sp");

    def invoke(self, context, event):
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();

        self.nThis=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        self.n群组=nΔΔ找到群组节点( self.nThis);
        if(self.n群组):
            
            print("GROUP==",self.n群组,self.n群组.sp激活预置名,self.n群组.ip激活群组物体ξ,);
            #for s物 in self.n群组.cp群组物体.keys():
            s物=self.n群组.cp群组物体[self.n群组.ip激活群组物体ξ].name;
            if(s物 in G.Ds物oGG):
                self.o=G.Ds物oGG[s物];
                print("FIND o==",self.o);

        return context.window_manager.invoke_props_dialog(self,300,50);#召唤

    def execute(self, context):
        #self.o=context.active_object;

        if(self.o==None):
            self.report({"ERROR"},"no object  is in the list");#"INFO" "ERROR" "DEBUG" "WARNING"
            return {"FINISHED"};
        if( self.nThis ):
            try:
                self.o["SHAPEKEY"];
            except:
                self.o["SHAPEKEY"]={};
            try:
                self.o["SHAPEKEY"][self.o.type];
            except:
                self.o["SHAPEKEY"][self.o.type]={};
            try:
                self.o["SHAPEKEY"][self.o.type][ self.nThis.name];
            except:
                self.o["SHAPEKEY"][self.o.type][ self.nThis.name]=[];#self.o.type:{s本节点名:[v,v,...]  }

            #----记录点位置-------------------------------------------------------------
            if(context.active_object.mode!="OBJECT"):
                bpy.ops.object.mode_set(mode="OBJECT");
            id=self.o.data;key=id.shape_keys;L点序f3=[];
            if(self.o.type ==self.o.type):
                #Lspmv=[sp   for sp in  id.splines[0].points];#●●假设只有一个样条
                if(not key ):
                    self.o.shape_key_add(name="base", from_mix=True);
                    self.o.shape_key_add(name="animation", from_mix=True);

                elif(len(key.key_blocks)==1):
                    self.o.shape_key_add(name="animation", from_mix=True);

                #if(self.o.active_shape_key.value!=1):self.o.active_shape_key.value=1;

                if(self.o.data.shape_keys .use_relative==False):
                    self.o.data.shape_keys .use_relative=True;
                #--------------------------------------------------------------------------
                skA=self.o.active_shape_key;
                if(not skA):
                    self.o.active_shape_key_index=0;
                    skA=self.o.active_shape_key;                    
                dt=skA.data;
                #Lsk=key.key_blocks;
                for skp in dt:
                    L点序f3.append([skp.co.x,skp.co.y,skp.co.z]);#[[x,y,z],[x,y,z],...]

                    """
                   for sp in  id.splines[0].points:
                        L点序f3.append([sp.co.x,sp.co.y,sp.co.z]);
                    """
                self.o["SHAPEKEY"][self.o.type][ self.nThis.name]=L点序f3;
                print("Lf3 save==",L点序f3,len(dt));
                self.o.active_shape_key_index=1;
                skA=self.o.active_shape_key;
                if(skA.value!=1.0):
                    skA.value=1.0;
                    
        return {"FINISHED"};

 #//////////////////////////////////////////////
def ΔAPPLYCurveSK(self,o):
    i点数now=len(o.active_shape_key.data);
    try:
        if(i点数now!=len( o["SHAPEKEY"][self.o.type][self.name]) ):
            sΔΔ节点出错变色(self,b出错条件=True,s打印="the number of point has been changed!!!");
            return ;            
    except:pass#print("ERROR SK",self.name);
    LIB.dllIMDJS.ΔΔShapeKey插值(i点数now,2,1,1,self.ip指数,False,c_wchar_p(self.name),c_wchar_p(self.name),c_void_p(o.as_pointer()) );
    
#////////////////////////////////////////////////
class 卐TEST卐Operator(bpy.types.Operator):
    bl_idname = "op.test_sk";
    bl_label = "test_sk";
    bl_description= "get the PSR of active object and store in the node (act like key frame recording)"
    bl_context='object';
    
    o=None;
    def invoke(self, context, event):
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();

        self.nThis=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        self.n群组=nΔΔ找到群组节点( self.nThis);
        if(self.n群组):
            print("GROUP==",self.n群组,self.n群组.sp激活预置名,self.n群组.ip激活群组物体ξ,);
            #for s物 in self.n群组.cp群组物体.keys():
            s物=self.n群组.cp群组物体[self.n群组.ip激活群组物体ξ].name;
            if(s物 in G.Ds物oGG):
                self.o=G.Ds物oGG[s物];
                print("FIND o==",self.o);

        #return context.window_manager.invoke_props_dialog(self,300,50);#召唤
        return  self.execute(context);
        
    def execute(self, context):
        try:
            self.o["SHAPEKEY"][self.o.type][ self.nThis.name];
        except:
            return {"FINISHED"};
        
        print("len==",len(self.o["SHAPEKEY"][self.o.type][ self.nThis.name]));
        for L in self.o["SHAPEKEY"][self.o.type][ self.nThis.name]:
            ΔΔ打印vLIB("L",L);
            
            
        return {"FINISHED"};

class 卐动画CurveSK卐IMDJS_NODES(Node, 卐IMDJS_NODES_PSR):
    bl_idname = "IMDJS_CurveSK"
    bl_label = '♂ShapeKey'
    #bl_icon = 'FORCE_VORTEX'

    sp物名 = StringProperty(default="");
    spSK名1 = StringProperty(default="");
    spSK名2 = StringProperty(default="");
    spSK名3 = StringProperty(default="");
    #o=bpy.context.active_object;
    #ip循环结束时刻 =None;
    bp有物=BoolProperty(default=False);

    def init(self, context):
        卐IMDJS_NODES_PSR. init(self, context);

    def Δ升级节点(self,nt,n开始,o群父,o,i物序,i延时):
        n节点前面,i运动时刻end,i超出时间,i本节点开始时刻,ns本节点input,b是禁用节点=self.Δ检查时间(nt,n开始,o群父,o,i延时);
        #return ;
        i实际帧=self.ip实际帧+i延时;
        #====在本节点时间内==============================================
        if (i超出时间>0 and G.Li当前帧GG[0] <=i实际帧):
            #----前面传来值------------------------------------------------------------
            #n节点前面 = ns本节点input.links[0].from_node;
            if(o.active_shape_key_index==0):#不能改变基础SK
                o.active_shape_key_index=1;
            if(LIB.dllIMDJS==None):LIB.dllIMDJS=dllΔΔ载入dllLIB(LIB,"dllIMDJS",CLIB,CLIB64);
            cb刷新=(c_bool*1)(G.Lb是要刷新GG[0]);

            i点数now=len(o.active_shape_key.data);
            try:
                if(i点数now!=len( o["SHAPEKEY"][o.type][self.name]) ):
                    sΔΔ节点出错变色(self,b出错条件=True,s打印="the number of point has been changed!!!");
                    return ;            
            except:
                #pass;
                if(self.name!=self.label):
                    self.label=self.name;
                print("ERROR SK",self.name);    


            if(n节点前面.bl_idname!="IMDJS_NodeStart"):
                #====本节点时间内===================================================
                if (G.Li当前帧GG[0] <= i运动时刻end):
                    if(b是禁用节点==False and self.bp是循环==False):
                        #LIB.dllIMDJS.ΔΔ节点渐变色(c_void_p(bpy.context.screen.as_pointer()),c_void_p(self.as_pointer()),c_float(i超出时间),c_float(self.ip节点时间 ),False,cb刷新);
                        G.Lb是要刷新GG[0]=cb刷新[0];
                    try:
                        o["SHAPEKEY"][o.type][self.name];
                    except:
                        print("it's not record shapekey yet!!!",self.name);
                        if(self.name!=self.label):self.label=self.name;
                        
                        return ;
                    #----插值-----------------------------------------------------------------
                    #ΔΔPSR插值( o, scene,self.ip节点时间, i本节点开始时刻,  i运动时刻end,Lv开始shape, f3最大值Scale, self.ip指数, "S");

                    LIB.dllIMDJS.ΔΔShapeKey插值(i点数now,G.Li当前帧GG[0],self.ip节点时间,i本节点开始时刻,self.ip指数,b是禁用节点,c_wchar_p(n节点前面.name),c_wchar_p(self.name),c_void_p(o.as_pointer()) );
                    #print("exe",);
                    #self.outputs["RESULT_SCALE"].default_value= cf3结果;
                #----停止时刻----------------------------------------------------------------
                if(G.Li当前帧GG[0] > i运动时刻end and G.Li当前帧GG[0] <=i实际帧):
                    #pass;
                    LIB.dllIMDJS.ΔΔShapeKey插值(len(o.active_shape_key.data),self.ip节点时间+i本节点开始时刻,self.ip节点时间,i本节点开始时刻,self.ip指数,b是禁用节点,c_wchar_p(n节点前面.name),c_wchar_p(self.name),c_void_p(o.as_pointer()) );
            #----第一个节点-------------------------------------------------------------
            else:
                for i,sk in enumerate(o.data.shape_keys.key_blocks):
                    if(i==1):
                        if(sk.value!=1):
                            sk.value=1;
                        if(sk.mute):
                            sk.mute=False;
                        continue;
                    if(sk.value>0):
                        sk.value=0;

                LIB.dllIMDJS.ΔΔShapeKey插值(i点数now,G.Li当前帧GG[0],self.ip节点时间,i本节点开始时刻,self.ip指数,b是禁用节点,c_wchar_p(self.name),c_wchar_p(self.name),c_void_p(o.as_pointer()) );
                #print("IS FIRST ",self.name);

        #====超出节点运动时间===============================================
        if (G.Li当前帧GG[0] > i运动时刻end):
            if (G.Li当前帧GG[0] <i运动时刻end+2):#快结束前
                #----把值传给自己的下个接口万一禁用也可以传递--------------------------------------
                """
                #n节点前面 = ns本节点input.links[0].from_node;
                if (n节点前面.bl_idname == "IMDJS_NodeStart"):
                    self.cp物序此节点关键帧记录[self.name].fvp3loc= pg初始.fvp3loc;
                    self.cp物序此节点关键帧记录[self.name].fvp3euler= pg初始.fvp3euler;
                    self.cp物序此节点关键帧记录[self.name].fvp4q= pg初始.fvp4q;
                    self.cp物序此节点关键帧记录[self.name].fvp3scale= pg初始.fvp3scale;
                else:
                    self.cp物序此节点关键帧记录[self.name].fvp3loc=n节点前面.cp物序此节点关键帧记录[self.name].fvp3loc;
                    self.cp物序此节点关键帧记录[self.name].fvp3euler=n节点前面.cp物序此节点关键帧记录[self.name].fvp3euler;
                    self.cp物序此节点关键帧记录[self.name].fvp4q=n节点前面.cp物序此节点关键帧记录[self.name].fvp4q;
                    self.cp物序此节点关键帧记录[self.name].fvp3scale=n节点前面.cp物序此节点关键帧记录.scale;
                    
                n节点前面.ip从开始第几个节点=self.ip从开始第几个节点;
                """
            #----超出节点-----------------------------------------------------------
            if (G.Li当前帧GG[0] >i实际帧):
                if(LIB.dllIMDJS==None):LIB.dllIMDJS=dllΔΔ载入dllLIB(LIB,"dllIMDJS",CLIB,CLIB64);
                #LIB.dllIMDJS.ΔΔ节点渐变色(c_void_p(bpy.context.screen.as_pointer()),c_void_p(self.as_pointer()),c_float(),c_float(),True,(c_bool*1)(G.Lb是要刷新GG[0]));
                for link in self.outputs["OUTPUT"].links:
                    if(link.to_socket.identifier!="INPUT"):continue;
                    link.to_node.Δ升级节点(nt,n开始,o群父,o,i物序,i延时);

    #====LAYOUT=====================================================
    def draw_buttons(self, context, layout):
        uil行=layout.row(align=True);
        uil行.prop(self, "ip实际帧", text = "C");
        uil行.enabled=False;

        uil行=layout.row(align=True);
        uil行.prop(self, "ip指数", text = "pow");
        #uil行.prop(self, "sp影响", text = "influence");
        #uil行.prop(self, "bp相对", text = "Relative",toggle=True);

        uil行=layout.row(align=False);
        uil行.operator(operator=卐PICK_SK卐Operator.bl_idname,text='pick SHAPE',text_ctxt='',translate=True,icon='REC',emboss=True,icon_value=0);#OP.sp类型="SHAPE";
        uil行.operator(operator=卐GOTO本节点尾卐Operator.bl_idname,text='GO',text_ctxt='',translate=True,icon='LOOP_FORWARDS',emboss=True,icon_value=0);
        uil行=layout.row(align=False).split(percentage=0.3, align=False);
        uil行.operator(operator=卐INSERT前面一个节点卐Operator.bl_idname,text='insert node',text_ctxt='',translate=True,icon='NODE_INSERT_OFF',emboss=True,icon_value=0);
        uil行.operator(operator=卐PICK_TIME卐Operator.bl_idname,text='pick_time',text_ctxt='',translate=True,icon='EYEDROPPER',emboss=True,icon_value=0);

        #--------------------------------------------------------------------------
        uil行 = layout.row(align=True );
        uil行.operator(卐画画选卐Operator.bl_idname, text='显', icon='GREASEPENCIL');
        uil行.operator(卐选择群组物体卐Operator.bl_idname, text='选', icon='RESTRICT_SELECT_OFF').bp是选=True;
        uil行.operator(卐选择群组物体卐Operator.bl_idname, text='反', icon='VISIBLE_IPO_OFF').bp是选=False;

        uil行=layout.row(align=False);
        uil行.operator(operator=卐REASSIGN_SK卐Operator.bl_idname,text='reassign_sk',text_ctxt='',translate=True,icon='FORWARD',emboss=True,icon_value=0);
        uil行.operator(operator=卐TEST卐Operator.bl_idname,text='TEST',text_ctxt='',translate=True,icon='NONE',emboss=True,icon_value=0);        
        #----时间-------------------------------------------------------------------
        uil行 = layout.row(align=True );
        uil行.prop(data=self,property="ip停止时间",text='stopTIME',text_ctxt='',translate=True,icon='PAUSE',expand=False,slider=False,toggle=False,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);
        if(self.ip停止时间==0): uil行.active=False;
        else: uil行.active=True;
        layout.prop(self, "ip节点时间", text = "TIME",slider=False);

    def draw_buttons_ext(self, context, layout):
        pass;

#//////////////////////////////////////////////////
class 卐设置UV卐IMDJS_NODES(Node, 卐IMDJS_NODES):
    bl_idname = "IMDJS_NodeAniUV"
    bl_label = 'set UV'
    #bl_icon = 'FORCE_VORTEX'


    sp物名 = StringProperty(default="");
    spUV名1 = StringProperty(default="");
    spUV名2 = StringProperty(default="");
    spUV名3 = StringProperty(default="");
    #o=bpy.context.active_object;
    #ip循环结束时刻 =None;
    bp有物=BoolProperty(default=False);

    def init(self, context):
        #self.b使用回放颜色 = False;


        self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"INPUT");
        self.inputs.new("NodeSocketFloatFactor","F_UV") ;
        #self.inputs.new("NodeSocketInt","NUM_CYCLE");
        #self.inputs.new("NodeSocketInt","NUM_INTERVAL");


        self.outputs.new(卐颜色接口卐NodeSocket.bl_idname,"OUTPUT");

    def Δ升级节点(self,nt,n开始,o群父,o,i物序,i延时):
        print("UPDATE",);
        if(bΔΔ是禁用节点(nt,self,o群父,o,i延时) ):return ;
        ns输入=self.inputs["INPUT"]
        ns输入.ip接口开始时刻 = ns输入.links[0].from_socket.ip接口开始时刻;
        Lastnode = ns输入.links[0].from_node;

        float = self.inputs["F_UV"];
        if (len(float.links) > 0):#有连接
            n节点前面 = float.links[0].from_node;
            if (n节点前面.sp节点类型 == "BREAK"):
                n节点前面.Δ升级节点();
            float.default_value = float.links[0].from_socket.default_value;#把对方的值 赋予自己

        ns下一个=self.outputs["OUTPUT"];

        
        ns下一个.ip接口开始时刻 = ns输入.ip接口开始时刻 + self.ip节点时间;#决定 本节点结束时间
        #self.ip循环结束时刻 = ns输入.ip接口开始时刻 + self.ip节点时间;#决定 本节点结束时间
        #====在本节点时间内==============================================
        #print("",G.Li当前帧GG[0]);
        if (G.Li当前帧GG[0]> ns输入.ip接口开始时刻 and G.Li当前帧GG[0]<=ns下一个.ip接口开始时刻 ):
            #----一个UV不能变化------------------------------------------------------------
            if (self.spUV名1 and not self.spUV名2):
                print("ONLY 1 UV",);
                return ;
            #----变化多个UV------------------------------------------------------------
            elif (self.spUV名1 and  self.spUV名2 and not self.spUV名3 and  not float.links ):#两个UV
                #f一半时间=self.ip节点时间/2;
                i当前节点时间=(G.Li当前帧GG[0]-ns输入.ip接口开始时刻 );
                bpy.ops.object.mode_set(mode='OBJECT');
                #if(i当前节点时间>f一半时间):
                    #i当前节点时间=f一半时间-(i当前节点时间-f一半时间);
                f当前Ξ本节点时间=i当前节点时间/self.ip节点时间;
                Cmuvl1=o.data.uv_layers[self.spUV名1].data;
                Cmuvl2=o.data.uv_layers[self.spUV名2].data;
                id=o.data;
                if("UV_ani" not in o.data.uv_layers):
                    bpy.ops.mesh.uv_texture_add();
                    Cmuvl动画=id.uv_layers.active.data;
                    print("UV NAME==",id.uv_layers.active.name);
                    id.uv_layers.active.name="UV_ani";
                else:
                    Cmuvl动画=id.uv_layers["UV_ani"].data;

                if(id.uv_textures["UV_ani"].active_render==False):
                    id.uv_textures["UV_ani"].active_render=True;

                for i环,muvl动画 in enumerate(Cmuvl动画):

                    muvl动画.uv=Cmuvl1[i环].uv+(Cmuvl2[i环].uv-Cmuvl1[i环].uv)*f当前Ξ本节点时间;
                    print("SET UV==",f当前Ξ本节点时间,muvl动画.uv,len(Cmuvl动画));

                bpy.ops.object.mode_set(mode='EDIT');
                #----动画uv----------------------------------------------------------------


                    #print("C",f当前Ξ本节点时间);
                #☐☐☐☐☐3分1时间☐☐☐☐☐☐☐☐
                #☐☐━━━━╋━━━━╋━━━━━━→☐时间增加方向☐
                #☐☐☐☐☐☐┃☐☐☐☐┃☐☐
                #☐☐☐☐☐/┃\☐☐/┃\☐☐☐☐
                #☐☐☐☐/☐┃☐\/☐┃☐\☐☐☐☐
                #☐☐☐/☐☐┃☐/\☐┃☐☐\☐☐☐
                #☐☐/☐☐☐┃/☐☐↘┃☐☐☐↘☐☐☐
                #spUV名2☐spUV名3☐☐☐☐☐☐☐☐

        #----如果有下一个节点 并且时间已过本节点时间  就升级它------------------------------------------------------------
        else:
            if(len(ns下一个.links) > 0):
                if (G.Li当前帧GG[0]>= ns下一个.ip接口开始时刻):
                    for link in ns下一个.links:
                        link.to_node.Δ升级节点(nt,n开始,o群父,o,i物序,i延时);

    def draw_buttons(self, context, layout):
        layout.prop_search(self, "sp物名",  context.scene, "objects", text="", icon = "OBJECT_DATA");#把context.scene.objects[某个].name  赋予self.sp物名
        if(self.sp物名):
            layout.prop_search(self, "spUV名1",  context.scene.objects[self.sp物名].data, "uv_layers", text="", icon = "GROUP_UVS");#把key_blocks[某个].name 赋予self.spUV名1
            if(self.spUV名1):
                layout.prop_search(self, "spUV名2",  context.scene.objects[self.sp物名].data, "uv_layers", text="", icon = "GROUP_UVS");
                if(self.spUV名2):
                    layout.prop_search(self, "spUV名3",  context.scene.objects[self.sp物名].data, "uv_layers", text="", icon = "GROUP_UVS");



#//////////////////////////////////////////////////
class 卐设置灯光halo卐IMDJS_NODES(Node, 卐IMDJS_NODES):
    bl_idname = "IMDJS_NodeSetHalo"
    bl_label = 'set halo'
    #bl_icon = 'FORCE_VORTEX'


    sp物名 = StringProperty(default="");
    spSK名1 = StringProperty(default="");
    #o=bpy.context.active_object;
    ip指数=IntProperty(min=1, max=16,default=5);
    bp有物=BoolProperty(default=False);

    def init(self, context):
        #self.b使用回放颜色 = False;


        self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"INPUT");
        self.inputs.new("NodeSocketFloatFactor","HALO_VALUE") ;
        self.inputs.new("NodeSocketFloatFactor","HALO_VALUE倍数");

        self.outputs.new(卐颜色接口卐NodeSocket.bl_idname,"OUTPUT");

        self.inputs["HALO_VALUE_MUL"].default_value =1.0;
    # Atualiza o valor do 下一个 com o valor Absoluto
    def Δ升级节点(self,nt,n开始,o群父,o,i物序,i延时):
        if(bΔΔ是禁用节点(nt,self,o群父,o,i延时) ):return ;
        global o镜G;
        self.ip节点时间 = self.inputs["INPUT"].links[0].from_node.ip节点时间;#从别的节点传入开始时刻
        """"""
        if(self.bp是禁用节点):
            if(not  self.use_custom_color):
                self.use_custom_color=True;
                self.color=(1.0, 0.0, 0.0);#红色
            self.ip实际帧 =self.ip节点时间 ;
            #----过了本节点时间-执行下一节点的升级-----------------------------------------------
            if(len(self.outputs["OUTPUT"].links) > 0):
                if (G.Li当前帧GG[0] >i实际帧):
                    for link in self.outputs["OUTPUT"].links:
                        link.to_node.Δ升级节点(nt,n开始,o群父,o,i物序,i延时);

        elif(not self.bp是禁用节点):
            if(self.use_custom_color ):
                self.use_custom_color=False;
        #---如果有别的连接-------------------------------------------------------------
        for s in ["HALO_VALUE","HALO_VALUE_MUL","TIME"]:
            if (len(self.inputs[s].links) > 0):#有连接
                #print("S==",s);
                n节点前面 = self.inputs[s].links[0].from_node;
                if (n节点前面.sp节点类型 == "BREAK"):
                    n节点前面.Δ升级节点();
                self.inputs[s].default_value = self.inputs[s].links[0].from_socket.default_value;#把对方的值 赋予自己

        #====在本节点时间内==============================================
        
        if(self.ip节点时间==0 and  self.ip节点时间!=100000):
            self.ip节点时间=100000;
        self.ip实际帧 = self.ip节点时间 + self.ip节点时间;#决定 本节点结束时间
        if (self.ip节点时间 ==0  or(G.Li当前帧GG[0] > self.inputs["INPUT"].ip接口开始时刻 and G.Li当前帧GG[0] <= self.ip实际帧 and self.sp物名)):
            #print("HALO",);
            if(o镜G==None):
                o镜G=scene.camera;
                if(not o镜G):
                    print("NOT FIND CAM",o镜G);return ;
            m镜=o镜matrix_world;

            if(o群父!=None):
                m光=o群父.matrix_world*o.matrix_world;#子的全局m 相当于群组的本地m
            else:
                m光=o.matrix_world;

            v镜Z=Vector((m镜[0][2],m镜[1][2],m镜[2][2]));v光Z=Vector((m光[0][2],m光[1][2],m光[2][2]));
            f夹角=v镜Z.angle(v光Z)-2.1415926;
            #print("ANGLE",f夹角);
            if(f夹角>0):
                bpy.data.lamps[self.sp物名].halo_intensity =self.inputs["HALO_VALUE"].default_value= (f夹角**self.ip指数)*self.inputs["HALO_VALUE_MUL"].default_value;
        #----过了本节点时间-执行下一节点的升级-----------------------------------------------
        if(len(self.outputs["OUTPUT"].links) > 0):
            if (G.Li当前帧GG[0] >i实际帧):
                for link in self.outputs["OUTPUT"].links:
                    if(link.to_socket.identifier!="INPUT"):continue;
                    link.to_node.Δ升级节点(nt,n开始,o群父,o,i物序,i延时);

    #==============================================================
    def draw_buttons(self, context, layout):
        layout.prop(self, "bp是禁用节点", text = "disable");
        layout.prop_search(self, "sp物名",  bpy.data, "lamps", text="", icon = "OUTLINER_OB_LAMP");#把context.scene.pp场景物体MT设定s2.cp物体组 赋予self.name
        #if(self.sp物名):
            #layout.prop_search(self, "spSK名1",  context.scene.objects[self.sp物名].data.shape_keys, "key_blocks", text="", icon = "SHAPEKEY_DATA");#把context.scene.pp场景物体MT设定s2.cp物体组 赋予self.name
        layout.prop(self, "ip指数", text = "exponent");

#////////////////////////////////////////////////
#☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
#☐☐☐☐☐☐☐┆┅┈☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
#☐☐☐☐☐☐☐│┃☐┅┈☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
#☐☐☐☐☐☐┆☐┃☐☐☐┅┈☐Z轴☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
#☐☐☐☐☐☐│/☐☐☐☐☐☐┅☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
#☐☐☐☐☐☐━━━━━━━━━━━☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
#   x,-y<-    +1L-2    +1L-1     +1L+0      +1L+1       +1L+2       ->x,y
#        -y<-      M-2           M-1       ●                  M1             M2           ->y
#-x,-y<-    -1L-2     -1L-1    -1L+0        -1L+1        -1L+2      ->-x,y
#-x,-y<-    -2L-2     -2L-1    -2L+0        -2L+1        -2L+2      ->-x,y
#                   ip一个                                                                 ip十个
class 卐设置太阳灯位置卐IMDJS_NODES(Node, 卐IMDJS_NODES):
    '''Set a "Object" sp属性 of the Object'''
    bl_idname = 'IMDJS_NodeSetSunLights'
    bl_label = 'set sun location'
    #bl_icon = 'FORCE_VORTEX'


    sp属性 = StringProperty();
    bp升级 = BoolProperty(description = "bp升级 or not the scene data. Warning High Performace Drop if enabled");
    fvp3位置x=FloatVectorProperty(name="x", description="", default=(1.0, 0.0, 0.0), subtype='NONE', size=3, update=None, get=None, set=None);
    fvp3位置y=FloatVectorProperty(name="y", description="", default=(0.0, 1.0, 0.0), subtype='NONE', size=3, update=None, get=None, set=None);
    fvp3位置z=FloatVectorProperty(name="z", description="", default=(0.0, 0.0, 1.0), subtype='NONE', size=3, update=None, get=None, set=None);

    def init(self, context):
        self.b使用回放颜色 = True
        self.sp节点类型 = ""

        self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"INPUT")


        self.outputs.new(卐颜色接口卐NodeSocket.bl_idname,"OUTPUT")

    def Δ同步参数(self,o):
        pass;



    def Δ升级节点(self,o父,o):
        if(self.bp是禁用节点 or not o.children):return ;
        #----如果在本节点时间内---------------------------------------------------------------
        ns下一个=self.outputs["OUTPUT"];
        
        if(self.ip节点时间==0 and  self.ip节点时间!=100000):
            self.ip节点时间=100000;
        ns下一个.ip接口开始时刻 = self.ip节点时间 + self.ip节点时间;#决定 本节点结束时间

        G.Li当前帧GG[0] =scene.frame_current;
        if (G.Li当前帧GG[0] > self.inputs["INPUT"].ip接口开始时刻 and G.Li当前帧GG[0] <=ns下一个.ip接口开始时刻 ):
            #----先设置初始父子位置-------------------------------------------------------------
            m父=o.matrix_world;vZ轴向单位=Vector((m父[0][2],m父[1][2],m父[2][2]));
            v父位=vΔΔm得v位LIB(m父);
            f父Z=m父[2][3];
            v位移单位x=m父*Vector(self.fvp3位置x);v位移单位y=m父*Vector(self.fvp3位置y);v位移单位z=m父*Vector(self.fvp3位置z);f壹个间隔=o.data.shadow_frustum_size*2;
            f夹角Z向=Vector((0,0,-1)).angle(vZ轴);
            for o子 in o.children:
                if(o子.name[0]=="L"):
                    v位全局真=v位移单位x*f壹个间隔+v位移单位y*eval(子.name[1:]);
                    fZ距离=v位全局真.z-f父Z;
                    f长Z轴=fZ距离/cos(f夹角Z向);
                    vZ轴向长=vZ轴向单位*f长Z轴;
                    v位果真=v位全局真+vZ轴向长;
                    o子.matrix_world=mΔΔm移位LIB(m父,v位果真);



    def draw_buttons(self, context, layout):
        layout.prop(self, "sp属性", text = "sring");
        layout.operator(卐新建或升级太阳灯卐Operator.bl_idname, text='新建太阳', icon='NONE');

    def draw_buttons_ext(self, context, layout):
        layout.prop(self, "sp属性", text = "string")
        layout.prop(self,"bp升级", text = "update Scene")
    pass
    
#////////////////////////////////////////////////
class 卐新建或升级太阳灯卐Operator(bpy.types.Operator):
    bl_idname = 'op.new_sun_lights';
    bl_label = 'new or update sun';
    bl_description = 'new or update sun';

    sp=StringProperty(name="note", description="", default="are you sure");
    ip十个=IntProperty(name='一L',description='',default=1,min=1,max=100,step=1,subtype='NONE',update=None,get=None,set=None);
    ip一个=IntProperty(name='一R',description='',default=1,min=1,max=100,step=1,subtype='NONE',update=None,get=None,set=None);
    ip左或右个=IntProperty(name='L or R',description='',default=1,min=1,max=100,step=1,subtype='NONE',update=None,get=None,set=None);

    #==============================================================
    def invoke(self, context, event):
        self.n=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="IMDJS_NodeSetSunLights");
        return context.window_manager.invoke_props_dialog(self)#把自身加入到dialog

    def draw(self, context):
        layout = self.layout;
        layout.prop(self, "sp");
        uil行=layout.row(align=False);
        uil行.prop(data=self,property="ip十个",text='十个',text_ctxt='',translate=True,icon='NONE',expand=False,slider=False,toggle=False,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);
        uil行.prop(data=self,property="ip一个",text='一个',text_ctxt='',translate=True,icon='NONE',expand=False,slider=False,toggle=False,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);
        uil行.prop(data=self,property="ip左或右个",text='左右个',text_ctxt='',translate=True,icon='NONE',expand=False,slider=False,toggle=False,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);

    def execute(self, context):
        scene=context.scene;
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();

        o日=None;
        if(self.n!=None):
            n群组=nΔΔ找到群组节点(self.n);
            if(n群组!=None):
                b找到物=False;
                for s物名,o  in Ds物oGitems():
                    if(s物名 in n群组.cp群组物体.keys()):#只取一个子计算
                        if(self.o.type=="LAMP"):
                            o日=o;
                            break;

        if(o日):
            #----ip十个------------------------------------------------------------------
            for i in range(self.ip十个):
                for j in range(self.ip左或右个):
                    o子=o日.copy();
                    o子.name="+"+str(j+1)+"L+"+str(i+1);
                    scene.objects.link(o子);
                    o子.parent=o日;
                    o子=o日.copy();
                    o子.name="-"+str(j+1)+"L+"+str(i+1);
                    scene.objects.link(o子);
                    o子.parent=o日;
            #----ip一个------------------------------------------------------------------
            for i in range(self.ip一个):
                for j in range(self.ip左或右个):
                    o子=o日.copy();
                    o子.name="+"+str(j+1)+"L-"+str(i+1);
                    scene.objects.link(o子);
                    o子.parent=o日;
                    o子=o日.copy();
                    o子.name="-"+str(j+1)+"L-"+str(i+1);
                    scene.objects.link(o子);
                    o子.parent=o日;

        else:
            self.report({"ERROR"},"no main sun");#"INFO" "ERROR" "DEBUG" "WARNING"


        return {"FINISHED"};
        pass
#/////////////////////////////////////////////////
D目录={"NodeCategory":["IMDJS_NodeCategoryShape","Shape"]};
Ls条项=[卐动画CurveSK卐IMDJS_NODES.bl_idname];
#////end//////////////////////////////////////////////




