import bpy,math,os,sys

from bpy.types import NodeTree, Node
from bpy.props import*
from mathutils import*


#if("function_node" in locals()):imp.reload(function_node);
#if(文件夹此mod+".function_node" not in locals()):
from ..function_node import *

#if(文件夹此mod+".IMDJS_tree" not in locals()):
from .IMDJS_tree import * ;

#from IMDJS_nodes_m.operator_node import 卐刷新所有群组名称卐Operator,卐同步游戏LOD卐Operator ,卐创建游戏LOD卐Operator;
from ..operator_node import *;

#//////////////////////////////////////////////
class 卐设置ShapeKey卐IMDJS_NODES(Node, 卐IMDJS_NODES):
    bl_idname = "IMDJS_NodeSetSK"
    bl_label = 'set ShapeKey'
    bl_icon = 'FORCE_VORTEX'

    sp节点类型 = StringProperty();
    sp物名 = StringProperty(default="");
    spSK名1 = StringProperty(default="");
    spSK名2 = StringProperty(default="");
    spSK名3 = StringProperty(default="");
    #o=bpy.context.active_object;
    #ip循环结束时刻 =None;
    bp有物=BoolProperty(default=False);

    def init(self, context):
        self.b使用回放颜色 = False;
        self.sp节点类型 = "OPS";

        self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"INPUT");
        self.inputs.new("NodeSocketFloatFactor","SK_VALUE") ;
        #self.inputs.new("NodeSocketInt","NUM_CYCLE");
        #self.inputs.new("NodeSocketInt","NUM_INTERVAL");
        self.inputs.new("NodeSocketInt","TIME");

        self.outputs.new(卐颜色接口卐NodeSocket.bl_idname,"OUTPUT");

    def Δ升级节点(self,scene,o群父,o,i延时):
        if(bΔΔ是禁用节点(self,scene,o群父,o,i延时) ):return ;
        ns输入=self.inputs["INPUT"]
        ns输入.ip接口时刻 = ns输入.links[0].from_socket.ip接口时刻;
        Lastnode = ns输入.links[0].from_node;

        float = self.inputs["SK_VALUE"];
        if (len(float.links) > 0):#有连接
            n节点前面 = float.links[0].from_node;
            if (n节点前面.sp节点类型 == "BREAK"):
                n节点前面.Δ升级节点();
            float.default_value = float.links[0].from_socket.default_value;#把对方的值 赋予自己

        """
        ns循环次数 = self.inputs["NUM_CYCLE"];
        if (len(ns循环次数.links) > 0):
            n节点前面 = ns循环次数.links[0].from_node;
            if (n节点前面.sp节点类型 == "BREAK"):
                n节点前面.Δ升级节点();
            ns循环次数.default_value = ns循环次数.links[0].from_socket.default_value;

        if(ns循环间隔.default_value <1):
            ns循环间隔.default_value =1;

        ns循环间隔 = self.inputs["NUM_INTERVAL"];
        if (len(ns循环间隔.links) > 0):
            n节点前面 = ns循环间隔.links[0].from_node;
            if (n节点前面.sp节点类型 == "BREAK"):
                n节点前面.Δ升级节点();
            ns循环间隔.default_value = ns循环间隔.links[0].from_socket.default_value;

        if(ns循环间隔.default_value <0):
            ns循环间隔.default_value =0;
        """

        ns本节点时间 = self.inputs["TIME"];
        if (len(ns本节点时间.links) > 0):
            n节点前面 = ns本节点时间.links[0].from_node;
            if (n节点前面.sp节点类型 == "BREAK"):
                n节点前面.Δ升级节点();
            ns本节点时间.default_value = ns本节点时间.links[0].from_socket.default_value;

        ns下一个=self.outputs["OUTPUT"];

        i本节点时间=self.inputs["TIME"].default_value;
        if(self.inputs["TIME"].default_value==0):
            i本节点时间=100000;
        ns下一个.ip接口时刻 = ns输入.ip接口时刻 + i本节点时间;#决定 本节点结束时间
        #self.ip循环结束时刻 = ns输入.ip接口时刻 + self.inputs["TIME"].default_value;#决定 本节点结束时间
        G.Li当前帧GG[0]=scene.frame_current;
        if (G.Li当前帧GG[0]> ns输入.ip接口时刻 and G.Li当前帧GG[0]<=ns下一个.ip接口时刻 ):#在本节点时间内
            #print("UNDATE SK",G.Li当前帧GG[0],ns输入.ip接口时刻);
            #----变化一个SK------------------------------------------------------------
            if (self.spSK名1 and not self.spSK名2):
                o.data.shape_keys.key_blocks[self.spSK名1].value = float.default_value;
            #----变化多个SK------------------------------------------------------------
            elif (self.spSK名1 and  self.spSK名2 and not self.spSK名3 and  not float.links ):
                f一半时间=ns本节点时间.default_value/2;
                i当前节点时间=(G.Li当前帧GG[0]-ns输入.ip接口时刻 );

                if(i当前节点时间>f一半时间):
                    i当前节点时间=f一半时间-(i当前节点时间-f一半时间);
                f当前Ξ本节点时间=i当前节点时间/f一半时间;
                o.data.shape_keys.key_blocks[self.spSK名1].value = f当前Ξ本节点时间;
                o.data.shape_keys.key_blocks[self.spSK名2].value = 1-f当前Ξ本节点时间;

            elif (self.spSK名1 and  self.spSK名2  and  self.spSK名3 and not float.links ):#spSK名1为基础SK
                f三分一时间=ns本节点时间.default_value/3;
                i当前节点时间=(G.Li当前帧GG[0]-ns输入.ip接口时刻 );

                if(i当前节点时间<f三分一时间):
                    f当前Ξ本节点时间=i当前节点时间/f三分一时间;#三分一时间时为最大值
                    o.data.shape_keys.key_blocks[self.spSK名2].value = f当前Ξ本节点时间;#升
                    if(o.data.shape_keys.key_blocks[self.spSK名3].value>0):
                        o.data.shape_keys.key_blocks[self.spSK名3].value=0;
                    #print("A",f当前Ξ本节点时间);
                elif(i当前节点时间>=f三分一时间 and i当前节点时间<f三分一时间*2):#在中间
                    i当前节点时间=i当前节点时间-f三分一时间;
                    f当前Ξ本节点时间=i当前节点时间/f三分一时间;
                    o.data.shape_keys.key_blocks[self.spSK名2].value =1- f当前Ξ本节点时间;#降
                    o.data.shape_keys.key_blocks[self.spSK名3].value = f当前Ξ本节点时间;#升
                    #print("B",f当前Ξ本节点时间);
                elif(i当前节点时间>=f三分一时间*2):
                    i当前节点时间=i当前节点时间-f三分一时间*2;
                    f当前Ξ本节点时间=i当前节点时间/f三分一时间;
                    o.data.shape_keys.key_blocks[self.spSK名3].value = 1-f当前Ξ本节点时间;#降
                    if(o.data.shape_keys.key_blocks[self.spSK名2].value>0):
                        o.data.shape_keys.key_blocks[self.spSK名2].value=0;
                    #print("C",f当前Ξ本节点时间);
                #☐☐☐☐☐3分1时间☐☐☐☐☐☐☐☐
                #☐☐━━━━╋━━━━╋━━━━━━→☐时间增加方向☐
                #☐☐☐☐☐☐┃☐☐☐☐┃☐☐
                #☐☐☐☐☐/┃\☐☐/┃\☐☐☐☐
                #☐☐☐☐/☐┃☐\/☐┃☐\☐☐☐☐
                #☐☐☐/☐☐┃☐/\☐┃☐☐\☐☐☐
                #☐☐/☐☐☐┃/☐☐↘┃☐☐☐↘☐☐☐
                #spSK名2☐spSK名3☐☐☐☐☐☐☐☐

        #----如果有下一个节点 并且时间已过本节点时间  就升级它------------------------------------------------------------
        else:
            if(len(ns下一个.links) > 0):
                if (G.Li当前帧GG[0]>= ns下一个.ip接口时刻):
                    for link in ns下一个.links:
                        link.to_node.Δ升级节点(scene,None,o,i延时);

    # Additional buttons displayed on the node.
    def draw_buttons(self, context, layout):
        layout.prop_search(self, "sp物名",  context.scene, "objects", text="", icon = "OBJECT_DATA");#把context.scene.objects[某个].name  赋予self.sp物名
        if(self.sp物名):
            layout.prop_search(self, "spSK名1",  context.scene.objects[self.sp物名].data.shape_keys, "key_blocks", text="", icon = "SHAPEKEY_DATA");#把key_blocks[某个].name 赋予self.spSK名1
            if(self.spSK名1):
                layout.prop_search(self, "spSK名2",  context.scene.objects[self.sp物名].data.shape_keys, "key_blocks", text="", icon = "SHAPEKEY_DATA");
                if(self.spSK名2):
                    layout.prop_search(self, "spSK名3",  context.scene.objects[self.sp物名].data.shape_keys, "key_blocks", text="", icon = "SHAPEKEY_DATA");

#//////////////////////////////////////////////////
class 卐设置UV卐IMDJS_NODES(Node, 卐IMDJS_NODES):
    bl_idname = "IMDJS_NodeAniUV"
    bl_label = 'set UV'
    bl_icon = 'FORCE_VORTEX'

    sp节点类型 = StringProperty();
    sp物名 = StringProperty(default="");
    spUV名1 = StringProperty(default="");
    spUV名2 = StringProperty(default="");
    spUV名3 = StringProperty(default="");
    #o=bpy.context.active_object;
    #ip循环结束时刻 =None;
    bp有物=BoolProperty(default=False);

    def init(self, context):
        self.b使用回放颜色 = False;
        self.sp节点类型 = "OPS";

        self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"INPUT");
        self.inputs.new("NodeSocketFloatFactor","F_UV") ;
        #self.inputs.new("NodeSocketInt","NUM_CYCLE");
        #self.inputs.new("NodeSocketInt","NUM_INTERVAL");
        self.inputs.new("NodeSocketInt","TIME");

        self.outputs.new(卐颜色接口卐NodeSocket.bl_idname,"OUTPUT");

    def Δ升级节点(self,scene,o群父,o,i延时):
        print("UPDATE",);
        if(bΔΔ是禁用节点(self,scene,o群父,o,i延时) ):return ;
        ns输入=self.inputs["INPUT"]
        ns输入.ip接口时刻 = ns输入.links[0].from_socket.ip接口时刻;
        Lastnode = ns输入.links[0].from_node;

        float = self.inputs["F_UV"];
        if (len(float.links) > 0):#有连接
            n节点前面 = float.links[0].from_node;
            if (n节点前面.sp节点类型 == "BREAK"):
                n节点前面.Δ升级节点();
            float.default_value = float.links[0].from_socket.default_value;#把对方的值 赋予自己

        ns本节点时间 = self.inputs["TIME"];
        if (len(ns本节点时间.links) > 0):
            n节点前面 = ns本节点时间.links[0].from_node;
            if (n节点前面.sp节点类型 == "BREAK"):
                n节点前面.Δ升级节点();
            ns本节点时间.default_value = ns本节点时间.links[0].from_socket.default_value;

        ns下一个=self.outputs["OUTPUT"];

        i本节点时间=self.inputs["TIME"].default_value;
        ns下一个.ip接口时刻 = ns输入.ip接口时刻 + i本节点时间;#决定 本节点结束时间
        #self.ip循环结束时刻 = ns输入.ip接口时刻 + self.inputs["TIME"].default_value;#决定 本节点结束时间
        #====在本节点时间内==============================================
        G.Li当前帧GG[0]=scene.frame_current;#print("",G.Li当前帧GG[0]);
        if (G.Li当前帧GG[0]> ns输入.ip接口时刻 and G.Li当前帧GG[0]<=ns下一个.ip接口时刻 ):
            #----一个UV不能变化------------------------------------------------------------
            if (self.spUV名1 and not self.spUV名2):
                print("ONLY 1 UV",);
                return ;
            #----变化多个UV------------------------------------------------------------
            elif (self.spUV名1 and  self.spUV名2 and not self.spUV名3 and  not float.links ):#两个UV
                #f一半时间=ns本节点时间.default_value/2;
                i当前节点时间=(G.Li当前帧GG[0]-ns输入.ip接口时刻 );
                bpy.ops.object.mode_set(mode='OBJECT');
                #if(i当前节点时间>f一半时间):
                    #i当前节点时间=f一半时间-(i当前节点时间-f一半时间);
                f当前Ξ本节点时间=i当前节点时间/ns本节点时间.default_value;
                Cmuvl1=o.data.uv_layers[self.spUV名1].data;
                Cmuvl2=o.data.uv_layers[self.spUV名2].data;
                id=o.data;
                if("UV_ani" not in o.data.uv_layers):
                    bpy.ops.mesh.uv_texture_add();
                    Cmuvl动画=id.uv_layers.active.data;
                    print("UV NAME==",id.uv_layers.active.name);
                    id.uv_layers.active.name="UV_ani";
                else:
                    Cmuvl动画=id.uv_layers["UV_ani"].data;
                    
                if(id.uv_textures["UV_ani"].active_render==False):
                    id.uv_textures["UV_ani"].active_render=True;
                    
                for i环,muvl动画 in enumerate(Cmuvl动画):

                    muvl动画.uv=Cmuvl1[i环].uv+(Cmuvl2[i环].uv-Cmuvl1[i环].uv)*f当前Ξ本节点时间;
                    print("SET UV==",f当前Ξ本节点时间,muvl动画.uv,len(Cmuvl动画));

                bpy.ops.object.mode_set(mode='EDIT');
                #----动画uv----------------------------------------------------------------


                    #print("C",f当前Ξ本节点时间);
                #☐☐☐☐☐3分1时间☐☐☐☐☐☐☐☐
                #☐☐━━━━╋━━━━╋━━━━━━→☐时间增加方向☐
                #☐☐☐☐☐☐┃☐☐☐☐┃☐☐
                #☐☐☐☐☐/┃\☐☐/┃\☐☐☐☐
                #☐☐☐☐/☐┃☐\/☐┃☐\☐☐☐☐
                #☐☐☐/☐☐┃☐/\☐┃☐☐\☐☐☐
                #☐☐/☐☐☐┃/☐☐↘┃☐☐☐↘☐☐☐
                #spUV名2☐spUV名3☐☐☐☐☐☐☐☐

        #----如果有下一个节点 并且时间已过本节点时间  就升级它------------------------------------------------------------
        else:
            if(len(ns下一个.links) > 0):
                if (G.Li当前帧GG[0]>= ns下一个.ip接口时刻):
                    for link in ns下一个.links:
                        link.to_node.Δ升级节点(scene,None,o,i延时);

    def draw_buttons(self, context, layout):
        layout.prop_search(self, "sp物名",  context.scene, "objects", text="", icon = "OBJECT_DATA");#把context.scene.objects[某个].name  赋予self.sp物名
        if(self.sp物名):
            layout.prop_search(self, "spUV名1",  context.scene.objects[self.sp物名].data, "uv_layers", text="", icon = "GROUP_UVS");#把key_blocks[某个].name 赋予self.spUV名1
            if(self.spUV名1):
                layout.prop_search(self, "spUV名2",  context.scene.objects[self.sp物名].data, "uv_layers", text="", icon = "GROUP_UVS");
                if(self.spUV名2):
                    layout.prop_search(self, "spUV名3",  context.scene.objects[self.sp物名].data, "uv_layers", text="", icon = "GROUP_UVS");



#//////////////////////////////////////////////////
class 卐设置灯光halo卐IMDJS_NODES(Node, 卐IMDJS_NODES):
    bl_idname = "IMDJS_NodeSetHalo"
    bl_label = 'set halo'
    bl_icon = 'FORCE_VORTEX'

    sp节点类型 = StringProperty();
    sp物名 = StringProperty(default="");
    spSK名1 = StringProperty(default="");
    #o=bpy.context.active_object;
    ip指数=IntProperty(min=1, max=16,default=5);
    bp有物=BoolProperty(default=False);

    def init(self, context):
        self.b使用回放颜色 = False;
        self.sp节点类型 = "OPS";

        self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"INPUT");
        self.inputs.new("NodeSocketFloatFactor","HALO_VALUE") ;
        self.inputs.new("NodeSocketFloatFactor","HALO_VALUE倍数");
        self.inputs.new("NodeSocketInt","TIME");
        self.outputs.new(卐颜色接口卐NodeSocket.bl_idname,"OUTPUT");

        self.inputs["HALO_VALUE_MUL"].default_value =1.0;
    # Atualiza o valor do 下一个 com o valor Absoluto
    def Δ升级节点(self,scene,o群父,o,i延时):
        if(bΔΔ是禁用节点(self,scene,o群父,o,i延时) ):return ;
        global o镜G;
        self.inputs["INPUT"].ip接口时刻 = self.inputs["INPUT"].links[0].from_socket.ip接口时刻+1;#从别的节点传入开始时刻
        """"""
        if(self.bp是禁用节点):
            if(not  self.use_custom_color):
                self.use_custom_color=True;
                self.color=(1.0, 0.0, 0.0);#红色
            self.outputs["OUTPUT"].ip接口时刻 =self.inputs["INPUT"].ip接口时刻 ;
            #----过了本节点时间-执行下一节点的升级-----------------------------------------------
            if(len(self.outputs["OUTPUT"].links) > 0):
                if (G.Li当前帧GG[0] >= self.outputs["OUTPUT"].ip接口时刻):
                    for link in self.outputs["OUTPUT"].links:
                        link.to_node.Δ升级节点(scene,None,o,i延时);

        elif(not self.bp是禁用节点):
            if(self.use_custom_color ):
                self.use_custom_color=False;
        #---如果有别的连接-------------------------------------------------------------
        for s in ["HALO_VALUE","HALO_VALUE_MUL","TIME"]:
            if (len(self.inputs[s].links) > 0):#有连接
                #print("S==",s);
                n节点前面 = self.inputs[s].links[0].from_node;
                if (n节点前面.sp节点类型 == "BREAK"):
                    n节点前面.Δ升级节点();
                self.inputs[s].default_value = self.inputs[s].links[0].from_socket.default_value;#把对方的值 赋予自己

        #====在本节点时间内==============================================
        i本节点时间=self.inputs["TIME"].default_value;
        if(i本节点时间==0 and  i本节点时间!=100000):
            i本节点时间=100000;
        self.outputs["OUTPUT"].ip接口时刻 = self.inputs["INPUT"].ip接口时刻 + i本节点时间;#决定 本节点结束时间
        if (ns本节点时间.default_value ==0  or(G.Li当前帧GG[0] > self.inputs["INPUT"].ip接口时刻 and G.Li当前帧GG[0] <= self.outputs["OUTPUT"].ip接口时刻 and self.sp物名)):
            #print("HALO",);
            if(o镜G==None):
                o镜G=scene.camera;
                if(not o镜G):
                    print("NOT FIND CAM",o镜G);return ;
            m镜=o镜matrix_world;

            if(o群父!=None):
                m光=o群父.matrix_world*o.matrix_world;#子的全局m 相当于群组的本地m
            else:
                m光=o.matrix_world;

            v镜Z=Vector((m镜[0][2],m镜[1][2],m镜[2][2]));v光Z=Vector((m光[0][2],m光[1][2],m光[2][2]));
            f夹角=v镜Z.angle(v光Z)-2.1415926;
            #print("ANGLE",f夹角);
            if(f夹角>0):
                bpy.data.lamps[self.sp物名].halo_intensity =self.inputs["HALO_VALUE"].default_value= (f夹角**self.ip指数)*self.inputs["HALO_VALUE_MUL"].default_value;
        #----过了本节点时间-执行下一节点的升级-----------------------------------------------
        if(len(self.outputs["OUTPUT"].links) > 0):
            if (G.Li当前帧GG[0] >self.outputs["OUTPUT"].ip接口时刻):
                for link in self.outputs["OUTPUT"].links:
                    link.to_node.Δ升级节点(scene,None,o,i延时);

    #==============================================================
    def draw_buttons(self, context, layout):
        layout.prop(self, "bp是禁用节点", text = "disable");
        layout.prop_search(self, "sp物名",  bpy.data, "lamps", text="", icon = "OUTLINER_OB_LAMP");#把context.scene.pp场景物体MT设定s2.cp物体组 赋予self.name
        #if(self.sp物名):
            #layout.prop_search(self, "spSK名1",  context.scene.objects[self.sp物名].data.shape_keys, "key_blocks", text="", icon = "SHAPEKEY_DATA");#把context.scene.pp场景物体MT设定s2.cp物体组 赋予self.name
        layout.prop(self, "ip指数", text = "exponent");

#////////////////////////////////////////////////
#☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
#☐☐☐☐☐☐☐┆┅┈☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
#☐☐☐☐☐☐☐│┃☐┅┈☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
#☐☐☐☐☐☐┆☐┃☐☐☐┅┈☐Z轴☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
#☐☐☐☐☐☐│/☐☐☐☐☐☐┅☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
#☐☐☐☐☐☐━━━━━━━━━━━☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
#   x,-y<-    +1L-2    +1L-1     +1L+0      +1L+1       +1L+2       ->x,y
#        -y<-      M-2           M-1       ●                  M1             M2           ->y
#-x,-y<-    -1L-2     -1L-1    -1L+0        -1L+1        -1L+2      ->-x,y
#-x,-y<-    -2L-2     -2L-1    -2L+0        -2L+1        -2L+2      ->-x,y
#                   ip一个                                                                 ip十个
class 卐设置太阳灯位置卐IMDJS_NODES(Node, 卐IMDJS_NODES):
    '''Set a "Object" sp属性 of the Object'''
    bl_idname = 'IMDJS_NodeSetSunLights'
    bl_label = 'set sun location'
    bl_icon = 'FORCE_VORTEX'

    sp节点类型 = StringProperty();
    sp属性 = StringProperty();
    bp升级 = BoolProperty(description = "bp升级 or not the scene data. Warning High Performace Drop if enabled");
    fvp3位置x=FloatVectorProperty(name="x", description="", default=(1.0, 0.0, 0.0), subtype='NONE', size=3, update=None, get=None, set=None);
    fvp3位置y=FloatVectorProperty(name="y", description="", default=(0.0, 1.0, 0.0), subtype='NONE', size=3, update=None, get=None, set=None);
    fvp3位置z=FloatVectorProperty(name="z", description="", default=(0.0, 0.0, 1.0), subtype='NONE', size=3, update=None, get=None, set=None);
    
    def init(self, context):
        self.b使用回放颜色 = True
        self.sp节点类型 = ""

        self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"INPUT")
        self.inputs.new("NodeSocketInt","TIME")

        self.outputs.new(卐颜色接口卐NodeSocket.bl_idname,"OUTPUT")

    def Δ同步参数(self,o):
        pass;
        
        
        
    def Δ升级节点(self,scene,o父,o):
        if(self.bp是禁用节点 or not o.children):return ;
        #----如果在本节点时间内---------------------------------------------------------------
        ns下一个=self.outputs["OUTPUT"];
        i本节点时间=self.inputs["TIME"].default_value;
        if(i本节点时间==0 and  i本节点时间!=100000):
            i本节点时间=100000;
        ns下一个.ip接口时刻 = self.inputs["INPUT"].ip接口时刻 + i本节点时间;#决定 本节点结束时间
        
        G.Li当前帧GG[0] =scene.frame_current;
        if (G.Li当前帧GG[0] > self.inputs["INPUT"].ip接口时刻 and G.Li当前帧GG[0] <=ns下一个.ip接口时刻 ):
            #----先设置初始父子位置-------------------------------------------------------------
            m父=o.matrix_world;vZ轴向单位=Vector((m父[0][2],m父[1][2],m父[2][2]));
            v父位=vΔΔm得v位LIB(m父);
            f父Z=m父[2][3];
            v位移单位x=m父*Vector(self.fvp3位置x);v位移单位y=m父*Vector(self.fvp3位置y);v位移单位z=m父*Vector(self.fvp3位置z);f壹个间隔=o.data.shadow_frustum_size*2;
            f夹角Z向=Vector((0,0,-1)).angle(vZ轴);
            for o子 in o.children:
                if(o子.name[0]=="L"):
                    v位全局真=v位移单位x*f壹个间隔+v位移单位y*eval(子.name[1:]);
                    fZ距离=v位全局真.z-f父Z;
                    f长Z轴=fZ距离/cos(f夹角Z向);
                    vZ轴向长=vZ轴向单位*f长Z轴;
                    v位果真=v位全局真+vZ轴向长;
                    o子.matrix_world=mΔΔm移位LIB(m父,v位果真);
                    


    def draw_buttons(self, context, layout):
        layout.prop(self, "sp属性", text = "sring");
        layout.operator(卐新建或升级太阳灯卐Operator.bl_idname, text='新建太阳', icon='NONE');

    def draw_buttons_ext(self, context, layout):
        layout.prop(self, "sp属性", text = "string")
        layout.prop(self,"bp升级", text = "update Scene")

#////////////////////////////////////////////////
class 卐新建或升级太阳灯卐Operator(bpy.types.Operator):
    bl_idname = 'op.new_sun_lights';
    bl_label = 'new or update sun';
    bl_description = 'new or update sun';

    sp=StringProperty(name="note", description="", default="are you sure");
    ip十个=IntProperty(name='一L',description='',default=1,min=1,max=100,step=1,subtype='NONE',update=None,get=None,set=None);
    ip一个=IntProperty(name='一R',description='',default=1,min=1,max=100,step=1,subtype='NONE',update=None,get=None,set=None);
    ip左或右个=IntProperty(name='L or R',description='',default=1,min=1,max=100,step=1,subtype='NONE',update=None,get=None,set=None);

    #==============================================================
    def invoke(self, context, event):
        self.n=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="IMDJS_Nodes",s节点类型="IMDJS_NodeSetSunLights");
        return context.window_manager.invoke_props_dialog(self)#把自身加入到dialog
        
    def draw(self, context):
        layout = self.layout;
        layout.prop(self, "sp");
        uil行=layout.row(align=False);
        uil行.prop(data=self,property="ip十个",text='十个',text_ctxt='',translate=True,icon='NONE',expand=False,slider=False,toggle=False,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);
        uil行.prop(data=self,property="ip一个",text='一个',text_ctxt='',translate=True,icon='NONE',expand=False,slider=False,toggle=False,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);        
        uil行.prop(data=self,property="ip左或右个",text='左右个',text_ctxt='',translate=True,icon='NONE',expand=False,slider=False,toggle=False,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);         
        
    def execute(self, context):
        scene=context.scene;
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();
            
        o日=None;
        if(self.n!=None):
            n群组=nΔΔ找到群组节点(self.n);
            if(n群组!=None):
                b找到物=False;
                for s物名,o  in Ds物oGitems():
                    if(s物名 in n群组.cp群组物体.keys()):#只取一个子计算
                        if(o.type=="LAMP"):
                            o日=o;
                            break;
                        
        if(o日):
            #----ip十个------------------------------------------------------------------
            for i in range(self.ip十个):
                for j in range(self.ip左或右个):
                    o子=o日.copy();
                    o子.name="+"+str(j+1)+"L+"+str(i+1);
                    scene.objects.link(o子);
                    o子.parent=o日;
                    o子=o日.copy();
                    o子.name="-"+str(j+1)+"L+"+str(i+1);
                    scene.objects.link(o子);
                    o子.parent=o日;
            #----ip一个------------------------------------------------------------------
            for i in range(self.ip一个):
                for j in range(self.ip左或右个):
                    o子=o日.copy();
                    o子.name="+"+str(j+1)+"L-"+str(i+1);
                    scene.objects.link(o子);
                    o子.parent=o日;
                    o子=o日.copy();
                    o子.name="-"+str(j+1)+"L-"+str(i+1);
                    scene.objects.link(o子);
                    o子.parent=o日;
        
        else:
            self.report({"ERROR"},"no main sun");#"INFO" "ERROR" "DEBUG" "WARNING"
        
        
        return {"FINISHED"};
        
    
#////end//////////////////////////////////////////////




