
import bpy,math,os,sys

from bpy.types import NodeTree, Node,NodeInternal
from bpy.props import*
from mathutils import*


path目录mod = os.path.dirname(__file__); #本py文件所在目录
文件夹此mod=os.path.basename(path目录mod);  #imdjs_nodes

try:
    from PYLIB.PYLIB_string import*
except:
    print("!!!!! ERROR import PYLIB_string",);
from .IMDJS_tree import 卐颜色接口卐NodeSocket,卐IMDJS_nodes,卐IMDJS_NODES,卐IMDJS_NODES_PSR ;

#from IMDJS_nodes_m.operator_node import 卐刷新所有群组名称卐Operator,卐同步游戏LOD卐Operator ,卐创建游戏LOD卐Operator;
from .IMDJS_logic import ΔΔ初始化PSR;
from ..operator_node import *;

#from ..operator_cloth import *;
#if( sys.modules[文件夹此mod+".global_var"]):
"""
try:
    import IMDJS_nodes_m.global_var as G;
except:
    if("IMDJS_nodes_m.global_var" in sys.modules):
        print("find IMDJS_nodes_m.global_var",);
        G = sys.modules["IMDJS_nodes_m.global_var"];
"""

#////////////////////////////////////////////
class 卐添加活物到group卐Operator(bpy.types.Operator):#+
    bl_idname = "op.imdjs_objects_add_to_group"
    bl_label = "add MT to object"
    name = bpy.props.StringProperty();
    bp升级=bpy.props.BoolProperty(name='update',description='---',default=False,subtype='NONE',update=None,get=None,set=None);

    def invoke(self, context, event):
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();
        
        self.nThis=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="IMDJS_NodeOutPutGroup");
        return self.execute(context);

    def execute(self, context):
        if( self.nThis!=None):
            """"""
            #----检测节点完整性---------------------------------------------------------------
            for nt in bpy.data.node_groups:
                if(nt.bl_idname=="imdjs_nodes"):
                    if(nt not in G.LntIMDJS节点GG):
                        G.LntIMDJS节点GG.append(nt);
                        G.Dnt树Dn节点DoL属性GG[nt]={};#填充第一级
                    for n in nt.nodes:
                        if (n.bl_idname == "IMDJS_NodeStart"):
                            b有开始n=False;
                            for n2 in G.Ln开始ntGG:
                                if(n ==n2[0] ):
                                    b有开始n=True;
                                    break;
                            if(b有开始n==False):
                                G.Ln开始ntGG.append([n,nt]);
            
            #----检测群组物完整性-----------------------------------------------------------
            n属性=nΔΔ找到属性节点从群组( self.nThis);
            if(n属性):
                ΔUPDATE字符串(n属性,context);
            for o in context.selected_objects:
                #o.pp物N设定o.name = self.name;
                if(o not in G.LoN物GG):
                    if(o.dupli_group ):#第壹个是父物体
                        for o组物 in o.dupli_group.objects:#第壹个是父物体#升级所有组物
                            if(o组物 not in G.LoN物GG):
                                G.LoN物GG.append(o组物);G.Ds物oGG.setdefault(o组物.name,o组物);
                                Δ填充Do物m3修改器单个GG(o组物);
                            if(o组物.dupli_group):
                                for o组组物 in o组物.dupli_group.objects:
                                    if(o组组物 not in G.LoN物GG):
                                        G.LoN物GG.append(o组组物);G.Ds物oGG.setdefault(o组组物.name,o组组物)
                                        Δ填充Do物m3修改器单个GG(o组组物);
                    #----非群组物体---------------------------------------------------------------
                    ΔΔ填充LoN物GG单个(o);
                    Δ填充Do物m3修改器单个GG(o);
                    #----初始化--------------------------------------------------------------
                    ΔΔ初始化PSR(self,context,self.nThis,o,True);#●●初始化PSR
                        
            #----群组物体-----------------------------------------------------------------
            for o in G.LoN物GG:
                if(o.name not in self.nThis.cp群组物体.keys() and o.select):#只添加选中物
                    s新预置名 = sΔΔ名字增量LIB(o.name, self.nThis.cp群组物体.keys());
                    pg= self.nThis.cp群组物体.add();
                    print("ADD group object",o.name);
                    pg.name=s新预置名;pg.fp距离权重=-1.0;
                    try:
                        pg.spID名=o.data.name;
                    except:
                        pg.spID名=o.name;
                    pg.s物类型=o.type ;
                    #----激活ξ---------------------------------------------------------------
                    iξ=len( self.nThis.cp群组物体)-1;
                    self.nThis.ip激活群组物体ξ=iξ;

            #print("ADD LoMT==",G.LoN物GG);
            #print("ADD G.Do物m3修改器单个GG==",G.Do物m3修改器单个GG);

        return {'FINISHED'};

#======================================================
class 卐删除这个设置卐Operator(bpy.types.Operator):#  - 号
    bl_idname = 'op.delete_this_mt';
    bl_label = 'delete this item';
    bl_description = 'delete this item';
    bl_options = { 'UNDO', 'INTERNAL'};

    def invoke(self, context, event):
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();
        self.n群组=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        
        return self.execute(context);

    def execute(self, context):
        if(self.n群组!=None):
            s要删除物名=self.n群组.cp群组物体[self.n群组.ip激活群组物体ξ].name;
            links=self.n群组.outputs["OUTPUT"].links;
            if(links):
                n开始=links[0].to_node;
                if(n开始.bl_idname=="IMDJS_NodeStart"):
                    nt=context.space_data.node_tree;
                    if(nt in G.Dnt树Dn开始节点Lo节点群组物GG):
                        if(n开始 in G.Dnt树Dn开始节点Lo节点群组物GG[nt]):
                            if(s要删除物名 in G.Ds物oGG):
                                o删除=G.Ds物oGG[s要删除物名];
                                if(o删除 in G.Dnt树Dn开始节点Lo节点群组物GG[nt][n开始]):
                                    G.Dnt树Dn开始节点Lo节点群组物GG[nt][n开始].remove(o删除);
                                print("remove obj ---",s要删除物名);
                        else:
                            G.Dnt树Dn开始节点Lo节点群组物GG[nt][n开始]=[];
                            
            ΔΔ从LoN物GG删物(s要删除物名);
            #--------------------------------------------------------------------------
            self.n群组.cp群组物体.remove(self.n群组.ip激活群组物体ξ);
            if (self.n群组.ip激活群组物体ξ> len(self.n群组.cp群组物体)-1):
                self.n群组.ip激活群组物体ξ = len(self.n群组.cp群组物体)-1;

            ΔΔUPDATE激活的预置名(self, context);#这个必须

        return {'FINISHED'};

#======================================================
class 卐删除设置从3d卐Operator(bpy.types.Operator):#  x 号
    bl_idname = 'op.delete_mt_form_3d';
    bl_label = 'delete this item from view';
    bl_description = 'delete this item from view';
    bl_options= { 'UNDO', 'INTERNAL'};

    sp=StringProperty(name="note!!", description="", default="are you sure?");
    def draw(self, context):
        self.layout.prop(self, "sp");
    def invoke(self, context, event):#召唤
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();
        self.n群组=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        return context.window_manager.invoke_props_dialog(self,400,50);

    def execute(self, context):
        print("NODE==",self.n群组.cp群组物体);
        if(self.n群组!=None):
            links=self.n群组.outputs["OUTPUT"].links;
            if(links):
                n开始=links[0].to_node;
                if(n开始.bl_idname=="IMDJS_NodeStart"):
                    nt=context.space_data.node_tree;
                    
            for oS in context.selected_objects:
                if(oS.name in self.n群组.cp群组物体.keys()):
                    if(nt in G.Dnt树Dn开始节点Lo节点群组物GG):
                        if(n开始 in G.Dnt树Dn开始节点Lo节点群组物GG[nt]):
                            if(oS.name in G.Ds物oGG):
                                o删除=G.Ds物oGG[s要删除物名];
                                if(o删除 in G.Dnt树Dn开始节点Lo节点群组物GG[nt][n开始]):
                                    G.Dnt树Dn开始节点Lo节点群组物GG[nt][n开始].remove(o删除);
                        else:
                            G.Dnt树Dn开始节点Lo节点群组物GG[nt][n开始]=[];  
                            
                    ΔΔ从LoN物GG删物(oS.name);
                    self.n群组.cp群组物体.remove(self.n群组.cp群组物体.keys().index(oS.name));
                    if (self.n群组.ip激活群组物体ξ> len(self.n群组.cp群组物体)-1):
                        self.n群组.ip激活群组物体ξ = len(self.n群组.cp群组物体)-1;

                ΔΔUPDATE激活的预置名(self, context);#这个必须

        return {'FINISHED'};

#==============oA=bpy.context.active_object;==============================
class 卐删除所有设置Operator(bpy.types.Operator):#  X号
    bl_idname = 'op.imdjs_delete_all';
    bl_label = 'delete all items';
    bl_description = 'delete all items';
    bl_options= { 'UNDO', 'INTERNAL'};

    sp=StringProperty(name="note", description="", default="are you sure delete all items?");
    def draw(self, context):
        self.layout.prop(self, "sp");
    def invoke(self, context, event):#召唤
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();
        self.n群组=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        return context.window_manager.invoke_props_dialog(self,400,50);

    def execute(self, context):
        #print("NODE==",self.n群组.cp群组物体);
        if(self.n群组!=None):

            for s物名 in self.n群组.cp群组物体.keys():
                #print("NAME==",s物名);
                ΔΔ从LoN物GG删物(s物名);
            self.n群组.cp群组物体.clear();
            self.n群组.ip激活群组物体ξ =-1;

        return {'FINISHED'}

#----------------------------------------------------------------------------
class 卐目录设置移上卐Operator(bpy.types.Operator):#↑
    bl_idname = 'op.imdjs_move_up'
    bl_label = 'Move up'
    bl_options = {'REGISTER', 'UNDO', 'INTERNAL'}

    @classmethod
    def poll(cls, context):
        return True;

    def invoke(self, context, event):
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();
        self.nThis=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        return self.execute(context);

    def execute(self, context):
        if( self.nThis!=None):
            index = self.nThis.ip激活群组物体ξ;
            self.nThis.cp群组物体.move(index, index-1);
            self.nThis.ip激活群组物体ξ -= 1;
        return {'FINISHED'}

#----------------------------------------------------------------------------
class 卐目录设置移下卐Operator(bpy.types.Operator):#↓
    bl_idname = 'op.imdjs_move_down'
    bl_label = 'Move Down'
    bl_options = {'REGISTER', 'UNDO', 'INTERNAL'}

    @classmethod
    def poll(cls, context):
        return True;

    def invoke(self, context, event):
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();
        self.nThis=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        return self.execute(context);

    def execute(self, context):
        if( self.nThis!=None):
            index = self.nThis.ip激活群组物体ξ;
            self.nThis.cp群组物体.move(index, index+1);
            self.nThis.ip激活群组物体ξ += 1;
        return {'FINISHED'};

#////////////////////////////////////////////////
class 卐排列群组物体卐Operator(bpy.types.Operator):
    bl_idname = 'op.sort_mt';
    bl_label = 'sort';
    bl_description = 'sort group objects';

    def invoke(self, context, event):
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();
        self.nThis=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        return context.window_manager.invoke_props_dialog(self)#把自身加入到dialog

    def execute(self, context):
        if( self.nThis!=None):
            Ls设置名 = [s原名 for s原名 in self.nThis.cp群组物体.keys() if s原名 != "0"];
            Ls设置名.sort();
            if ("0" in self.nThis.cp群组物体.keys()):
                Ls设置名.insert(0, "0") #把"0" 项插到最前

            for idx, s原名 in enumerate(Ls设置名):
                self.nThis.ip激活群组物体ξ= self.nThis.cp群组物体.keys().index(s原名)
                i开始位置 = self.nThis.ip激活群组物体ξ
                i最后位置 = idx

                while (i最后位置 != i开始位置):
                    if(i开始位置 < i最后位置):
                        self.nThis.cp群组物体.move(i开始位置, i开始位置+1)
                        i开始位置 += 1
                    elif(i开始位置 > i最后位置):
                        self.nThis.cp群组物体.move(i开始位置, i开始位置-1)
                        i开始位置 -= 1

            self.nThis.sp激活预置名= self.nThis.cp群组物体[ self.nThis.ip激活群组物体ξ].name;

        return {'FINISHED'}

#//////////////////////////////////////////////////
class 卐三角菜单卐Menu(bpy.types.Menu):
    bl_idname = 'menu.mt_group';
    bl_label = 'menu ';

    def draw(self, context):
        layout = self.layout;
        #layout.operator('import.sk', icon='IMPORT')
        #layout.operator('export.sk', icon='EXPORT')
        layout.operator(卐排列群组物体卐Operator.bl_idname, icon='SORTALPHA');
        layout.operator(卐删除所有设置Operator.bl_idname,icon='X');


#======================================================
class 卐群组卐UIList(bpy.types.UIList):
    def draw_item(self, context, layout, data, item, icon, active_data, active_propname, index):
        if (self.layout_type in {'DEFAULT', 'COMPACT'}):
            #layout.label(text=item.name, translate=False, icon_value=icon)
            row = layout.row().split(percentage=0.7, align=True);
            ICON="X";
            if(item.s物类型=="MESH"):
                ICON="OUTLINER_OB_MESH";
            elif(item.s物类型=="EMPTY"):
                ICON="OUTLINER_OB_EMPTY";
            elif(item.s物类型=="LAMP"):
                ICON="OUTLINER_OB_LAMP";
            elif(item.s物类型=="CURVE"):
                ICON="OUTLINER_OB_CURVE";
            elif(item.s物类型=="ARMATURE"):
                ICON="OUTLINER_OB_ARMATURE";
            elif(item.s物类型=="LATTICE"):
                ICON="OUTLINER_OB_LATTICE";
            elif(item.s物类型=="SURFACE"):
                ICON="OUTLINER_OB_SURFACE";
            elif(item.s物类型=="META"):
                ICON="OUTLINER_OB_META";
            elif(item.s物类型=="FONT"):
                ICON="OUTLINER_OB_FONT";
            elif(item.s物类型=="CAMERA"):
                ICON="OUTLINER_OB_CAMERA";
            elif(item.s物类型=="SPEAKER"):
                ICON="OUTLINER_OB_SPEAKER";
            elif(item.s物类型=="NONE"):
                ICON="X";
            row.prop(item, "name", text="", icon=ICON, emboss=False);

            #if(index!=0 ):
                #row.prop(item, "ip延时", text="", emboss=True,slider=True);




#////////////////////////////////////////////////
def ΔUPDATE改变颜色(self, context):
    if(self.bp只激活物):
        if(self.use_custom_color==False):
            self.use_custom_color=True;
        if(self.color!=(0.0,0.8,1.0)):
            self.color=(0.0,0.8,1.0);
    else:
        if(self.use_custom_color==True):
            self.use_custom_color=False;

    
class 卐群组物体卐PropertyGroup(bpy.types.PropertyGroup):#单个预置 cpSK预置id
    name = StringProperty(name="Preset Name", default="",update=ΔΔUPDATE激活的预置名);# name是cp的ξ ,update=ΔΔUPDATE改名预置
    s物类型=StringProperty(name="object type", default="NONE");
    spID名=StringProperty(name="old name", default="");
    bp改了名=BoolProperty(name='change name', description='---', default=False);
    bp脏=BoolProperty(name='dirty', description='---', default=False);
    fp距离权重=FloatProperty(name='weight',description='weight of distance from the object',default=0.0,min=0.0,max=1.0,step=3,precision=2,subtype='NONE',unit='NONE',update=None,get=None,set=None);
    ip延时= IntProperty(name="delay",description="delay time",default= 0,min=0, max=100,) ;
    #bp是硬盘=BoolProperty(name='是硬盘', description='是硬盘的数据', default=False);

        
class 卐输出群组卐IMDJS_NODES(Node, 卐IMDJS_NODES):
    bl_idname = "IMDJS_NodeOutPutGroup"
    bl_label = 'object group list'
    #bl_icon = 'FORCE_VORTEX'
    bl_width_default=200;
    bl_width_min=150;
    bl_width_max=300;

    ip循环次数=IntProperty(name='',description='---',default=0,min=0,max=10000,soft_min=0,soft_max=10000,step=1,subtype='NONE',update=None,get=None,set=None);

    ip子节点时间=IntProperty(name='',description='---',default=0,min=0,max=10000,soft_min=0,soft_max=10000,step=1,subtype='NONE',update=None,get=None,set=None);

    sp激活预置名=StringProperty();
    cp群组物体= CollectionProperty(type=卐群组物体卐PropertyGroup);
    ip激活群组物体ξ= IntProperty(default=0,update=ΔΔUPDATE激活的预置名);
    
    bp只激活物=BoolProperty(name='',description='object only available for the active item',default=False,subtype='NONE',update=ΔUPDATE改变颜色,get=None,set=None);
    
    ip延时=IntProperty(name='delay',description='time of  delay',default=0,min=0,max=1000,step=1,subtype='NONE',update=None,get=None,set=None);
    
    sp计算距离物体=StringProperty(name='distance object',description='distance object',default='',maxlen=0,subtype='NONE',update=None,get=None,set=None);
    
    bp已经初始化=BoolProperty(name='',default=False,subtype='NONE',update=None,get=None,set=None);    #bp是延时=BoolProperty(name='delay',description='',default=False,subtype='NONE',update=None,get=None,set=None);
    #bp显示位置=BoolProperty(name='',description='显示物体3d位置',default=False,subtype='NONE',update=ΔΔUPDATE显示位置,get=None,set=None);

    #--------------------------------------------------------------------------
    def init(self, context):
        #self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"INPUT");
        self.outputs.new(卐颜色接口卐NodeSocket.bl_idname,"OUTPUT");
        self.label=self.name;
        self.ip实际帧=0;self.ip停止时间=0;
    #======================================================
    def draw_buttons(self, context, layout):
        uil行 = layout.row(align=True );
        uil行.operator(卐刷新所有群组名称卐Operator.bl_idname, text='', icon='FILE_REFRESH') ;
        uil行.menu(卐三角菜单卐Menu.bl_idname, icon='DOWNARROW_HLT', text='');#三角菜单
        #uil行.operator(卐升级设置卐Operator.bl_idname, text='', icon='FILE_PARENT');
        #uil行.operator(卐目录设置移上卐Operator.bl_idname, text='', icon='TRIA_UP');
        #uil行.operator(卐目录设置移下卐Operator.bl_idname, text='', icon='TRIA_DOWN') ;
        #uil行.prop(data=self,property="bp是延时",text='delay',text_ctxt='',translate=True,icon='NONE',expand=False,slider=False,toggle=True,icon_only=False,event=False,full_event=False,emboss=True);
        uil行.prop(data=self,property='bp只激活物',text='only active',text_ctxt='',translate=True,icon='RESTRICT_SELECT_OFF',expand=False,slider=False,toggle=True,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);
        #--------------------------------------------------------------------------        
        uil行= layout.row(align=True );#.split(percentage=0.5,align=True);
        uil行.prop_search(self,"sp计算距离物体", context.scene, "objects", text = "distance object", icon = "OBJECT_DATAMODE");
        uil行.operator(卐激活物名给sp卐Operator.bl_idname, text='', icon='EYEDROPPER') ;
        
        if(self.sp计算距离物体):
            uil行= layout.row(align=False );#.split(percentage=0.5,align=True);  
            uil列1=uil行.column(align=True);
            uil列1.operator(卐初始化群组距离卐Operator.bl_idname, text='init distance', icon='FILE_TICK') ;
            uil列2=uil行.column(align=True);
            uil列2.operator(卐反初始化群组距离卐Operator.bl_idname, text='uninit', icon='X') ;
            uil列1.enabled=not self.bp已经初始化;uil列2.enabled=self.bp已经初始化;

                          
        
        uil行= layout.row(align=True );
        uil行.prop(data=self,property='ip延时',text='delay',text_ctxt='',translate=True,icon='NONE',expand=False,slider=False,toggle=False,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);
        if(self.ip延时==0):
            uil行.active=False;
        else:
            uil行.active=True;
        #--------------------------------------------------------------------------
        uil行=layout.row(align=False);
        uil行.template_list('卐群组卐UIList', '－－－', self, 'cp群组物体', self, 'ip激活群组物体ξ', rows=3,maxrows=8,);
        #--------------------------------------------------------------------------
        uil行应用 = layout.row(align=True ).split(percentage=0.5,align=True);
        #uil列 = uil行3.column(align=True);
        OPERATOR添加MT=uil行应用.operator(卐添加活物到group卐Operator.bl_idname, text='', icon='ZOOMIN');
        if(OPERATOR添加MT.bp升级!=False):
            #print("BP UPDATE",);
            OPERATOR添加MT.bp升级=False;#+
        uil行应用.operator(卐删除这个设置卐Operator.bl_idname, text='', icon='ZOOMOUT') ;#-
        uil行应用.operator(卐删除设置从3d卐Operator.bl_idname, text='', icon='PANEL_CLOSE') ;#x
        

        #--------------------------------------------------------------------------
        uil行 = layout.row(align=True );
        uil行.operator(卐画画选卐Operator.bl_idname, text='显', icon='GREASEPENCIL');
        uil行.operator(卐选择群组物体卐Operator.bl_idname, text='选', icon='RESTRICT_SELECT_OFF').bp是选=True;
        uil行.operator(卐选择群组物体卐Operator.bl_idname, text='反', icon='VISIBLE_IPO_OFF').bp是选=False;

#==============================================================
class 卐初始化群组距离卐Operator(bpy.types.Operator):
    bl_idname = "op.imdjs_init_distance_group";
    bl_label = "init group";
    bl_context='object';

    sp=StringProperty(name="注意", description="", default="are you sure init group ?");
    #--------------------------------------------------------------------------
    def draw(self, context):    self.layout.prop(self, "sp");

    def invoke(self, context, event):
        self.n群组=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        return context.window_manager.invoke_props_dialog(self,300,50);#召唤

    def execute(self, context):
        if(LIB.dllIMDJS==None):LIB.dllIMDJS=dllΔΔ载入dllLIB(LIB,"dllIMDJS",CLIB,CLIB64);
        print("sp==",self.sp);
        LIB.dllIMDJS.ΔΔ计算V距离权重(c_void_p(context.as_pointer()),c_void_p(self.n群组.as_pointer()));
        
        if(self.n群组.bp已经初始化==False):
            self.n群组.bp已经初始化=True;
        return {"FINISHED"};

class 卐反初始化群组距离卐Operator(bpy.types.Operator):
    bl_idname = "op.imdjs_init_distance_group_un";
    bl_label = "uninit group";
    bl_context='object';

    sp=StringProperty(name="注意", description="", default="are you sure init group ?");
    #--------------------------------------------------------------------------
    def draw(self, context):    self.layout.prop(self, "sp");

    def invoke(self, context, event):
        self.n群组=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        return context.window_manager.invoke_props_dialog(self,300,50);#召唤

    def execute(self, context):
        
        if(self.n群组.bp已经初始化==True):
            self.n群组.bp已经初始化=False;

        return {"FINISHED"};
        
class 卐激活物名给sp卐Operator(bpy.types.Operator):
    bl_idname = "op.imdjs_active_name_sp";
    bl_label = "active_name_sp";
    bl_context='object';
    bl_description="pick the active object"
    
    sp=StringProperty(name="注意", description="", default="are you sure init group ?");
    def invoke(self, context, event):
        self.nThis=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        return self.execute(context);
    #--------------------------------------------------------------------------
    def execute(self, context):
        if(self.nThis):
            oA=context.active_object;
            self.nThis.sp计算距离物体=oA.name;
            print("pick up object: %s"%oA.name);
        else:
            self.report({"ERROR"},"!!! can't find node");#"INFO" "ERROR" "DEBUG" "WARNING"
        return {"FINISHED"};

#////////////////////////////////////////////////
D目录={"NodeCategory":["IMDJS_NodeCategoryIM","IO"]};
Ls条项=[卐输出群组卐IMDJS_NODES.bl_idname];
#////end////end////end////end////end////end////end////end////




