

import bpy,math,os,sys
from bpy.types import NodeTree, Node
from bpy.props import*
from mathutils import*

dir = os.path.dirname(__file__); #本py文件所在目录
文件夹此mod=os.path.basename(dir);  #MotionTool

try:
    import PYLIB.global_var as LIB;
except:
    pass;

try:
    from PYLIB.PYLIB_attribute import dllΔΔ载入dllLIB,dllΔΔ卸载dllLIB;
except:
    from ..PYLIB.PYLIB_attribute import dllΔΔ载入dllLIB,dllΔΔ卸载dllLIB;
#from ..operator_node import CLIB,CLIB64;
from ..operator_node import *;
#if("function_node" in locals()):imp.reload(function_node);
#if(文件夹此mod+".function_node" not in locals()):
#from IMDJS_nodes_m.function_node import *
#from IMDJS_nodes_m.function_node import G
#import IMDJS_nodes_m.global_var as G;

from .IMDJS_tree import 卐颜色接口卐NodeSocket,卐IMDJS_nodes,卐IMDJS_NODES,卐IMDJS_NODES_PSR ;
#from IMDJS_nodes_m.global_var import Li当前帧GG ;
#from IMDJS_nodes_m.operator_node import 卐刷新所有群组名称卐Operator,卐同步游戏LOD卐Operator ,卐创建游戏LOD卐Operator;
#from IMDJS_nodes_m.operator_node import *;
"""
try:
    import IMDJS_nodes_m.global_var as G;
except:
    if("IMDJS_nodes_m.global_var" in sys.modules):
        print("find IMDJS_nodes_m.global_var",);
        G = sys.modules["IMDJS_nodes_m.global_var"];
"""
#///////////////////////////////////////////////
class 卐动画父级卐IMDJS_NODES(Node,卐IMDJS_NODES):
    bl_idname = 'IMDJS_NodeParent'
    bl_label = '动画父级'
    #bl_icon = 'FORCE_VORTEX'

    bp是刚体 = BoolProperty(name='p是刚体',description='p是刚体',default=False,subtype='NONE',update=None,get=None,set=None); # bp相对 0 == Absolute, bp相对 1 = Relative

    bp开始了本节点 = BoolProperty(name='',description='',default=False,subtype='NONE',update=None,get=None,set=None);
    #bp是父子 = BoolProperty(name='是父子',description='是父子',default=False,subtype='NONE',update=None,get=None,set=None);
    bp是距离决定父子 = BoolProperty(name='是距离决定父子',description='是距离决定父子',default=False,subtype='NONE',update=None,get=None,set=None);
    fp距离父子D=FloatProperty(name='距离父子',description='',default=1.0,min=0.0,max=100.0,soft_min=0.0,soft_max=100.0,step=3,precision=2,subtype='NONE',unit='NONE',update=None,get=None,set=None);
    fp距离阈值D=FloatProperty(name='距离阈值',description='',default=0.1,min=0.0,max=10.0,soft_min=0.0,soft_max=10.0,step=3,precision=2,subtype='NONE',unit='NONE',update=None,get=None,set=None);

    ep插值类型 = EnumProperty(items=Lt4插值类型);
    fvp3位置父前帧=FloatVectorProperty();#(default=(None, None, None));#fvp3初始scale
    fvp16矩阵父前帧=FloatVectorProperty(size=16,);
    #ip停止父级时间=IntProperty(name='停止父级时间',description='停止父级时间',default=0,min=0,max=10000,soft_min=0,soft_max=10000,step=1,subtype='NONE',update=None);
    ip上次开始帧=IntProperty(name='上次开始帧',description='上次开始帧',default=0,min=0,max=10000,soft_min=0,soft_max=10000,step=1,subtype='NONE',update=None);
    sp本节点父名=StringProperty(name='',description='',default='',maxlen=0,subtype='NONE',update=None,get=None,set=None);


    #--------------------------------------------------------------------------
    def init(self, context):
        #self.b使用回放颜色 = False;

        self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"INPUT");
        self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"INPUT_PARENT");



        self.outputs.new(卐颜色接口卐NodeSocket.bl_idname,"OUTPUT");
        self.outputs.new("NodeSocketFloat","输出父子距离");


    #--------------------------------------------------------------------------
    #☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐☐☐☐☐i开始时间☐☐☐☐☐☐☐☐☐☐☐☐☐i结束时间☐☐☐
    #☐☐☐☐☐☐☐☐┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐┃☐☐☐☐☐☐☐☐
    #☐☐☐☐☐☐☐☐┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐┃☐☐☐☐☐☐☐☐
    #☐☐☐☐☐☐☐☐┃☐☐┃☐☐☐☐☐☐☐☐☐☐☐☐┃☐☐☐☐☐☐☐☐
    #☐☐☐☐☐☐☐☐┃☐☐┃☐☐☐☐☐☐☐☐☐☐☐☐┃☐☐☐☐☐☐☐☐
    #☐☐━━━━━━━━━━━━━━━━━━━━━━━━━━━━→☐☐
    #                              -1== 成为父子时刻=非负;
    #                               显示动画    ┃     隐藏动画   bp开始了
    #☐☐☐☐☐☐☐☐☐☐☐┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐☐☐☐☐☐☐☐☐☐┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐

    #==============================================================
    def Δ刷新子级PSR(self,o父):
        for o子 in o父.children:
            o子.location=o子.location;
            Δ刷新子级PSR(self,o子);

    #==============================================================
    def Δ升级节点(self,nt,n开始,o群父,o,i物序,i延时):

        if(bΔΔ是禁用节点(nt,self,o群父,o,i延时) ):return ;
        if(o.pp物PSRo.bp是初始化了PSR==False):
            print("NOT INIT",);
            return ;
        i本节点开始时刻=self.inputs["INPUT"].ip接口开始时刻 = self.inputs["INPUT"].links[0].from_node.ip节点时间;#从上一个节点时间为  开始
        #print("TIME==",i本节点开始时刻 ,self.name);

        if(self.ip节点时间==0 and  self.ip节点时间!=100000):
            self.ip节点时间=100000;
        self.ip实际帧 = i本节点开始时刻 +self.ip节点时间;#上个节点时间+持续时间为本节点结束时间
        #----检测是否有值传过来---------------------------------------------------------
        for s in ["TIME"]:
            ns输入= self.inputs[s];
            if (ns输入.links):
                n节点前面 = ns输入.links[0].from_node;
                ns输入.default_value = ns输入.links[0].from_socket.default_value;

        print("UPDATA----",G.Li当前帧GG[0],self.name,"START==",self.bp开始了本节点);
        #print("G.Li当前帧GG[0] ",G.Li当前帧GG[0],i本节点开始时刻 , self.ip实际帧);
        #====在本节点时间内==============================================
        #G.Li当前帧GG[0]=scene.frame_current;
        if (G.Li当前帧GG[0] >= i本节点开始时刻 and G.Li当前帧GG[0] <= self.ip实际帧):
            #print("UPDATA----",self.name,"START==",self.bp开始了本节点);
            #----找到父---------------------------------------------------------------
            if(self.inputs["INPUT_PARENT"].links):
                if(self.sp本节点父名==""):
                    n群组输入=self.inputs["INPUT_PARENT"].links[0].from_node;
                    #print("G.LoN物GG==",G.LoN物GG);
                    Ls物名本群组=n群组输入.cp群组物体.keys();
                    for s物名 in Ls物名本群组:
                        if(s物名 in G.Ds物oGG):
                            o父=G.Ds物oGG[s物名];
                            self.sp本节点父名=s物名;
                            print("FIND FARTHIER==",o父.name,self.name);
                            break;

                else:
                    o父=G.Ds物oGG.get(self.sp本节点父名);

                if(o父==None):
                    print("NO FATHER",);
                    if(self.sp本节点父名!=""):
                        self.sp本节点父名="";#清空
                    return ;
                #else:print("FATIER==",o父.name);


            else:
                print("NO LINKS",);
                return ;
            """"""
            #----计算父子距离并成为父子-------------------------------------------------
            if(self.bp是距离决定父子):
                if(o.pp物PSRo.ip时刻成为父子==-1):#未成父子
                    m子=o.matrix_world;m父=o父.matrix_world;
                    f距离父子Now=(Vector((m子[0][3],m子[1][3],m子[2][3]))-Vector((m父[0][3],m父[1][3],m父[2][3]))).length;
                    if(self.outputs["输出父子距离"].links):
                        self.outputs["输出父子距离"].default_value=f距离父子Now;
                    #----在成为父子的距离----------------------------------------------------------
                    #print("START==",o.pp物PSRo.bp开始了);
                    #if(o.pp物PSRo.bp开始了==False):
                    if(self.fp距离父子D>f距离父子Now-self.fp距离阈值D and self.fp距离父子D<f距离父子Now+self.fp距离阈值D):
                        #----只执行一次--------------------------------------------------------------
                        o.pp物PSRo.ip时刻成为父子=G.Li当前帧GG[0];
                        o.pp物PSRo.fvp16矩阵父动态初始=f16ΔΔm转f16LIB(o父.matrix_world);

                        o.pp物PSRo.bp开始了=True;
                        print("FARTHER TIME==",o.pp物PSRo.ip时刻成为父子);
                        print("SET  PARENT distance==",o.pp物PSRo.fvp16矩阵父动态初始[0],o.pp物PSRo.fvp16矩阵父动态初始[1],o.pp物PSRo.fvp16矩阵父动态初始[2]);
                        #----刷新缓存--------------------------------------------------------------
                        o.pp物PSRo.iip长度当前缓存=0;o.pp物PSRo.cp缓存PSR.clear();
                        print("CLEAR  CACHE",o.name);

            #----本节点第一帧---用于设定帧父子---------------------------------------------
            print("FRAME==",G.Li当前帧GG[0],i本节点开始时刻,self.name,self.bp开始了本节点)#,G.Li当前帧GG[0],i本节点开始时刻,self.name);
            if(G.Li当前帧GG[0] == i本节点开始时刻):
                print("SET",G.Li当前帧GG[0],"START==",self.bp开始了本节点,o父.name,self.name);
                #----父位置初始化---------------------------------------------------------
                if(self.bp是距离决定父子==False ):
                    if(self.bp开始了本节点==False or self.ip上次开始帧!= i本节点开始时刻 ):
                        o.pp物PSRo.fvp16矩阵子对父初始L=f16ΔΔm转f16LIB(o父.matrix_world.inverted()*o.matrix_world);
                        #self.fvp16矩阵父前帧=f16ΔΔm转f16LIB(o父.matrix_world);
                        self.bp开始了本节点=True;
                        self.ip上次开始帧= i本节点开始时刻;
                        print("SETmat==",o.pp物PSRo.fvp16矩阵子对父初始L[0],o.pp物PSRo.fvp16矩阵子对父初始L[1],o.pp物PSRo.fvp16矩阵子对父初始L[2]);


            #----执行父子---用缓存-----------------------------------------------
            #if(o.pp物PSRo.bp开始了):
            if(self.bp是距离决定父子 and o.pp物PSRo.ip时刻成为父子!=-1):
                ΔΔ隐藏或显示动画(o,False);#显示
                i过了父子时刻多少帧=G.Li当前帧GG[0]-o.pp物PSRo.ip时刻成为父子;
                if(i过了父子时刻多少帧>=0 ):#当前帧在父子关系时刻
                    ΔΔ隐藏或显示动画(o,True);#隐藏
                    #----有缓存------------------------------------------------------------
                    if(o.pp物PSRo.iip长度当前缓存 >i过了父子时刻多少帧):#有缓存
                        o.location=o.pp物PSRo.cp缓存PSR[i过了父子时刻多少帧].loc;
                        Δ刷新子级PSR(self,o);
                        if(o.name=="DDD"):
                            print("IS CACHE",o.location);
                    #----没缓存-------------------------------------------------------------
                    else:
                        v父位=Vector((o.pp物PSRo.fvp16矩阵父动态初始[3],o.pp物PSRo.fvp16矩阵父动态初始[7],o.pp物PSRo.fvp16矩阵父动态初始[11]));
                        o.location=o父.location+(Vector(pg记录.fvp3loc)-v父位);
                        Δ刷新子级PSR(self,o);
                        pg新缓存=o.pp物PSRo.cp缓存PSR.add();
                        pg新缓存.location=o.location;
                        o.pp物PSRo.iip长度当前缓存+=1;
            #----全局--设定帧父子-----------------------------------------------------
            #print("START",G.Li当前帧GG[0] ,self.bp开始了本节点,self.name);
            if(self.bp开始了本节点):
                if(self.bp是距离决定父子==False ):
                    ΔΔ隐藏或显示动画(o,True);#隐藏

                    o.matrix_world=o父.matrix_world*mΔΔf16转mLIB(o.pp物PSRo.fvp16矩阵子对父初始L);
                    #self.fvp16矩阵父前帧=f16ΔΔm转f16LIB(o父.matrix_world);
                    self.Δ刷新子级PSR(o);


        #----在本节点时间之前或之后--------------------------------------------------------
        else:
            #print("TIME NEXT==",self.ip实际帧,self.name);
            #if( o.pp物PSRo.bp开始了==True):o.pp物PSRo.bp开始了=False;#开始后就一直开始,直到手动刷新
            #----在本节点时间之前--------------------------------------------------------
            if (G.Li当前帧GG[0] < i本节点开始时刻):

                if(self.bp开始了本节点==True):
                    self.bp开始了本节点=False;
                ΔΔ隐藏或显示动画(o,False);#显示

                #----刚体-----------------------------------------------------------------
                if(self.bp是刚体):
                    if(o.rigid_body):
                        rb=o.rigid_body;
                        #if(rb.enabled==True):rb.enabled=False;
                        if(rb.kinematic==False): rb.kinematic=True;

            #----过了本节点时间-执行下一节点的升级--------------------------------------------
            if (G.Li当前帧GG[0] >i实际帧):
                if(self.bp开始了本节点==True):
                    self.bp开始了本节点=False;
                if(self.sp本节点父名!=""):
                    self.sp本节点父名="";#清空
                if(self.bp是刚体):
                    if(o.rigid_body):
                        rb=o.rigid_body;
                        #if(rb.enabled==False): rb.enabled=True;
                        if(rb.kinematic==True):rb.kinematic=False;

                for link in self.outputs["OUTPUT"].links:
                    if(link.to_socket.identifier!="INPUT"):continue;
                    link.to_node.Δ升级节点(nt,n开始,o群父,o,i物序,i延时);


    #==============================================================
    def draw_buttons(self, context, layout):
        uil=layout.row(align=False);
        uil.prop(self, "bp是刚体", text = "是刚体",icon="MESH_ICOSPHERE",toggle=True);
        uil.prop(self, "bp是距离决定父子", text = "是距离决定父子",icon="NONE",toggle=False);
        uil=layout.row(align=False).split(percentage=0.4,align=False);
        uil.prop(self, "fp距离阈值D", text = "距离阈值",icon="NONE",slider=True);
        uil.prop(self, "fp距离父子D", text = "距离父子",icon="NONE",slider=True);
        layout.operator(operator=卐清除子缓存卐Operator.bl_idname,text='清除子缓存',text_ctxt='',translate=True,icon='NONE',emboss=True,icon_value=0);
        #layout.prop(self, "ip停止父级时间", text = "停止父级时间");
        #uil行=layout.row(align=True);
        #uil行.prop(self, "bp相对", text = "相对");uil行.prop(self, "bp是循环", text = "循环");

    # Detail buttons in the sidebar.
    def draw_buttons_ext(self, context, layout):
        pass;

#==============================================================
def Δ清除子缓存(o):
    o.pp物PSRo.bp开始了=False;
    o.pp物PSRo.ip时刻成为父子=-1;
    o.pp物PSRo.iip长度当前缓存=0;o.pp物PSRo.cp缓存PSR.clear();
    #o.pp物PSRo.bp是初始化了PSR=False;
    #print("fvp16==",o.pp物PSRo.fvp16矩阵父动态初始);

    #o.pp物PSRo.fvp16矩阵父动态初始=FloatVectorProperty(size=16);

class 卐清除子缓存卐Operator(bpy.types.Operator):
    bl_idname = "op.imdjs_init_parent";
    bl_label = "清除子缓存";
    bl_options={'UNDO'};
    bl_context='object';

    sp=StringProperty(name="注意", description="", default="你确定要清除子缓存？");
    #--------------------------------------------------------------------------
    def draw(self, context):    self.layout.prop(self, "sp");

    def invoke(self, context, event):
        self.n=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        return context.window_manager.invoke_props_dialog(self,300,50);#召唤

    def execute(self, context):
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();

        if(self.n!=None):

            self.n.bp开始了本节点=False;#self.n.fvp3位置父动态初始=(0,0,0);

            n群组=nΔΔ找到群组节点(self.n);
            if(n群组!=None):
                for s物名,o  in Ds物oGitems():
                    if(s物名 in n群组.cp群组物体.keys()):
                        print("S==",s物名,o);
                        #----刷新缓存--------------------------------------------------------------
                        Δ清除子缓存(o);
                context.scene.frame_current =self.n.inputs["INPUT"].ip接口开始时刻-1;

                #print("self.n.ip时刻成为父子==",o.pp物PSRo.ip时刻成为父子);
            self.report({"ERROR"},"zero  ip时刻成为父子== %d "%o.pp物PSRo.ip时刻成为父子);#"INFO" "ERROR" "DEBUG" "WARNING"
        return {"FINISHED"};

#//////////////////////////////////////////////////
class 卐随机PSR卐IMDJS_NODES(Node,卐IMDJS_NODES):
    bl_idname = 'IMDJS_NodeRandomPSR'
    bl_label = '随机PSR'
    #bl_icon = 'FORCE_VORTEX'


    cp随机PSR偏移=CollectionProperty(type=卐PSR物体设定卐PropertyGroup, name="随机PSR", description="", options={'ANIMATABLE'});
    bp位置=BoolProperty(name='位置',description='',default=True,subtype='NONE',update=None,get=None,set=None);
    bp旋转=BoolProperty(name='旋转',description='',default=False,subtype='NONE',update=None,get=None,set=None);
    bp缩放=BoolProperty(name='缩放',description='',default=False,subtype='NONE',update=None,get=None,set=None);
    ep插值类型 = EnumProperty(items=Lt4插值类型);
    ip种子=IntProperty(name='种子',description='---',default=1);
    iipCP限长=IntProperty(name='循环长度',description='---',default=10);#一个cp的段数
    #--------------------------------------------------------------------------
    ip频率=IntProperty(name='频率',description='---',default=0);
    ip当前段数=IntProperty(default=0);
    ip当前CP数=IntProperty(default=0);
    ip上次种子=IntProperty(default=0);
    ip上次本节点时间=IntProperty(default=0);
    ip上段时刻=IntProperty(default=0);


    f3上一段位置=FloatVectorProperty(name='',description='',default=(0.0,0.0,0.0),min=-10000.0,max=10000.0,soft_min=-10000.0,soft_max=10000.0,step=3,precision=2,subtype='NONE',unit='NONE',size=3);
    f3上一段缩放=FloatVectorProperty(name='',description='',default=(1.0,1.0,1.0),min=-10000.0,max=10000.0,soft_min=-10000.0,soft_max=10000.0,step=3,precision=2,subtype='NONE',unit='NONE',size=3);
    f3上一段旋转=FloatVectorProperty(name='',description='',default=(0.0,0.0,0.0),min=-10000.0,max=10000.0,soft_min=-10000.0,soft_max=10000.0,step=3,precision=2,subtype='NONE',unit='NONE',size=3);

    f3当前位置应=[None,None,None];
    f3当前缩放应=[None,None,None];f3当前旋转应=[None,None,None];
    #--------------------------------------------------------------------------
    def init(self, context):
        #self.b使用回放颜色 = False;

        self.ip频率=25;

        self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"INPUT");
        
        self.inputs.new("NodeSocketVectorXYZ","START_LOC");
        self.inputs.new("NodeSocketVectorXYZ","START_SCALE");
        self.inputs.new("NodeSocketVectorXYZ","START_ROT");
        self.inputs.new("NodeSocketInt","频率");#表示多少帧一个循环

        self.inputs.new("NodeSocketVectorXYZ","位置幅度");
        self.inputs.new("NodeSocketVectorXYZ","缩放幅度");
        self.inputs.new("NodeSocketVectorXYZ","旋转幅度");
        self.inputs.new("NodeSocketFloat","INFLUENCE");


        self.outputs.new(卐颜色接口卐NodeSocket.bl_idname,"OUTPUT");
        self.outputs.new("NodeSocketVectorXYZ","RESULT_LOC");
        self.outputs.new("NodeSocketVectorXYZ","RESULT_SCALE");
        self.outputs.new("NodeSocketVectorXYZ","RESULT_ROT");

        self.inputs["频率"].default_value = 25;

        self.inputs["位置幅度"].default_value = [0.1,0.1,0.1];self.inputs["缩放幅度"].default_value = [0.1,0.1,0.1];self.inputs["旋转幅度"].default_value = [0.1,0.1,0.1];
        self.ip节点时间 = 0;

    #--------------------------------------------------------------------------
    def Δ初始化(self):
        print("INIT->->->->->->->->",);
        self.ip上次本节点时间=self.ip节点时间;
        self.ip频率=self.inputs["频率"].default_value;
        self.ip上次种子=self.ip种子;
        self.cp随机PSR偏移.clear();
        self.ip上段时刻=0;
        #--------------------------------------------------------------------------

        self.ip当前段数=0;
        self.ip当前CP数=0;

    #--------------------------------------------------------------------------
    def Δ升级节点(self,nt,n开始,o群父,o,i物序,i延时):
        if(bΔΔ是禁用节点(nt,self,o群父,o,i延时) ):return ;
        if(self.ip节点时间!=self.ip上次本节点时间  or self.inputs["频率"].default_value!=self.ip频率 or \
            self.ip上次种子!=self.ip种子):
            self.Δ初始化();
        #----cp随机PSR段数在100内-------------------------------------------------------
        f3位置幅度=self.inputs["位置幅度"].default_value;f3缩放幅度=self.inputs["缩放幅度"].default_value;f3旋转幅度=self.inputs["旋转幅度"].default_value;
        iiCP长=len(self.cp随机PSR偏移);
        #----增加第壹段-------------------------------------------------------------
        if(iiCP长==0):
            pg=self.cp随机PSR偏移.add();
            for i in range(3):
                pg.fvp3初始loc[i]=数ΔΔ生成随机数(-f3位置幅度[i],f3位置幅度[i]);
                pg.fvp3初始scale[i]=数ΔΔ生成随机数(-f3缩放幅度[i],f3缩放幅度[i]);
                pg.fvp3初始euler[i]=数ΔΔ生成随机数(-f3旋转幅度[i],f3旋转幅度[i]);

            self.ip上段时刻=self.ip上段时刻+self.ip频率;

        #--------------------------------------------------------------------------
        ns输入=self.inputs["INPUT"];
        ns输入.ip接口开始时刻 = ns输入.links[0].from_socket.ip接口开始时刻;#从上一个节点时间为  开始
        # Tempo Final = Tempo Anterior + Duração
        ns下一个=self.outputs["OUTPUT"];
        ns下一个.ip接口开始时刻 = ns输入.ip接口开始时刻 + self.ip节点时间;#上个节点时间+本节点时间为本节点结束时刻

        #----检测是否有值传过来---------------------------------------------------------
        for s in ["START_LOC","START_SCALE","START_ROT","TIME"]:
            if (len(self.inputs[s].links) > 0):#有连接
                print("S==",s);
                n节点前面 = self.inputs[s].links[0].from_node;
                if (n节点前面.sp节点类型 == "BREAK"):
                    n节点前面.Δ升级节点();
                self.inputs[s].default_value = self.inputs[s].links[0].from_socket.default_value;#把对方的值 赋予自己
        #--------------------------------------------------------------------------


        f3开始loc = self.inputs["START_LOC"].default_value;
        f3开始scale = self.inputs["START_SCALE"].default_value;
        f3开始Rot = self.inputs["START_ROT"].default_value;

        #====在本节点时间内==============================================
        ns下一个=self.outputs["OUTPUT"];

        if(self.ip节点时间==0):
            self.ip节点时间=100000;
        ns下一个.ip接口开始时刻 = self.ip节点时间 + self.ip节点时间;#决定 本节点结束时间

        if (G.Li当前帧GG[0]> ns输入.ip接口开始时刻 and G.Li当前帧GG[0]<= ns下一个.ip接口开始时刻):
            #----在开始或将结束时  归零----------------------------------------------------
            if (G.Li当前帧GG[0]== ns输入.ip接口开始时刻+1 or G.Li当前帧GG[0]== ns下一个.ip接口开始时刻):
                self.ip当前段数=0;  self.ip当前CP数=0;#self.f3上一段位置=f3开始loc;self.f3上一段缩放=f3开始scale;self.f3上一段旋转=f3开始Rot;
                #print("START--------------------------------------------------------------",);
            #--------------------------------------------------------------------------
            i当前段时间=self.ip频率*(self.ip当前段数+self.iipCP限长*self.ip当前CP数+1);#至少有self.ip频率数
            #print("NOW_TIME==",G.Li当前帧GG[0],"SEC_TIME==",i当前段时间,"SEC==",self.ip当前段数);
            i当前段时刻=i当前段时间-(G.Li当前帧GG[0]-ns输入.ip接口开始时刻 );
            i当前段时刻Ξip频率=1-(i当前段时刻/self.ip频率);#这个值应该在0到1间
            print(i当前段时刻,"/==",i当前段时刻Ξip频率,"CP==",self.ip当前CP数);#,self.ip频率,self.ip当前段数
            if(self.ip当前段数==0):
                if(self.bp位置):self.f3上一段位置=f3开始loc;
                if(self.bp缩放):self.f3上一段缩放=f3开始scale;
                if(self.bp旋转):self.f3上一段旋转=f3开始Rot;
            #--------------------------------------------------------------------------
            for i in range(3):
                if(self.bp位置):
                    #print("iiCPlen==",iiCP长);
                    f当前段位置应=self.cp随机PSR偏移[self.ip当前段数].fvp3初始loc[i]+f3开始loc[i];#相对开始Loc的偏移
                    f乛段=f当前段位置应-self.f3上一段位置[i];
                    f当前帧偏移量=f乛段*i当前段时刻Ξip频率*f影响;
                    self.f3当前位置应[i]=f当前帧偏移量+self.f3上一段位置[i];
                    #if(i==2):#print(" SHOULD ==",self.f3当前位置应[i],"LAST==",self.f3上一段位置[i]);
                        #"LAST==",self.f3上一段位置[i]

                if(self.bp缩放):
                    f当前段缩放应=self.cp随机PSR偏移[self.ip当前段数].fvp3初始scale[i]+f3开始scale[i];
                    f乛段=f当前段缩放应-self.f3上一段缩放[i];
                    f当前帧偏移量=f乛段*i当前段时刻Ξip频率*f影响;
                    self.f3当前缩放应[i]=f当前帧偏移量+self.f3上一段缩放[i];

                if(self.bp旋转):
                    f当前段旋转应=self.cp随机PSR偏移[self.ip当前段数].fvp3初始euler[i]+f3开始Rot[i];
                    f乛段=f当前段旋转应-self.f3上一段旋转[i];
                    f当前帧偏移量=f乛段*i当前段时刻Ξip频率*f影响;
                    self.f3当前旋转应[i]=f当前帧偏移量+self.f3上一段旋转[i];

            #----在本段时间内赋值---------------------------------------------------------------
            if(G.Li当前帧GG[0]>i当前段时间):
                #----增加一段--------------------------------------------------------------
                if(iiCP长-1<=self.ip当前段数 and iiCP长<self.iipCP限长):
                    pg=self.cp随机PSR偏移.add();

                    if(iiCP长==(self.iipCP限长-1)):#最后一段
                        pg.fvp3初始loc=[0.0,0.0,0.0];
                        pg.fvp3初始scale=[0.0,0.0,0.0];
                        pg.fvp3初始euler=[0.0,0.0,0.0];
                    else:
                        for i in range(3):
                            pg.fvp3初始loc[i]=数ΔΔ生成随机数(-f3位置幅度[i],f3位置幅度[i]);
                            pg.fvp3初始scale[i]=数ΔΔ生成随机数(-f3缩放幅度[i],f3缩放幅度[i]);
                            pg.fvp3初始euler[i]=数ΔΔ生成随机数(-f3旋转幅度[i],f3旋转幅度[i]);

                    #print("ADD PG ");

                #--------------------------------------------------------------------------
                self.ip上段时刻=self.ip上段时刻+self.ip频率;
                #self.ip上段时刻=pg.ip本段时刻;
                self.ip当前段数+=1;
                #----另一个CP----------------------------------------------------------------
                #print("SEC&CP限长",self.ip当前段数,self.iipCP限长-1);
                if(self.ip当前段数>(self.iipCP限长-1)):#>9
                    #print("ADD_CP________");
                    self.ip当前CP数+=1;
                    self.ip当前段数=0;
                #--------------------------------------------------------------------------
                if(self.bp位置):
                    self.f3上一段位置=self.f3当前位置应;
                    #print("GIVE LAST==",self.f3当前位置应[2]);
                if(self.bp缩放):
                    self.f3上一段缩放=self.f3当前缩放应;
                if(self.bp旋转):
                    self.f3上一段旋转=self.f3当前旋转应;
            #======================================================
            if(self.bp位置):
                o.location=self.f3当前位置应;
                ##print("LOCATION==",o.location,self.ip当前段数);
            if(self.bp缩放):
                o.scale=self.f3当前缩放应;
                ##print("SCAL==",o.scale);
            if(self.bp旋转):
                o.rotation_euler=self.f3当前旋转应;
                #o.rotation_euler=[math.radians(self.f3当前旋转应[0]),math.radians(self.f3当前旋转应[1]),math.radians(self.f3当前旋转应[2])];
                ##print("ROTATION==",o.rotation_euler);

        #----过了本节点时间-执行下一节点的升级-----------------------------------------------
        if (G.Li当前帧GG[0]> ns下一个.ip接口开始时刻):
            for link in ns下一个.links:
               link.to_node.Δ升级节点(nt,n开始,o群父,o,i物序,i延时);
        #☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
        #☐☐☐☐☐☐第0段☐☐第1段☐☐第2段☐☐第3段☐第4段☐┃第0段☐☐第1段☐☐第2段☐☐第3段☐☐第4段☐☐☐☐☐☐☐☐☐☐
        #☐☐☐☐开始☐ip频率☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐    ┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐节点内时间结束☐☐☐☐☐☐☐☐☐
        #☐☐☐☐☐┃☐☐☐┃☐☐☐┃☐☐☐┃☐☐☐┃☐☐☐┃☐☐☐┃☐☐☐┃☐☐☐┃☐☐☐┃☐☐☐┃☐☐☐☐☐☐☐☐☐☐☐☐☐
        #☐━━━━╋━━━╋━━━╋━━━╋━━━╋━━━╋━━━╋━━━╋━━━╋━━━╋━━━╋━━━━→☐时间增加方向☐
        #☐☐☐☐☐┃☐☐☐●☐☐☐┃☐☐☐┃☐☐☐┃☐☐☐┃☐☐☐●☐☐☐┃☐☐☐┃☐☐☐┃☐☐☐┃☐☐☐☐☐☐☐☐☐☐
        #☐☐☐☐☐┃☐┄☐┊☐☐┃☐☐☐┃☐☐☐┃☐☐☐┃☐┄☐┊☐☐┃☐☐☐┃☐☐☐┃☐☐☐┃☐☐☐☐☐☐☐☐☐
        #☐☐☐☐☐○─━━━┇━━┃━━━┃━━━┃━━━●─━━━┇━━┃━━━┃━━━┃━━━●☐☐☐☐☐☐☐☐
        #☐☐☐☐☐☐☐☐☐☐☐┊☐┃☐☐☐●☐☐☐┃☐☐↗┃☐☐☐☐☐┊☐┃☐☐☐●☐☐☐┃☐☐↗☐☐☐☐☐☐
        #☐☐☐☐☐☐☐☐☐☐☐┇☐┃☐☐↗☐┅┈☐┃☐/☐┃☐☐☐☐☐┇☐┃☐☐↗☐┅┈☐┃☐/☐☐☐☐☐☐☐☐☐☐
        #☐☐☐☐☐☐☐☐☐☐☐☐┊┃☐/☐☐☐☐●/☐☐┃☐☐☐☐☐☐┊┃☐/☐☐☐☐●/☐☐☐☐☐☐☐☐☐☐
        #☐☐☐☐☐☐☐☐☐☐☐☐┃/☐☐☐☐☐☐☐☐☐☐┃☐☐☐☐☐☐┃/☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
        #☐☐☐☐☐☐☐☐☐☐☐☐☐●☐☐☐☐☐☐☐☐☐☐☐┃☐☐☐☐☐☐☐●☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
        #☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐一个cp结束☐☐☐☐☐☐☐☐

    def draw_buttons(self, context, layout):
        layout.prop(self, "ep插值类型", text = "");
        uil行=layout.row(align=False);
        uil行.prop(self, "bp位置", text = "位置",toggle=True,emboss=True);
        uil行.prop(self, "bp缩放", text = "缩放",toggle=True,emboss=True);
        uil行.prop(self, "bp旋转", text = "旋转",toggle=True,emboss=True);
        uil行=layout.row(align=False);
        uil行.prop(self,"ip种子",slider=True);uil行.prop(self,"iipCP限长",slider=False);
    # Detail buttons in the sidebar.
    #def draw_buttons_ext(self, context, layout):
        #pass;

#////////////////////////////////////////////////
class 卐运动缩放卐IMDJS_NODES(Node,卐IMDJS_NODES):
    bl_idname = 'IMDJS_NodeSetScale'
    bl_label = '设置缩放'
    #bl_icon = 'FORCE_VORTEX'

    bp本地 = BoolProperty(); # bp本地 0 == Absolute, bp本地 1 = Relative

    def init(self, context):
        #self.b使用回放颜色 = False;

        self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"INPUT");
        self.inputs.new("NodeSocketVectorXYZ","START_SCALE");
        self.inputs.new("NodeSocketVectorXYZ","END_SCALE");


        self.outputs.new(卐颜色接口卐NodeSocket.bl_idname,"OUTPUT");
        self.outputs.new("NodeSocketVectorXYZ","RESULT_SCALE");

    def Δ升级节点(self,nt,n开始,o群父,o,i物序,i延时):
        if(bΔΔ是禁用节点(nt,self,o群父,o,i延时) ):return ;

        ns本节点input= self.inputs["INPUT"];#print(">>>>>>",G.Li当前帧GG[0], self.ip实际帧 );
        i本节点开始时刻=ns本节点input.ip接口开始时刻 = ns本节点input.links[0].from_socket.ip接口开始时刻+i延时;
        if(ns本节点input.ip接口开始时刻!=i本节点开始时刻):
            ns本节点input.ip接口开始时刻=i本节点开始时刻;
        i运动时刻end=i本节点开始时刻+ self.ip节点时间;
        if(self.ip实际帧 !=i运动时刻end+self.ip停止时间):
            self.ip实际帧=i运动时刻end+self.ip停止时间;#上个节点时间+持续时间为本节点结束时间

        #----检测是否有值传过来---------------------------------------------------------
        ns最大值 = self.inputs["END_SCALE"];
        if (len(ns最大值.links) > 0):
            n节点前面 = ns最大值.links[0].from_node;
            if (n节点前面.sp节点类型 == "BREAK"): # Operadores já estão atualizados, Math e outros precisam atualizar
                n节点前面.Δ升级节点();
            pg记录.fvp3loc = ns最大值.links[0].from_socket.default_value;

        ns开始Loc输入 = self.inputs["START_SCALE"];
        if (len(ns开始Loc输入.links) > 0):
            n节点前面 = ns开始Loc输入.links[0].from_node;
            if (n节点前面.sp节点类型 == "BREAK"): # Operadores já estão atualizados, Math e outros precisam atualizar
                n节点前面.Δ升级节点();
            ns开始Loc输入.default_value = ns开始Loc输入.links[0].from_socket.default_value;

        Influence = self.inputs["INFLUENCE"];
        if (len(Influence.links) > 0):
            n节点前面 = Influence.links[0].from_node;
            if (n节点前面.sp节点类型 == "BREAK"): # Operadores já estão atualizados, Math e outros precisam atualizar
                n节点前面.Δ升级节点();
            Influence.default_value = Influence.links[0].from_socket.default_value;

        f3最大值 = [0,0,0];
        f开始Loc = ns开始Loc输入.default_value;


        if (not self.bp本地): # ABSOLUTE
            end = pg记录.fvp3loc;
            start = f开始Loc;
            f3最大值 =    [   (1-f影响)*start[0] + f影响 * end[0],(1-f影响)*start[1] + f影响 * end[1],(1-f影响)*start[2] + f影响 * end[2],];
        else:
            f3最大值 = [ (f开始Loc[0] + (pg记录.fvp3loc[0])), (f开始Loc[1] + (pg记录.fvp3loc[1])), (f开始Loc[2] + (pg记录.fvp3loc[2]))];

        #====在本节点时间内==============================================
        if (G.Li当前帧GG[0] > i本节点开始时刻 and G.Li当前帧GG[0] <= self.ip实际帧):
            o.scale = f3最大值;

            self.outputs["RESULT_SCALE"].default_value = f3最大值;

        if (G.Li当前帧GG[0] >i实际帧):
            for link in self.outputs["OUTPUT"].links:
                if(link.to_socket.identifier!="INPUT"):continue;
                link.to_node.Δ升级节点(nt,n开始,o群父,o,i物序,i延时);


    # Additional buttons displayed on the node.
    def draw_buttons(self, context, layout):
        layout.prop(self, "bp本地", text = "Relative");

    # Detail buttons in the sidebar.
    def draw_buttons_ext(self, context, layout):
        pass;

#////////////////////////////////////////////////
class 卐运动位置卐IMDJS_NODES(Node,卐IMDJS_NODES):
    bl_idname = 'IMDJS_NodeSetPosition'
    bl_label = '设置位置'
    #bl_icon = 'FORCE_VORTEX'


    bp本地 = BoolProperty() ;# bp本地 0 == Absolute, bp本地 1 = Relative
    #bp传位=BoolProperty(name='',description='',default=False,subtype='NONE',update=None,get=None,set=None);
    #======================================================
    def init(self, context):
        #self.b使用回放颜色 = False;


        self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"INPUT");
        """
        self.inputs.new("NodeSocketVectorXYZ","START_LOC");
        self.inputs.new("NodeSocketVectorXYZ","END_LOC");
        """


        self.outputs.new(卐颜色接口卐NodeSocket.bl_idname,"OUTPUT");
        #self.outputs.new("NodeSocketVectorXYZ","RESULT_LOC");

    # Atualiza o valor do 下一个 com o valor Absoluto
    def Δ升级节点(self,nt,n开始,o群父,o,i物序,i延时):
        if(bΔΔ是禁用节点(nt,self,o群父,o,i延时) ):return ;
        i本节点开始时刻=self.inputs["INPUT"].ip接口开始时刻 = self.inputs["INPUT"].links[0].from_node.ip节点时间;
        self.ip实际帧 = i本节点开始时刻+ self.ip节点时间;

        """
        if (self.bp传位):
            n节点前面 = ns最大值.links[0].from_node;
            if (n节点前面.sp节点类型 == "BREAK"): # Operadores já estão atualizados, Math e outros precisam atualizar
                n节点前面.Δ升级节点();
            pg记录.fvp3loc = ns最大值.links[0].from_socket.default_value;

        if (len(ns开始Loc输入.links) > 0):
            n节点前面 = ns开始Loc输入.links[0].from_node;
            if (n节点前面.sp节点类型 == "BREAK"): # Operadores já estão atualizados, Math e outros precisam atualizar
                n节点前面.Δ升级节点();
            ns开始Loc输入.default_value = ns开始Loc输入.links[0].from_socket.default_value;
        """
        Influence = self.inputs["INFLUENCE"];
        if (len(Influence.links) > 0):
            n节点前面 = Influence.links[0].from_node;
            if (n节点前面.sp节点类型 == "BREAK"): # Operadores já estão atualizados, Math e outros precisam atualizar
                n节点前面.Δ升级节点();
            Influence.default_value = Influence.links[0].from_socket.default_value;

        f3最大值 = [0,0,0];
        f开始Loc = ns开始Loc输入.default_value;


        if (not self.bp本地): # ABSOLUTE
            end = pg记录.fvp3loc;
            start = f开始Loc;

            f3最大值 =    [   (1-f影响)*start[0] + f影响 * end[0],(1-f影响)*start[1] + f影响 * end[1],(1-f影响)*start[2] + f影响 * end[2],];
        else:
            f3最大值 = [ (f开始Loc[0] + (pg记录.fvp3loc[0])),(f开始Loc[1] + (pg记录.fvp3loc[1])),(f开始Loc[2] + (pg记录.fvp3loc[2]))];

        if (G.Li当前帧GG[0] > i本节点开始时刻 and G.Li当前帧GG[0] <= self.ip实际帧):
            o.location = f3最大值;

        #self.outputs["RESULT_LOC"].default_value = f3最大值;

        if (G.Li当前帧GG[0] >i实际帧):
            for link in self.outputs["OUTPUT"].links:
                if(link.to_socket.identifier!="INPUT"):continue;
                link.to_node.Δ升级节点(nt,n开始,o群父,o,i物序,i延时);

    # Additional buttons displayed on the node.
    def draw_buttons(self, context, layout):
        layout.prop(self, "bp本地", text = "Relative");

    # Detail buttons in the sidebar.
    def draw_buttons_ext(self, context, layout):
        pass;

#//////////////////////////////////////////////////
class 卐运动旋转卐IMDJS_NODES(Node,卐IMDJS_NODES):
    bl_idname = 'IMDJS_NodeSetRotate'
    bl_label = '设置旋转'
    #bl_icon = 'FORCE_VORTEX'


    bp本地 = BoolProperty(); # bp本地 0 == Absolute, bp本地 1 = Relative

    def init(self, context):
        #self.b使用回放颜色 = False;


        self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"INPUT");
        self.inputs.new("NodeSocketVectorXYZ","START_ROT");
        self.inputs.new("NodeSocketVectorXYZ","END_ROT");


        self.outputs.new(卐颜色接口卐NodeSocket.bl_idname,"OUTPUT");
        self.outputs.new("NodeSocketVectorXYZ","RESULT_ROT");

    def Δ升级节点(self,nt,n开始,o群父,o,i物序,i延时):
        if(bΔΔ是禁用节点(nt,self,o群父,o,i延时) ):return ;
        i本节点开始时刻=self.inputs["INPUT"].ip接口开始时刻 = self.inputs["INPUT"].links[0].from_node.ip节点时间;
        self.ip实际帧 = i本节点开始时刻+ self.ip节点时间;

        ns最大值 = self.inputs["END_ROT"];
        if (len(ns最大值.links) > 0):
            n节点前面 = ns最大值.links[0].from_node;
            if (n节点前面.sp节点类型 == "BREAK"):
                n节点前面.Δ升级节点();
            pg记录.fvp3loc = ns最大值.links[0].from_socket.default_value;

        ns开始Loc输入 = self.inputs["START_ROT"];
        if (len(ns开始Loc输入.links) > 0):
            n节点前面 = ns开始Loc输入.links[0].from_node;
            if (n节点前面.sp节点类型 == "BREAK"): # Operadores já estão atualizados, Math e outros precisam atualizar
                n节点前面.Δ升级节点();
            ns开始Loc输入.default_value = ns开始Loc输入.links[0].from_socket.default_value;

        Influence = self.inputs["INFLUENCE"];
        if (len(Influence.links) > 0):
            n节点前面 = Influence.links[0].from_node;
            if (n节点前面.sp节点类型 == "BREAK"): # Operadores já estão atualizados, Math e outros precisam atualizar
                n节点前面.Δ升级节点();
            Influence.default_value = Influence.links[0].from_socket.default_value;

        f3最大值 = [0,0,0];
        f开始Loc = ns开始Loc输入.default_value;


        if (not self.bp本地): # ABSOLUTE
            end = pg记录.fvp3loc;
            start = f开始Loc;

            f3最大值 =    [   (1-f影响)*start[0] + f影响 * end[0],(1-f影响)*start[1] + f影响 * end[1],(1-f影响)*start[2] + f影响 * end[2],];
        else:
            f3最大值 = [ (f开始Loc[0] + (pg记录.fvp3loc[0])),(f开始Loc[1] + (pg记录.fvp3loc[1])), (f开始Loc[2] + (pg记录.fvp3loc[2]))];


        if (G.Li当前帧GG[0] > i本节点开始时刻 and G.Li当前帧GG[0] <= self.ip实际帧):
            o.rotation_euler = [  (math.radians(f3最大值[0])),(math.radians(f3最大值[1])),(math.radians(f3最大值[2]))];


            self.outputs["RESULT_ROT"].default_value = f3最大值;

        if (G.Li当前帧GG[0] >i实际帧):
            for link in self.outputs["OUTPUT"].links:
                if(link.to_socket.identifier!="INPUT"):continue;
                link.to_node.Δ升级节点(nt,n开始,o群父,o,i物序,i延时);

    # Additional buttons displayed on the node.
    def draw_buttons(self, context, layout):
        layout.prop(self, "bp本地", text = "Relative");

    # Detail buttons in the sidebar.
    def draw_buttons_ext(self, context, layout):
        pass;


#////////////////////////////////////////////////
class 卐运动轮子卐IMDJS_NODES(Node,卐IMDJS_NODES):
    bl_idname = 'IMDJS_NodeWheel'
    bl_label = '运动轮子'
    #bl_icon = 'FORCE_VORTEX'



    bp开始了本节点 = BoolProperty(name='',description='',default=False,subtype='NONE',update=None,get=None,set=None);

    fvp16父矩阵前帧=FloatVectorProperty(size=16);#(default=(None, None, None));
    fp子轮半径=FloatProperty(name='子轮半径',description='',default=0.1,min=0.0,max=10.0,soft_min=0.0,soft_max=10.0,step=3,precision=2,subtype='NONE',unit='NONE',update=None,get=None,set=None);

    ep父移动方向= EnumProperty( name="父移动方向", description="",items=  [("X","X","---","NONE",0),#(identifier, name, description, icon, number)
                                                                                               ("Y", "Y","---.","NONE",1),("Z", "Z","---.","NONE",2)  ],default="X");
    ep子旋转轴= EnumProperty( name="子旋转轴", description="",items=  [("X","X","---","NONE",0),#(identifier, name, description, icon, number)
                                                                                               ("Y", "Y","---.","NONE",1),("Z", "Z","---.","NONE",2)  ],default="X");

    sp本节点父名=StringProperty(name='',description='',default='',maxlen=0,subtype='NONE',update=None,get=None,set=None);


    #==============================================================
    def init(self, context):
        #self.b使用回放颜色 = False;

        self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"INPUT");
        self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"INPUT_PARENT");#作为计算依据

        self.outputs.new(卐颜色接口卐NodeSocket.bl_idname,"OUTPUT");
        self.outputs.new("NodeSocketVectorXYZ","输出父位置");


    #==============================================================
    def Δ升级节点多个(self,Do群父Lo子,Lo):
        #print("O==",o);
        if(bΔΔ是禁用节点(nt,self,o群父,o,i延时) ):return ;

        i本节点开始时刻=self.inputs["INPUT"].ip接口开始时刻 = self.inputs["INPUT"].links[0].from_node.ip节点时间;#从上一个节点时间为  开始

        if(self.ip节点时间==0 and  self.ip节点时间!=100000):
            self.ip节点时间=100000;
        self.ip实际帧 = i本节点开始时刻 +self.ip节点时间;#上个节点时间+持续时间为本节点结束时间

        #print("G.Li当前帧GG[0] ",G.Li当前帧GG[0],i本节点开始时刻 , self.ip实际帧);
        #====在本节点时间内==============================================
        G.Li当前帧GG[0]=scene.frame_current;
        if (G.Li当前帧GG[0] >= i本节点开始时刻 and G.Li当前帧GG[0] <= self.ip实际帧):
            #print("UPDATA",);
            #----找到父---------------------------------------------------------------
            if(self.inputs["INPUT_PARENT"].links):
                o父=None;#print("sp本节点父名==",self.sp本节点父名);
                if(self.sp本节点父名==""):
                    n群组输入=self.inputs["INPUT_PARENT"].links[0].from_node;
                    #print("G.LoN物GG==",G.LoN物GG);
                    Ls物名=n群组输入.cp群组物体.keys();
                    for s物名 in Ls物名:
                        if(s物名 in G.Ds物oGG):
                            o父=G.Ds物oGG[s物名];
                            self.sp本节点父名=s物名;
                            break;

                else:
                    o父=G.Ds物oGG.get(self.sp本节点父名);


                if(o父==None):
                    print("NO FATHER",);
                    if(self.sp本节点父名!=""):
                        self.sp本节点父名="";#清空
                    return ;

            else:
                print("NO LINKS",);
                return ;

            #----开始--只处理一次------------------------------------------------
            if(self.bp开始了本节点==False):
                for i,o in enumerate(Lo):
                    #o.pp物PSRo.fvp16矩阵父动态初始=f16ΔΔm转f16LIB(o父.matrix_world);
                    if(i==0):#只处理一次
                        self.fvp16父矩阵前帧=f16ΔΔm转f16LIB(o父.matrix_world);
                    o.pp物PSRo.iip长度当前缓存=0;o.pp物PSRo.cp缓存PSR.clear();
                    print("CLEAR  CACHE",o.name);

                self.bp开始了本节点=True;#开始了就一直开始
            #----计算mL并输出显示------------------------------------------------------
            m前帧=mΔΔf16转mLIB(self.fvp16父矩阵前帧);
            if(m前帧==o父.matrix_world):
                #print("FATHER NOT MOVING",m前帧,o父.name);#m前帧
                return ;
            m相对父L=m前帧.inverted()*o父.matrix_world;f3父位Now=Vector((m相对父L[0][3],m相对父L[1][3],m相对父L[2][3]));

            if(self.outputs["输出父位置"].links):
                self.outputs["输出父位置"].default_value=f3父位Now;
                #print("FATHER MOVE==",m前帧[0][3],o父.matrix_world[0][3],o父.location);

            self.fvp16父矩阵前帧=f16ΔΔm转f16LIB(o父.matrix_world);
            #----有缓存--------------------------------------------------------------
            i过了节点时刻多少帧=G.Li当前帧GG[0]- i本节点开始时刻 ;
            b有缓存此帧=False;
            for i,o in enumerate(Lo):
                ΔΔ隐藏或显示动画(o,True);#隐藏
                if(o.pp物PSRo.iip长度当前缓存 >i过了节点时刻多少帧):#单个物有缓存
                    o.rotation_quaternion=o.pp物PSRo.cp缓存PSR[i过了节点时刻多少帧].fvp4q;
                    #print("HAVE CACHE",i过了节点时刻多少帧,o.pp物PSRo.cp缓存PSR[i过了节点时刻多少帧].fvp4q);
                    if(b有缓存此帧==False):
                        b有缓存此帧=True;


            #----无缓存----------------------------------------------------------------
            if(b有缓存此帧==False):
                #----计算前帧相对现在距离---------------------------------------------------------
                if(self.ep父移动方向=="X"):
                    f移动距离=f3父位Now[0];
                elif(self.ep父移动方向=="Y"):
                    f移动距离=f3父位Now[1];
                elif(self.ep父移动方向=="Z"):
                    f移动距离=f3父位Now[2];


                f弧度转=f移动距离/self.fp子轮半径;#一个半径长为1 弧度
                #print("ROT==",o.name,f弧度转);#
                #if(o父.name=="FENG7"):#print("LEN==",o.name,f移动距离,self.fp子轮半径,f弧度转);

                if(self.ep子旋转轴=="X"):
                    f3转=(f弧度转, 0.0, 0.0);
                if(self.ep子旋转轴=="Y"):
                    f3转=(0.0, f弧度转, 0.0);
                if(self.ep子旋转轴=="Z"):
                    f3转=(0.0, 0.0, f弧度转);
                e=Euler(f3转, 'XYZ');
                #--------------------------------------------------------------------------
                for i,o in enumerate(Lo):
                    o.rotation_quaternion.rotate(e);
                    """"""
                    if(o.pp物PSRo.iip长度当前缓存 <=i过了节点时刻多少帧):#无缓存
                        pg新缓存=o.pp物PSRo.cp缓存PSR.add();
                        pg新缓存.fvp4q=o.rotation_quaternion;
                        o.pp物PSRo.iip长度当前缓存+=1;

                    #print("ROT==",o.name,e);
                #----输出显示--------------------------------------------------------------
                #if(self.outputs["输出父位置"].links):
                    #self.outputs["输出父位置"].default_value=f3父位Now;
                    #print("NOW==",m相对父L[0][3],m相对父L[1][3],m相对父L[2][3],o父.name);


                #print("M==",o父.matrix_world);
        #----在本节点时间之前或之后--------------------------------------------------------
        else:
            #if( o.pp物PSRo.bp开始了==True):o.pp物PSRo.bp开始了=False;#开始后就一直开始,直到手动刷新
            #----在本节点时间之前--------------------------------------------------------
            if (G.Li当前帧GG[0] < i本节点开始时刻):
                pass
    #==============================================================
    def  draw_buttons(self, context, layout):
        uil=layout.row(align=True);
        uil.prop(self, "ep父移动方向", text = "父移动方向");
        uil=layout.row(align=True);
        uil.prop(self, "ep子旋转轴", text = "子旋转轴");
        uil.prop(self, "fp子轮半径", text = "子轮半径",icon="MESH_CIRCLE",slider=True);
        uil=layout.row(align=False);
        uil.operator(operator=卐计算子轮半径卐Operator.bl_idname,text='计算子轮半径',text_ctxt='',translate=True,icon='NONE',emboss=True,icon_value=0);
        uil.operator(operator=卐清除子缓存卐Operator.bl_idname,text='清除子缓存',text_ctxt='',translate=True,icon='NONE',emboss=True,icon_value=0);

#==============================================================
class 卐计算子轮半径卐Operator(bpy.types.Operator):
    bl_idname = "op.imdjs_calculate_radius";
    bl_label = "计算子轮半径";
    bl_options={'UNDO'};
    bl_context='object';

    sp=StringProperty(name="注意", description="", default="你确定要计算子轮半径？");
    #--------------------------------------------------------------------------
    def draw(self, context):    self.layout.prop(self, "sp");

    def invoke(self, context, event):
        self.n=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="IMDJS_NodeWheel");
        return context.window_manager.invoke_props_dialog(self,300,50);#召唤

    def execute(self, context):
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();

        if(self.n!=None):
            n群组=nΔΔ找到群组节点(self.n);
            if(n群组!=None):
                b找到物=False;
                for s物名,o  in Ds物oGitems():
                    if(s物名 in n群组.cp群组物体.keys()):#只取一个子计算
                        print("S RADIUS==",s物名,o);
                        if(o.rotation_mode!="QUATERNION"):
                            o.rotation_mode="QUATERNION";
                            print("SET QUATERNION",);
                        #if(o.lock_rotation==(True,True,True)):
                        o.lock_rotation=(False,False,False);

                        if(b找到物==False):
                            if(self.n.ep子旋转轴=="X"):
                                self.n.fp子轮半径=(o.dimensions[1]+o.dimensions[2])/4;
                            elif(self.n.ep子旋转轴=="Y"):
                                self.n.fp子轮半径=(o.dimensions[0]+o.dimensions[2])/4;
                            elif(self.n.ep子旋转轴=="Z"):
                                self.n.fp子轮半径=(o.dimensions[0]+o.dimensions[1])/4;
                            print("RADIUS==",self.n.fp子轮半径);
                            b找到物=True;

                if(b找到物==False):
                #print("self.n.ip时刻成为父子==",o.pp物PSRo.ip时刻成为父子);
                    self.report({"ERROR"},"没有找到轮子");#"INFO" "ERROR" "DEBUG" "WARNING"
                    
#////////////////////////////////////////////////
class 卐PICK_PSR卐Operator(bpy.types.Operator):
    bl_idname = "op.pick_psr";
    bl_label = "pick_psr";
    bl_description= "get the PSR of active object and store in the node (act like key frame recording)"
    bl_options={'UNDO'};
    bl_context='object';

    sp=StringProperty(name="note!", description="", default="are you sure get the PSR of active object?");
    sp类型=StringProperty(name="type", description="", default="");
    nThis=None;
    #--------------------------------------------------------------------------
    def draw(self, context):    self.layout.prop(self, "sp");

    def invoke(self, context, event):
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();
        self.nThis=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        return context.window_manager.invoke_props_dialog(self,300,50);#召唤

    def execute(self, context):
        #o=context.active_object;
        o=None;
        if( self.nThis):
            bΔΔ是更新了场景(context.scene);
            
            n群组=nΔΔ找到群组节点( self.nThis);
            if(n群组!=None):
                for s物名,oG  in G.Ds物oGG.items():
                    if(s物名 in n群组.cp群组物体.keys()):
                        idx当前物ξ=n群组.cp群组物体.keys().index(s物名);
                        if(n群组.bp只激活物==True):
                            if(idx当前物ξ!=n群组.ip激活群组物体ξ):
                                continue;
                        #----少则add-------------------------------------------------------------
                        i缺了多少物=(idx当前物ξ+1)-len( self.nThis.cp物序此节点关键帧记录);
                        if(i缺了多少物>0):
                            for i in range(i缺了多少物):
                                pg关键帧记录= self.nThis.cp物序此节点关键帧记录.add();
                                #pg关键帧记录.name=s物名;
                            
                        pg关键帧记录=self.nThis.cp物序此节点关键帧记录[idx当前物ξ];
                        o=oG;
                        if(self.sp类型=="END_PSR"):
                            pg关键帧记录.fvp3loc= o.location;
                            pg关键帧记录.fvp3euler= o.rotation_euler;
                            pg关键帧记录.fvp3scale= o.scale;
                            self.report({"ERROR"},"set PSR  %s   %f  %f  %f"%(s物名,pg关键帧记录.fvp3loc[0],pg关键帧记录.fvp3loc[1],pg关键帧记录.fvp3loc[2]));
                            
                        else:
                            if(self.sp类型=="END_LOC"):
                                pg关键帧记录.fvp3loc= o.location;

                            elif(self.sp类型=="END_ROT"):
                                if(o.rotation_mode=="XYZ"):
                                    pg关键帧记录.fvp3euler= o.rotation_euler;
                                elif(o.rotation_mode=="QUATERNION"):
                                    pg关键帧记录.fvp4q= o.rotation_quaternion;

                            elif(self.sp类型=="END_SCALE"):
                                pg关键帧记录.fvp3scale= o.scale;

                            self.report({"ERROR"},"set loc   %s   %f  %f  %f"%(s物名,pg关键帧记录.fvp3loc[0],pg关键帧记录.fvp3loc[1],pg关键帧记录.fvp3loc[2]));#"INFO" "ERROR" "DEBUG" "WARNING"                            
                            
            ΔUPDATE时间( self.nThis, context);

        return {"FINISHED"};

#==============================================================
class 卐动画LOC卐IMDJS_NODES(Node,卐IMDJS_NODES_PSR):#  Node,卐IMDJS_NODES
    bl_idname = 'IMDJS_NodeLocation'
    bl_label = '♂LOC'
    #bl_icon = 'FORCE_VORTEX'

    #==============================================================
    def init(self, context):
        卐IMDJS_NODES_PSR. init(self, context);
        #self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"INPUT");#NodeSocket.bl_idname
        #self.inputs.new("NodeSocketVectorXYZ","END_LOC");

        #self.outputs.new(卐颜色接口卐NodeSocket.bl_idname,"OUTPUT");

        #self.label=self.name;self.use_custom_color=True;

    #====LOC=====================================================
    def Δ升级节点(self,nt,n开始,o群父,o,i物序,i延时):
        n节点前面,i运动时刻end,i超出时间,i本节点开始时刻,ns本节点input,b是禁用节点=self.Δ检查时间(nt,n开始,o群父,o,i延时);
        #print("over time==",i超出时间,G.Li当前帧GG[0],self.name);
        #print("i运动时刻end",i运动时刻end,"i本节点开始时刻",i本节点开始时刻,">>>>",G.Li当前帧GG[0]);
        i实际帧=self.ip实际帧+i延时;
        #====在本节点时间内==============================================
        if (i超出时间>0 and G.Li当前帧GG[0] <=i实际帧):
            n开始.spDebug=sΔΔ节点出错变色(self,(i物序>=len(self.cp物序此节点关键帧记录)),"!!!"+o.name+" not in self.cp物序此节点关键帧记录.keys");

            #----记录-----------------------------------------------------------------
            pg记录=self.cp物序此节点关键帧记录[i物序];
            if (not self.bp相对):
                f3最大值loc = pg记录.fvp3loc;
            else:
                f3最大值loc = [ (f3开始loc[0] + (pg记录.fvp3loc[0]))  ,  (f3开始loc[1] + (pg记录.fvp3loc[1]))  ,  (f3开始loc[2] + (pg记录.fvp3loc[2]))];

            #----前面传来的值---------------------------------------------------------------
            n节点前面loc = ns本节点input.links[0].from_node;
            while(n节点前面loc and n节点前面loc.bl_idname not in["IMDJS_NodeStart","IMDJS_NodeLocation","IMDJS_NodePSR"]):
                n节点前面loc=n节点前面loc.inputs["INPUT"].links[0].from_node;
            pg前面=n节点前面loc.cp物序此节点关键帧记录[i物序];
            f3开始loc= pg前面.fvp3loc;
            #----传递---------------------------------------------------------------
            n节点前面scale= ns本节点input.links[0].from_node;
            while(n节点前面scale and n节点前面scale.bl_idname not in["IMDJS_NodeStart","IMDJS_NodeScale","IMDJS_NodePSR"]):
                n节点前面scale=n节点前面scale.inputs["INPUT"].links[0].from_node;
            pg前面=n节点前面scale.cp物序此节点关键帧记录[i物序];
            f3开始scale= pg前面.fvp3scale;

            n节点前面rot = ns本节点input.links[0].from_node;
            while(n节点前面rot and n节点前面rot.bl_idname not in["IMDJS_NodeStart","IMDJS_NodeRotate","IMDJS_NodePSR"]):
                n节点前面rot=n节点前面rot.inputs["INPUT"].links[0].from_node;
            pg前面=n节点前面rot.cp物序此节点关键帧记录[i物序];
            if(o.rotation_mode=="XYZ"):
                f3开始euler= pg前面.fvp3euler;
            elif(o.rotation_mode=="QUATERNION"):
                f3开始euler= pg前面.fvp4q;
                
            #----CTYPE--------------------------------------------------------------                
            if(LIB.dllIMDJS==None):LIB.dllIMDJS=dllΔΔ载入dllLIB(LIB,"dllIMDJS",CLIB,CLIB64);
            cb刷新=(c_bool*1)(G.Lb是要刷新GG[0]);
            cf4最小值loc=(c_float*4)(f3开始loc[0],f3开始loc[1],f3开始loc[2]);cf4最大值loc=(c_float*4)(f3最大值loc[0],f3最大值loc[1],f3最大值loc[2]);cf3结果now=(c_float*3)();#cf3结果=(c_float*3)();
            s插值类型=self.ep插值类型.encode('gb2312'); 
            """"""
            LIB.dllIMDJS.Δ赋值PSR(c_void_p(o.as_pointer()),c_void_p(n开始.as_pointer()),-1,-1,G.Li当前帧GG[0]-i本节点开始时刻,3,(c_float*4)(f3开始scale[0],f3开始scale[1],f3开始scale[2]),"S",False);
            LIB.dllIMDJS.Δ赋值PSR(c_void_p(o.as_pointer()),c_void_p(n开始.as_pointer()),-1,-1,G.Li当前帧GG[0]-i本节点开始时刻,3,(c_float*4)(*f3开始euler),"R",False);
            
            #====运动时间内====================================================
            if (G.Li当前帧GG[0] <= i运动时刻end):
                #print(">>>> ",G.Li当前帧GG[0],"this input time==", i本节点开始时刻,"this OUTPUT time==", i运动时刻end);

                if(b是禁用节点==False and self.bp是循环==False):
                    #LIB.dllIMDJS.ΔΔ节点渐变色(c_void_p(bpy.context.screen.as_pointer()),c_void_p(self.as_pointer()),c_float(i超出时间),c_float(self.ip节点时间 ),False,cb刷新);
                    G.Lb是要刷新GG[0]=cb刷新[0];
                    
                #--------------------------------------------------------------------------
                LIB.dllIMDJS.ΔΔPSR插值(c_void_p(self.as_pointer()),i物序,self.ip从开始第几个节点,c_void_p(n开始.as_pointer()),c_void_p(o.as_pointer()),G.Li当前帧GG[0],self.ip节点时间,i本节点开始时刻,False,b是禁用节点,n开始.bp是曲线插值,cf4最小值loc,cf4最大值loc,self.ip指数,s插值类型,b"P",cf3结果now);

                if(o in G.Lo强制刷新物GG):
                    #scene.update();
                    o.location.x=cf3结果now[0];
                    #print("force<<<<",o.name);#√
            """"""
            #----停止时刻----------------------------------------------------------------
            if(G.Li当前帧GG[0] > i运动时刻end and G.Li当前帧GG[0] <=i实际帧):
                LIB.dllIMDJS.ΔΔPSR插值(c_void_p(self.as_pointer()),i物序,self.ip从开始第几个节点,c_void_p(n开始.as_pointer()),c_void_p(o.as_pointer()),i本节点开始时刻+self.ip节点时间,self.ip节点时间,i本节点开始时刻,False,b是禁用节点,n开始.bp是曲线插值,cf4最小值loc,cf4最大值loc,self.ip指数,s插值类型,b"P",cf3结果now);

        #====超出节点运动时间===============================================
        if (G.Li当前帧GG[0] > i运动时刻end):
            if(LIB.dllIMDJS==None):LIB.dllIMDJS=dllΔΔ载入dllLIB(LIB,"dllIMDJS",CLIB,CLIB64);

            #----超出节点-----------------------------------------------------------
            if (G.Li当前帧GG[0] >i实际帧):
                #LIB.dllIMDJS.ΔΔ节点渐变色(c_void_p(bpy.context.screen.as_pointer()),c_void_p(self.as_pointer()),c_float(),c_float(),True,(c_bool*1)(G.Lb是要刷新GG[0]));
                for link in self.outputs["OUTPUT"].links:
                    if(link.to_socket.identifier!="INPUT"):continue;
                    link.to_node.Δ升级节点(nt,n开始,o群父,o,i物序,i延时);
                   #print("UPDATE  ",G.Li当前帧GG[0] ,self.ip实际帧,self.name,"i运动时刻end=",i运动时刻end);
                if("NO_STOP" in self.outputs):
                    for link in self.outputs["NO_STOP"].links:
                        if(link.to_socket.identifier!="INPUT"):continue;
                        link.to_node.Δ升级节点(nt,n开始,o群父,o,i物序,i延时);

    #----LOC-----------------------------------------------------------------
    def draw_buttons(self, context, layout):
        uil行=layout.row(align=True);
        uil行.prop(self, "ip实际帧", text = "C");
        uil行.enabled=False;

        uil行=layout.row(align=True);
        uil行.prop(self, "ip指数", text = "pow");

        uil行=layout.row(align=False).split(percentage=0.7);
        #uil行.prop(self, "bp相对", text = "相对",toggle=True);
        uil行.prop(self, "bp是循环", text = "循环",toggle=True);
        uil行.prop(self, "bp是隐藏界面", text = "hide",toggle=True);
        if(self.bp是隐藏界面==False):
            uil行=layout.row(align=False);
            OP=uil行.operator(operator=卐PICK_PSR卐Operator.bl_idname,text='pick LOC',text_ctxt='',translate=True,icon='REC',emboss=True,icon_value=0);OP.sp类型="END_LOC";
            uil行.operator(operator=卐GOTO本节点尾卐Operator.bl_idname,text='GO',text_ctxt='',translate=True,icon='LOOP_FORWARDS',emboss=True,icon_value=0);

            uil行=layout.row(align=False).split(percentage=0.3, align=False);
            uil行.operator(operator=卐INSERT前面一个节点卐Operator.bl_idname,text='insert node',text_ctxt='',translate=True,icon='NODE_INSERT_OFF',emboss=True,icon_value=0);
            uil行.operator(operator=卐PICK_TIME卐Operator.bl_idname,text='pick_time',text_ctxt='',translate=True,icon='EYEDROPPER',emboss=True,icon_value=0);

            #--------------------------------------------------------------------------
            uil行 = layout.row(align=True );
            uil行.operator(卐画画选卐Operator.bl_idname, text='显', icon='GREASEPENCIL');
            uil行.operator(卐选择群组物体卐Operator.bl_idname, text='选', icon='RESTRICT_SELECT_OFF').bp是选=True;
            uil行.operator(卐选择群组物体卐Operator.bl_idname, text='反', icon='VISIBLE_IPO_OFF').bp是选=False;
        #----时间-------------------------------------------------------------------
        uil行 = layout.row(align=True );
        uil行.prop(data=self,property="ip停止时间",text='stopTIME',text_ctxt='',translate=True,icon='PAUSE',expand=False,slider=False,toggle=False,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);
        if(self.ip停止时间==0): uil行.active=False;
        else: uil行.active=True;
        layout.prop(self, "ip节点时间", text = "TIME",slider=False);

    def draw_buttons_ext(self, context, layout):
        pass;

#//////////////////////////////////////////////////
class 卐动画ROT卐IMDJS_NODES(Node,卐IMDJS_NODES_PSR):
    bl_idname = 'IMDJS_NodeRotate'
    bl_label = '♂ROT'
    #bl_icon = 'FORCE_VORTEX'

    #==============================================================
    def init(self, context):
        #self.b使用回放颜色 = False;
        卐IMDJS_NODES_PSR. init(self, context);
        #self.inputs.new("NodeSocketVectorXYZ","END_ROT");

    #--------------------------------------------------------------------------
    def Δ升级节点(self,nt,n开始,o群父,o,i物序,i延时):
        n节点前面,i运动时刻end,i超出时间,i本节点开始时刻,ns本节点input,b是禁用节点=self.Δ检查时间(nt,n开始,o群父,o,i延时);
        i实际帧=self.ip实际帧+i延时;
        #====在本节点时间内==============================================
        if (i超出时间>0 and G.Li当前帧GG[0] <=i实际帧):
            sΔΔ节点出错变色(self,(i物序>=len(self.cp物序此节点关键帧记录)),"!!!"+o.name+" not in self.cp物序此节点关键帧记录.keys");
            #----记录-----------------------------------------------------------------
            pg记录=self.cp物序此节点关键帧记录[i物序];
            if (not self.bp相对):
                f3最大值euler = pg记录.fvp3euler;
            else:
                f3最大值euler = [ (f3开始euler[0] + (pg记录.fvp3euler[0])),(f3开始euler[1] + (pg记录.fvp3euler[1])),(f3开始euler[2] + (pg记录.fvp3euler[2]))];
            #else:
                #sΔΔ节点出错变色(self,True,"wrong  node type to connect");                        
            #----前面传来值-------------------------------------------------------------
            n节点前面rot = ns本节点input.links[0].from_node;
            while(n节点前面rot and n节点前面rot.bl_idname not in["IMDJS_NodeStart","IMDJS_NodeRotate","IMDJS_NodePSR"]):
                n节点前面rot=n节点前面rot.inputs["INPUT"].links[0].from_node;
            pg前面=n节点前面rot.cp物序此节点关键帧记录[i物序];
            if(o.rotation_mode=="XYZ"):
                f3开始euler= pg前面.fvp3euler;
            elif(o.rotation_mode=="QUATERNION"):
                f3开始q= pg前面.fvp4q;
                
            #----传递---------------------------------------------------------------
            n节点前面loc= ns本节点input.links[0].from_node;
            while(n节点前面loc and n节点前面loc.bl_idname not in["IMDJS_NodeStart","IMDJS_NodeLocation","IMDJS_NodePSR"]):
                n节点前面loc=n节点前面loc.inputs["INPUT"].links[0].from_node;
            pg前面=n节点前面loc.cp物序此节点关键帧记录[i物序];
            f3开始loc= pg前面.fvp3loc;

            n节点前面scale= ns本节点input.links[0].from_node;
            while(n节点前面scale and n节点前面scale.bl_idname not in["IMDJS_NodeStart","IMDJS_NodeRotate","IMDJS_NodePSR"]):
                n节点前面scale=n节点前面scale.inputs["INPUT"].links[0].from_node;
            pg前面=n节点前面scale.cp物序此节点关键帧记录[i物序];
            f3开始scale= pg前面.fvp3scale;

            #----新建ctype----------------------------------------------------------------
            if(LIB.dllIMDJS==None):LIB.dllIMDJS=dllΔΔ载入dllLIB(LIB,"dllIMDJS",CLIB,CLIB64);
            cb刷新=(c_bool*1)(G.Lb是要刷新GG[0]);
            cf4最小值euler=(c_float*4)(f3开始euler[0],f3开始euler[1],f3开始euler[2]);cf4最大值euler=(c_float*4)(f3最大值euler[0],f3最大值euler[1],f3最大值euler[2]);#cf4结果=(c_float*4)();
            s插值类型=self.ep插值类型.encode('gb2312');#中文转字符
            cf4结果pass=(c_float*4)();
            
            LIB.dllIMDJS.Δ赋值PSR(c_void_p(o.as_pointer()),c_void_p(n开始.as_pointer()),-1,-1,G.Li当前帧GG[0]-i本节点开始时刻,3,(c_float*4)(*f3开始loc),"P",False);
            LIB.dllIMDJS.Δ赋值PSR(c_void_p(o.as_pointer()),c_void_p(n开始.as_pointer()),-1,-1,G.Li当前帧GG[0]-i本节点开始时刻,3,(c_float*4)(*f3开始scale),"S",False);

            #==============================================================
            if (G.Li当前帧GG[0] <= i运动时刻end):
                if(b是禁用节点==False and self.bp是循环==False):
                    #LIB.dllIMDJS.ΔΔ节点渐变色(c_void_p(bpy.context.screen.as_pointer()),c_void_p(self.as_pointer()),c_float(i超出时间),c_float(self.ip节点时间 ),False,cb刷新);
                    G.Lb是要刷新GG[0]=cb刷新[0];
                #--------------------------------------------------------------------------
  
                LIB.dllIMDJS.ΔΔPSR插值(c_void_p(self.as_pointer()),i物序,self.ip从开始第几个节点,c_void_p(n开始.as_pointer()),c_void_p(o.as_pointer()),G.Li当前帧GG[0],self.ip节点时间,i本节点开始时刻,False,b是禁用节点,n开始.bp是曲线插值,cf4最小值euler,cf4最大值euler,self.ip指数,s插值类型,b"R",cf4结果pass);

                if(o in G.Lo强制刷新物GG):
                    #scene.update();
                    o.location.x=cf3结果now[0];
            #----停止时刻----------------------------------------------------------------
            if(G.Li当前帧GG[0] > i运动时刻end and G.Li当前帧GG[0] <=i实际帧):
                LIB.dllIMDJS.ΔΔPSR插值(c_void_p(self.as_pointer()),i物序,self.ip从开始第几个节点,c_void_p(n开始.as_pointer()),c_void_p(o.as_pointer()),i本节点开始时刻+self.ip节点时间,self.ip节点时间,i本节点开始时刻,False,b是禁用节点,n开始.bp是曲线插值,cf4最小值euler,cf4最大值euler,self.ip指数,s插值类型,b"R",cf4结果pass);


        #====超出节点运动时间===============================================
        if (G.Li当前帧GG[0] > i运动时刻end):
            if(LIB.dllIMDJS==None):LIB.dllIMDJS=dllΔΔ载入dllLIB(LIB,"dllIMDJS",CLIB,CLIB64);

            #----超出节点-----------------------------------------------------------
            if (G.Li当前帧GG[0] >i实际帧):
                #LIB.dllIMDJS.ΔΔ节点渐变色(c_void_p(bpy.context.screen.as_pointer()),c_void_p(self.as_pointer()),c_float(),c_float(),True,(c_bool*1)(G.Lb是要刷新GG[0]));
                for link in self.outputs["OUTPUT"].links:
                    if(link.to_socket.identifier!="INPUT"):continue;
                    link.to_node.Δ升级节点(nt,n开始,o群父,o,i物序,i延时);

                if("NO_STOP" in self.outputs):
                    for link in self.outputs["NO_STOP"].links:
                        if(link.to_socket.identifier!="INPUT"):continue;
                        link.to_node.Δ升级节点(nt,n开始,o群父,o,i物序,i延时);

    #----PSR-----------------------------------------------------------------
    def draw_buttons(self, context, layout):
        uil行=layout.row(align=True);
        uil行.prop(self, "ip实际帧", text = "C");
        uil行.enabled=False;

        uil行=layout.row(align=False).split(percentage=0.7);
        uil行.prop(self, "ip指数", text = "pow");
        #uil行.prop(self, "bp相对", text = "Relative",toggle=True);
        uil行.prop(self, "bp是隐藏界面", text = "hide",toggle=True);
        if(self.bp是隐藏界面==False):
            uil行=layout.row(align=False);
            OP=uil行.operator(operator=卐PICK_PSR卐Operator.bl_idname,text='pick ROT',text_ctxt='',translate=True,icon='REC',emboss=True,icon_value=0);OP.sp类型="END_ROT";
            uil行.operator(operator=卐GOTO本节点尾卐Operator.bl_idname,text='GO',text_ctxt='',translate=True,icon='LOOP_FORWARDS',emboss=True,icon_value=0);
            uil行=layout.row(align=False).split(percentage=0.3, align=False);
            uil行.operator(operator=卐INSERT前面一个节点卐Operator.bl_idname,text='insert node',text_ctxt='',translate=True,icon='NODE_INSERT_OFF',emboss=True,icon_value=0);
            uil行.operator(operator=卐PICK_TIME卐Operator.bl_idname,text='pick_time',text_ctxt='',translate=True,icon='EYEDROPPER',emboss=True,icon_value=0);

            #----选择-------------------------------------------------------------
            uil行 = layout.row(align=True )
            uil行.operator(卐画画选卐Operator.bl_idname, text='显', icon='GREASEPENCIL');
            uil行.operator(卐选择群组物体卐Operator.bl_idname, text='选', icon='RESTRICT_SELECT_OFF').bp是选=True;
            uil行.operator(卐选择群组物体卐Operator.bl_idname, text='反', icon='VISIBLE_IPO_OFF').bp是选=False;
        #----时间-------------------------------------------------------------------
        uil行 = layout.row(align=True );
        uil行.prop(data=self,property="ip停止时间",text='stopTIME',text_ctxt='',translate=True,icon='PAUSE',expand=False,slider=False,toggle=False,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);
        if(self.ip停止时间==0): uil行.active=False;
        else: uil行.active=True;
        layout.prop(self, "ip节点时间", text = "TIME",slider=False);

    def draw_buttons_ext(self, context, layout):
        pass

#//////////////////////////////////////////////////
class 卐动画SCALE卐IMDJS_NODES(Node,卐IMDJS_NODES_PSR):
    bl_idname = 'IMDJS_NodeScale'
    bl_label = '♂SCALE'
    #bl_icon = 'FORCE_VORTEX'

    #==============================================================
    def init(self, context):
        卐IMDJS_NODES_PSR. init(self, context);
        #self.inputs.new("NodeSocketVectorXYZ","END_SCALE");
        #self.inputs["END_SCALE"].default_value = (1.0,1.0,1.0);

    def Δ升级节点(self,nt,n开始,o群父,o,i物序,i延时):
        n节点前面,i运动时刻end,i超出时间,i本节点开始时刻,ns本节点input,b是禁用节点=self.Δ检查时间(nt,n开始,o群父,o,i延时);
        i实际帧=self.ip实际帧+i延时;
        #====在本节点时间内==============================================
        if (i超出时间>0 and G.Li当前帧GG[0] <=i实际帧):
            sΔΔ节点出错变色(self,(i物序>=len(self.cp物序此节点关键帧记录)),"!!!"+o.name+" not in self.cp物序此节点关键帧记录.keys");

            #----记录-----------------------------------------------------------------
            pg记录=self.cp物序此节点关键帧记录[i物序];           
            if (not self.bp相对): # ABSOLUTE
                f3最大值Scale = pg记录.fvp3scale;
            else: # RELATIVE
                f3最大值Scale = [ (f3开始scale[0] + (pg记录.fvp3scale[0])),(f3开始scale[1] + (pg记录.fvp3scale[1])),(f3开始scale[2] + (pg记录.fvp3scale[2]))];   

            #----前面传来值-------------------------------------------------------------
            n节点前面scale = ns本节点input.links[0].from_node;
            while(n节点前面scale and n节点前面scale.bl_idname not in["IMDJS_NodeStart","IMDJS_NodeScale","IMDJS_NodePSR"]):
                n节点前面scale=n节点前面scale.inputs["INPUT"].links[0].from_node;
            pg前面=n节点前面scale.cp物序此节点关键帧记录[i物序];
            f3开始scale= pg前面.fvp3scale;
            
            #----传递---------------------------------------------------------------
            n节点前面loc= ns本节点input.links[0].from_node;
            while(n节点前面loc and n节点前面loc.bl_idname not in["IMDJS_NodeStart","IMDJS_NodeLocation","IMDJS_NodePSR"]):
                n节点前面loc=n节点前面loc.inputs["INPUT"].links[0].from_node;
            pg前面=n节点前面loc.cp物序此节点关键帧记录[i物序];
            f3开始loc= pg前面.fvp3loc;

            n节点前面rot = ns本节点input.links[0].from_node;
            while(n节点前面rot and n节点前面rot.bl_idname not in["IMDJS_NodeStart","IMDJS_NodeRotate","IMDJS_NodePSR"]):
                n节点前面rot=n节点前面rot.inputs["INPUT"].links[0].from_node;
            pg前面=n节点前面rot.cp物序此节点关键帧记录[i物序];
            if(o.rotation_mode=="XYZ"):
                f3开始euler= pg前面.fvp3euler;
            elif(o.rotation_mode=="QUATERNION"):
                f3开始euler= pg前面.fvp4q;
                
            #----新建ctype---------------------------------------------------------------
            if(LIB.dllIMDJS==None):LIB.dllIMDJS=dllΔΔ载入dllLIB(LIB,"dllIMDJS",CLIB,CLIB64);
            cb刷新=(c_bool*1)(G.Lb是要刷新GG[0]);
            cf4最小值scale=(c_float*4)(f3开始scale[0],f3开始scale[1],f3开始scale[2]);cf4最大值scale=(c_float*4)(f3最大值Scale[0],f3最大值Scale[1],f3最大值Scale[2]);#cf3结果=(c_float*3)();
            s插值类型=self.ep插值类型.encode('gb2312');cf3结果now=(c_float*3)();
            
            LIB.dllIMDJS.Δ赋值PSR(c_void_p(o.as_pointer()),c_void_p(n开始.as_pointer()),-1,-1,G.Li当前帧GG[0]-i本节点开始时刻,3,(c_float*4)(*f3开始loc),"P",False);
            LIB.dllIMDJS.Δ赋值PSR(c_void_p(o.as_pointer()),c_void_p(n开始.as_pointer()),-1,-1,G.Li当前帧GG[0]-i本节点开始时刻,3,(c_float*4)(*f3开始euler),"R",False);

            #====运动时间内===================================================
            if (G.Li当前帧GG[0] <= i运动时刻end):
                if(LIB.dllIMDJS==None):LIB.dllIMDJS=dllΔΔ载入dllLIB(LIB,"dllIMDJS",CLIB,CLIB64);
                if(b是禁用节点==False and self.bp是循环==False):
                    #LIB.dllIMDJS.ΔΔ节点渐变色(c_void_p(bpy.context.screen.as_pointer()),c_void_p(self.as_pointer()),c_float(i超出时间),c_float(self.ip节点时间 ),False,cb刷新);
                    G.Lb是要刷新GG[0]=cb刷新[0];
                #--------------------------------------------------------------------------
                LIB.dllIMDJS.ΔΔPSR插值(c_void_p(self.as_pointer()),i物序,0,c_void_p(n开始.as_pointer()),c_void_p(o.as_pointer()),G.Li当前帧GG[0],self.ip节点时间,i本节点开始时刻,False,b是禁用节点,n开始.bp是曲线插值,cf4最小值scale,cf4最大值scale,self.ip指数,s插值类型,b"S",cf3结果now);
                self.cp物序此节点关键帧记录[self.name].fvp3scale=cf3结果now;
                if(o in G.Lo强制刷新物GG):
                    #scene.update();
                    o.location.x=cf3结果now[0];
            #----停止时刻----------------------------------------------------------------
            if(G.Li当前帧GG[0] > i运动时刻end and G.Li当前帧GG[0] <=i实际帧):
                LIB.dllIMDJS.ΔΔPSR插值(c_void_p(self.as_pointer()),i物序,0,c_void_p(n开始.as_pointer()),c_void_p(o.as_pointer()),i本节点开始时刻+self.ip节点时间,self.ip节点时间,i本节点开始时刻,False,b是禁用节点,n开始.bp是曲线插值,cf4最小值scale,cf4最大值scale,self.ip指数,s插值类型,b"S",cf3结果now);

        #====超出节点运动时间===============================================
        if (G.Li当前帧GG[0] > i运动时刻end):

            #----超出节点-----------------------------------------------------------
            if (G.Li当前帧GG[0] >i实际帧):
                if(LIB.dllIMDJS==None):LIB.dllIMDJS=dllΔΔ载入dllLIB(LIB,"dllIMDJS",CLIB,CLIB64);
                #LIB.dllIMDJS.ΔΔ节点渐变色(c_void_p(bpy.context.screen.as_pointer()),c_void_p(self.as_pointer()),c_float(),c_float(),True,(c_bool*1)(G.Lb是要刷新GG[0]));
                for link in self.outputs["OUTPUT"].links:
                    if(link.to_socket.identifier!="INPUT"):continue;
                    link.to_node.Δ升级节点(nt,n开始,o群父,o,i物序,i延时);

                if("NO_STOP" in self.outputs):
                    for link in self.outputs["NO_STOP"].links:
                        if(link.to_socket.identifier!="INPUT"):continue;
                        link.to_node.Δ升级节点(nt,n开始,o群父,o,i物序,i延时);

    #====LAYOUT=====================================================
    def draw_buttons(self, context, layout):
        uil行=layout.row(align=True);
        uil行.prop(self, "ip实际帧", text = "C");
        uil行.enabled=False;

        uil行=layout.row(align=False).split(percentage=0.7);
        uil行.prop(self, "ip指数", text = "pow");
        #uil行.prop(self, "bp相对", text = "Relative",toggle=True);
        uil行.prop(self, "bp是隐藏界面", text = "hide",toggle=True);
        if(self.bp是隐藏界面==False):
            uil行=layout.row(align=False);
            OP=uil行.operator(operator=卐PICK_PSR卐Operator.bl_idname,text='pick SCALE',text_ctxt='',translate=True,icon='REC',emboss=True,icon_value=0);OP.sp类型="END_SCALE";
            uil行.operator(operator=卐GOTO本节点尾卐Operator.bl_idname,text='GO',text_ctxt='',translate=True,icon='LOOP_FORWARDS',emboss=True,icon_value=0)
            uil行=layout.row(align=False).split(percentage=0.3, align=False);
            uil行.operator(operator=卐INSERT前面一个节点卐Operator.bl_idname,text='insert node',text_ctxt='',translate=True,icon='NODE_INSERT_OFF',emboss=True,icon_value=0);
            uil行.operator(operator=卐PICK_TIME卐Operator.bl_idname,text='pick_time',text_ctxt='',translate=True,icon='EYEDROPPER',emboss=True,icon_value=0);

            #--------------------------------------------------------------------------
            uil行 = layout.row(align=True )
            uil行.operator(卐画画选卐Operator.bl_idname, text='显', icon='GREASEPENCIL');
            uil行.operator(卐选择群组物体卐Operator.bl_idname, text='选', icon='RESTRICT_SELECT_OFF').bp是选=True;
            uil行.operator(卐选择群组物体卐Operator.bl_idname, text='反', icon='VISIBLE_IPO_OFF').bp是选=False;
        #----时间-------------------------------------------------------------------
        uil行 = layout.row(align=True );
        uil行.prop(data=self,property="ip停止时间",text='stopTIME',text_ctxt='',translate=True,icon='PAUSE',expand=False,slider=False,toggle=False,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);
        if(self.ip停止时间==0): uil行.active=False;
        else: uil行.active=True;
        layout.prop(self, "ip节点时间", text = "TIME",slider=False);

    def draw_buttons_ext(self, context, layout):
        pass;

#///////////////////////////////////////////////
class 卐动画PSR卐IMDJS_NODES(Node,卐IMDJS_NODES_PSR):
    bl_idname = 'IMDJS_NodePSR'
    bl_label = '♂PSR'
    #bl_icon = 'FORCE_VORTEX'

    bp不loc = BoolProperty(name='',description='not execute location',default=False,subtype='NONE',update=None,get=None,set=None);
    bp不rot = BoolProperty(name='',description='not execute rotation',default=False,subtype='NONE',update=None,get=None,set=None);
    bp不scale = BoolProperty(name='',description='not execute scale',default=True,subtype='NONE',update=None,get=None,set=None);

    #bp是隐藏面板= BoolProperty(name='',description='hide template',default=True,subtype='NONE',update=None,get=None,set=None);
    #==============================================================
    def init(self, context):
        #self.b使用回放颜色 = False;
        卐IMDJS_NODES_PSR.init(self, context);
        """
        self.inputs.new("NodeSocketVectorXYZ","END_LOC");
        self.inputs.new("NodeSocketVectorXYZ","END_ROT");
        self.inputs.new("NodeSocketVectorXYZ","END_SCALE");

        self.inputs["END_SCALE"].default_value = (1.0,1.0,1.0);
        """
        #----初始化值--------------------------------------------------------------
        self.bp不loc=self.bp不rot=False;self.bp不scale=True;

    def Δ升级节点(self,nt,n开始,o群父,o,i物序,i延时):
        n节点前面,i运动时刻end,i超出时间,i本节点开始时刻,ns本节点input,b是禁用节点=self.Δ检查时间(nt,n开始,o群父,o,i延时);
        #print("over time==",i超出时间,G.Li当前帧GG[0],self.name);
        if(self.bp是循环 and self.ep开始结束=="START"):
            self.bp是循环=True;
        #print("time==",i超出时间,self.ip节点时间,i运动时刻end)
        i实际帧=self.ip实际帧+i延时;
        #====在本节点时间内==============================================
        if (i超出时间>0 and G.Li当前帧GG[0] <=i实际帧):
            #print("iDelay = %d  iEnd ==%d   iPass ==%d   iStart==%d    name ==%s   o ==%s"%(i延时,i运动时刻end,i超出时间,i本节点开始时刻,self.label,o.name));
            sΔΔ节点出错变色(self,(i物序>=len(self.cp物序此节点关键帧记录)),"!!!"+o.name+" not in self.cp物序此节点关键帧记录.keys");
            
            #----记录-----------------------------------------------------------------
            pg记录=self.cp物序此节点关键帧记录[i物序];
            if (not self.bp相对):
                f3最大值loc = pg记录.fvp3loc;f3最大值euler = pg记录.fvp3euler;f3最大值Scale = pg记录.fvp3scale;

            else:
                f3最大值loc = [ (f3开始loc[0] + (pg记录.fvp3loc[0])),(f3开始loc[1] + (pg记录.fvp3loc[1])),(f3开始loc[2] + (pg记录.fvp3loc[2]))];
                f3最大值euler = [ (f3开始euler[0] + (pg记录.fvp3euler[0])),(f3开始euler[1] + (pg记录.fvp3euler[1])),(f3开始euler[2] + (pg记录.fvp3euler[2]))];
                f3最大值Scale = [ (f3开始scale[0] + (pg记录.fvp3scale[0])),(f3开始scale[1] + (pg记录.fvp3scale[1])),(f3开始scale[2] + (pg记录.fvp3scale[2]))];
            #----前面传来值-------------------------------------------------------------
            if(not self.bp不loc):
                n节点前面loc = ns本节点input.links[0].from_node;
                while(n节点前面loc and n节点前面loc.bl_idname not in["IMDJS_NodeLocation","IMDJS_NodePSR","IMDJS_NodeStart"]):
                    n节点前面loc=n节点前面loc.inputs["INPUT"].links[0].from_node;
                f3开始loc= n节点前面loc.cp物序此节点关键帧记录[i物序].fvp3loc;
                
            if(not self.bp不scale):
                n节点前面scale = ns本节点input.links[0].from_node;
                while(n节点前面scale and n节点前面scale.bl_idname not in["IMDJS_NodeScale","IMDJS_NodePSR","IMDJS_NodeStart"]):
                    n节点前面scale=n节点前面scale.inputs["INPUT"].links[0].from_node;
                f3开始scale= n节点前面scale.cp物序此节点关键帧记录[i物序].fvp3scale;
                
            if(not self.bp不rot):
                n节点前面rot = ns本节点input.links[0].from_node;
                while(n节点前面rot and n节点前面rot.bl_idname not in["IMDJS_NodeRotate","IMDJS_NodePSR","IMDJS_NodeStart"]):
                    n节点前面rot=n节点前面rot.inputs["INPUT"].links[0].from_node;
                if(o.rotation_mode=="XYZ"):
                    f3开始euler= n节点前面rot.cp物序此节点关键帧记录[i物序].fvp3euler;
                elif(o.rotation_mode=="QUATERNION"):
                    f3开始euler= n节点前面rot.cp物序此节点关键帧记录[i物序].fvp4q;#●●暂时q当e来传
                    
            #----CTYPE----------------------------------------------------------------
            if(LIB.dllIMDJS==None):LIB.dllIMDJS=dllΔΔ载入dllLIB(LIB,"dllIMDJS",CLIB,CLIB64);
            
            cb刷新=(c_bool*1)(G.Lb是要刷新GG[0]);
            if(not self.bp不loc):
                cf4最小值loc=(c_float*4)(f3开始loc[0],f3开始loc[1],f3开始loc[2]);cf4最大值loc=(c_float*4)(f3最大值loc[0],f3最大值loc[1],f3最大值loc[2]);#cf3结果=(c_float*3)();
                s插值类型=self.ep插值类型.encode('gb2312');cf3结果now=(c_float*3)();
            if(not self.bp不scale):
                cf4最小值scale=(c_float*4)(f3开始scale[0],f3开始scale[1],f3开始scale[2]);cf4最大值scale=(c_float*4)(f3最大值Scale[0],f3最大值Scale[1],f3最大值Scale[2]);#cf3结果=(c_float*3)();
                s插值类型=self.ep插值类型.encode('gb2312');
            if(not self.bp不rot):
                cf4最小值euler=(c_float*4)(f3开始euler[0],f3开始euler[1],f3开始euler[2]);cf4最大值euler=(c_float*4)(f3最大值euler[0],f3最大值euler[1],f3最大值euler[2]);#cf4结果=(c_float*4)();
                s插值类型=self.ep插值类型.encode('gb2312');cf4结果pass=(c_float*4)();
            #==============================================================
            if (G.Li当前帧GG[0] <= i运动时刻end):
                #print("time==",i超出时间,self.ip节点时间,i运动时刻end);
                #f比例= i超出时间/self.ip节点时间;
                #self.color=( f比例, f比例,0.0);
                #print("color=",self.color);#Χ 打印颜色会出错?
                #ΔΔ节点渐变色(self,i超出时间,self.ip节点时间,False);
                if(b是禁用节点==False and self.bp是循环==False):
                    #LIB.dllIMDJS.ΔΔ节点渐变色(c_void_p(bpy.context.screen.as_pointer()),c_void_p(self.as_pointer()),c_float(i超出时间),c_float(self.ip节点时间 ),False,cb刷新);
                    G.Lb是要刷新GG[0]=cb刷新[0];

                #if(n开始.bp是曲线插值):print("self.ip从开始第几个节点==",self.ip从开始第几个节点, G.Li当前帧GG[0] ,self.label);
                """  """
                if(not self.bp不loc):
                    LIB.dllIMDJS.ΔΔPSR插值(c_void_p(self.as_pointer()),i物序,self.ip从开始第几个节点,c_void_p(n开始.as_pointer()),c_void_p(o.as_pointer()),G.Li当前帧GG[0],self.ip节点时间,i本节点开始时刻,False,b是禁用节点,n开始.bp是曲线插值,cf4最小值loc,cf4最大值loc,self.ip指数,s插值类型,b"P",cf3结果now);

                
                if(not self.bp不scale):
                    LIB.dllIMDJS.ΔΔPSR插值(c_void_p(self.as_pointer()),i物序,0,c_void_p(n开始.as_pointer()),c_void_p(o.as_pointer()),G.Li当前帧GG[0],self.ip节点时间,i本节点开始时刻,False,b是禁用节点,n开始.bp是曲线插值,cf4最小值scale,cf4最大值scale,self.ip指数,s插值类型,b"S",cf3结果now);
                
                if(not self.bp不rot):
                    LIB.dllIMDJS.ΔΔPSR插值(c_void_p(self.as_pointer()),i物序,self.ip从开始第几个节点,c_void_p(n开始.as_pointer()),c_void_p(o.as_pointer()),G.Li当前帧GG[0],self.ip节点时间,i本节点开始时刻,False,b是禁用节点,n开始.bp是曲线插值,cf4最小值euler,cf4最大值euler,self.ip指数,s插值类型,b"R",cf4结果pass);#print("cf4结果pass",G.Li当前帧GG[0] ,*cf4最小值euler,*cf4最大值euler,*cf4结果pass);

                if(o in G.Lo强制刷新物GG):
                    #scene.update();
                    o.location.x=cf3结果now[0];
                    
            #----停止时刻----------------------------------------------------------------
            if(G.Li当前帧GG[0] > i运动时刻end and G.Li当前帧GG[0] <=i实际帧):
                if(not self.bp不loc):
                    LIB.dllIMDJS.ΔΔPSR插值(c_void_p(self.as_pointer()),i物序,self.ip从开始第几个节点,c_void_p(n开始.as_pointer()),c_void_p(o.as_pointer()),i本节点开始时刻+self.ip节点时间,self.ip节点时间,i本节点开始时刻,False,b是禁用节点,n开始.bp是曲线插值,cf4最小值loc,cf4最大值loc,self.ip指数,s插值类型,b"P",cf3结果now);
                if(not self.bp不scale):
                        LIB.dllIMDJS.ΔΔPSR插值(c_void_p(self.as_pointer()),i物序,0,c_void_p(n开始.as_pointer()),c_void_p(o.as_pointer()),i本节点开始时刻+self.ip节点时间,self.ip节点时间,i本节点开始时刻,False,b是禁用节点,n开始.bp是曲线插值,cf4最小值scale,cf4最大值scale,self.ip指数,s插值类型,b"S",cf3结果now);
                if(not self.bp不rot):
                    LIB.dllIMDJS.ΔΔPSR插值(c_void_p(self.as_pointer()),i物序,self.ip从开始第几个节点,c_void_p(n开始.as_pointer()),c_void_p(o.as_pointer()),i本节点开始时刻+self.ip节点时间,self.ip节点时间,i本节点开始时刻,False,b是禁用节点,n开始.bp是曲线插值,cf4最小值euler,cf4最大值euler,self.ip指数,s插值类型,b"R",cf4结果pass);
                    
        #====超出节点运动时间===============================================
        if (G.Li当前帧GG[0] > i运动时刻end):
            if(LIB.dllIMDJS==None):LIB.dllIMDJS=dllΔΔ载入dllLIB(LIB,"dllIMDJS",CLIB,CLIB64);
 
            #----超出节点-----------------------------------------------------------
            if (G.Li当前帧GG[0] >i实际帧):
                #LIB.dllIMDJS.ΔΔ节点渐变色(c_void_p(bpy.context.screen.as_pointer()),c_void_p(self.as_pointer()),c_float(),c_float(),True,(c_bool*1)(G.Lb是要刷新GG[0]));
                for link in self.outputs["OUTPUT"].links:
                    if(link.to_socket.identifier!="INPUT"):continue;
                    link.to_node.Δ升级节点(nt,n开始,o群父,o,i物序,i延时);
                    """
                    if(link.to_node.use_custom_color):
                        link.to_node.use_custom_color=False;
                    """
                if("NO_STOP" in self.outputs):
                    for link in self.outputs["NO_STOP"].links:
                        if(link.to_socket.identifier!="INPUT"):continue;
                        link.to_node.Δ升级节点(nt,n开始,o群父,o,i物序,i延时);

    #-------------------------------------------------------------------------
    def draw_buttons(self, context, layout):
        uil行=layout.row(align=True);
        uil行.prop(self, "ip实际帧", text = "C");
        uil行.enabled=False;

        uil行=layout.row(align=True);
        uil行.prop(self, "ip指数", text = "pow");

        """
        #----TEST------------------------------------------------------------------
        uil行=layout.row(align=True);
        ns本节点input= self.inputs["INPUT"];
        uil行.prop(ns本节点input, "ip接口开始时刻", text = "节口时刻");
        """
        #--------------------------------------------------------------------------
        uil行=layout.row(align=False).split(percentage=0.7);
        #uil行.prop(self, "bp相对", text = "Relative",toggle=True);
        uil行.prop(self, "bp是循环", text = "循环",toggle=True);
        if(self.bp是循环):
            if(self.ep开始结束=="START"):
                uil行.prop(self, "ip循环次数", text = "num",);
            uil行=layout.row(align=True);
            uil行.prop(self, "ep开始结束", text = "type",toggle=True);
        uil行.prop(self, "bp是隐藏界面", text = "hide",toggle=True);
        #--------------------------------------------------------------------------
        if(self.bp是隐藏界面==False):
            uil行=layout.row(align=True);
            uil行.prop(self, "bp不loc", text = "X P",toggle=True);uil行.prop(self, "bp不rot", text = "X R",toggle=True);uil行.prop(self, "bp不scale", text = "X S",toggle=True);#uil行.prop(self, "bp是隐藏面板", text = "hide",toggle=False);
            """
            L=self.inputs["END_LOC"];R=self.inputs["END_ROT"];S=self.inputs["END_SCALE"];
            if(self.bp是隐藏面板):
                L.hide=R.hide=S.hide=True;
            else:
                L.hide=R.hide=S.hide=False;
            """

            uil行=layout.row(align=False);
            OP=uil行.operator(operator=卐PICK_PSR卐Operator.bl_idname,text='pick PSR',text_ctxt='',translate=True,icon='REC',emboss=True,icon_value=0);OP.sp类型="END_PSR";
            uil行.operator(operator=卐GOTO本节点尾卐Operator.bl_idname,text='GO',text_ctxt='',translate=True,icon='LOOP_FORWARDS',emboss=True,icon_value=0)
            uil行=layout.row(align=False).split(percentage=0.3, align=False);
            uil行.operator(operator=卐INSERT前面一个节点卐Operator.bl_idname,text='insert node',text_ctxt='',translate=True,icon='NODE_INSERT_OFF',emboss=True,icon_value=0);
            uil行.operator(operator=卐PICK_TIME卐Operator.bl_idname,text='pick_time',text_ctxt='',translate=True,icon='EYEDROPPER',emboss=True,icon_value=0);

            #--------------------------------------------------------------------------
            uil行 = layout.row(align=True )
            uil行.operator(卐画画选卐Operator.bl_idname, text='显', icon='GREASEPENCIL');
            uil行.operator(卐选择群组物体卐Operator.bl_idname, text='选', icon='RESTRICT_SELECT_OFF').bp是选=True;
            uil行.operator(卐选择群组物体卐Operator.bl_idname, text='反', icon='VISIBLE_IPO_OFF').bp是选=False;
        #----时间-------------------------------------------------------------------
        uil行 = layout.row(align=True );
        uil行.prop(data=self,property="ip停止时间",text='stopTIME',text_ctxt='',translate=True,icon='PAUSE',expand=False,slider=False,toggle=False,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);
        if(self.ip停止时间==0): uil行.active=False;
        else: uil行.active=True;
        layout.prop(self, "ip节点时间", text = "TIME",slider=False);

    def draw_buttons_ext(self, context, layout):
        pass;


        return {"FINISHED"};

#/////////////////////////////////////////////////
D目录={"NodeCategory":["IMDJS_NodeCategoryPSR","PSR"]};
Ls条项=[卐动画PSR卐IMDJS_NODES.bl_idname,卐动画LOC卐IMDJS_NODES.bl_idname,卐动画SCALE卐IMDJS_NODES.bl_idname,卐动画ROT卐IMDJS_NODES.bl_idname,];

#////end////end////end////end////end////end////end////end////






