import bpy
from bpy.props import*
from bpy.types import NodeTree, Node,NodeSocket

#from IMDJS_nodes_m.function_node import  ΔUPDATE时间,ΔΔUPDATE激活的预置名,bΔΔ是禁用节点#Χ
from IMDJS_nodes_m.operator_node import * #ΔUPDATE时间,ΔΔUPDATE激活的预置名,bΔΔ是禁用节点#√
#////////////////////////////////////////////////

# SOCKETS ------------------------------------------------------------------
class 卐颜色接口卐NodeSocket(NodeSocket):
    bl_idname = "IMDJS_NodeSocket"
    bl_label = "Next"

    t3颜色 = (1.0, 0.4, 0.216, 0.5);
    ip接口开始时刻=IntProperty(name='',description='',default=0,min=0,max=10000,step=1);#●●必须要初始化 不然在C++里会出错
    #def __init__(self):
        #self["i接口时刻"]=0;

    def draw(self, context, layout, node, text):
        #layout.prop(self,"ip接口开始时刻")
        layout.label(text);

    def draw_color(self, context, node):
        return (1.0, 1.0, 0.0, 1.0);

# NODE TREE ------------------------------------------------
class 卐IMDJS_nodes(NodeTree):
    bl_idname = "imdjs_nodes"
    bl_label = "IMDJS_Nodes"
    bl_icon = 'FORCE_VORTEX'
    """
    @classmethod
    def poll(cls, context):#是否在节点头显示插件
        return True;

    @classmethod
    def get_from_context(context):
        #print("get_from_context",);
        return (bpy.data.node_groups[0], None, None);

    """
#//////////////////////////////////////////////////

class 卐IMDJS_NODES():
    bp是禁用节点=BoolProperty(default = False);
    sp节点类型=StringProperty(name='type',description='',default='IMDJS_NODES',maxlen=0,subtype='NONE',update=None,get=None,set=None);
    """
    fvp3loc = FloatVectorProperty(size=3,default=( 0.0, 0.0,0.0));
    cp物序此节点关键帧记录=CollectionProperty(type=卐PSR记录卐PropertyGroup,name='传递PSR',description='');
    fvp3euler = FloatVectorProperty(size=3,default=( 0.0, 0.0,0.0));
    fvp4q = FloatVectorProperty(size=4,default=(1.0, 0.0, 0.0,0.0));
    fvp3scale = FloatVectorProperty(size=3,default=( 1.0, 1.0,1.0));
    """
    cp物序此节点关键帧记录=CollectionProperty(type=卐PSR记录卐PropertyGroup,name='记录PSR',description='');
    #----循环-----------------------------------------------------------------
    bp是循环= BoolProperty(name='cycle',description='cycle',default=False,update=ΔΔUPDATE循环);
    bp是隐藏界面= BoolProperty(name='hide',description='hide layout',default=False,update=None);
    ip循环次数=IntProperty(name='num',description='num of cycle',default=1,min=1,max=10000,step=1,update=None);
    ep开始结束=EnumProperty(name='type',description='type',items=[('START','start','--','PLAY',0),('END','end','--','PAUSE',1)],default='START',update=None);
    #ep开始结束 = EnumProperty( name='type', description='type',items=  [('OBJECT','物体模式','---','PLAY',0),('MODIFIER', '修改器模式','---.','PAUSE',1)  ],default='OBJECT');
    #----时间---------------------------------------------------------------
    ip实际帧=IntProperty(name='',description='current node frame',default=0,min=0,max=100000,step=1,subtype='NONE',update=None);

    ip节点时间=IntProperty(name='',description='the node duration time',default=1,min=0,max=50000,step=1,subtype='NONE',update=ΔUPDATE时间);
    ip停止时间=IntProperty(name='',description='how long to stop before updating next node',default=0,min=0,max=5000,step=1,subtype='NONE',update=ΔUPDATE时间,get=None,set=None);
    #--------------------------------------------------------------------------
    ip从开始第几个节点=IntProperty(default=-1);
    #--------------------------------------------------------------------------
    fp影响=FloatProperty(name='influence',description='influence',default=1.0,min=0.0,max=1.0,step=3,precision=2,subtype='NONE',unit='NONE',update=None,get=None,set=None);

    @classmethod
    def poll(cls, ntree):
        return True;
        #return (ntree.bl_idname == IMDJS_nodes_m.bl_idname);

    def init(self, context):
        self.use_custom_color=True;
        self.ip循环次数=1;self.ip实际帧=1;self.ip节点时间=25;self.fp影响=1.0;self.ip停止时间=0;

        #self.cp物序此节点关键帧记录[i物序].location=( 0.0, 0.0,0.0);self.cp物序此节点关键帧记录[i物序].fvp3euler=( 0.0, 0.0,0.0);self.fvp4q=(1.0, 0.0, 0.0,0.0);
        #self.cp物序此节点关键帧记录[i物序].scale=( 1.0, 1.0,1.0);
        self.ip从开始第几个节点=-1;self.ip从开始第几个euler=-1;self.ip从开始第几个scale=-1;

#////////////////////////////////////////////////
class 卐IMDJS_NODES_PSR(卐IMDJS_NODES):
    bp相对 = BoolProperty(name='本地',description='',default=False,subtype='NONE',update=None,get=None,set=None); # bp相对 0 == Absolute, bp相对 1 = Relative

    ep插值类型 = EnumProperty(items=Lt4插值类型);
    ip指数=IntProperty(name='',description='the interpolation between two keys',default=1,min=1,max=10,step=1,subtype='NONE',update=None);

    #--------------------------------------------------------------------------
    @classmethod
    def poll(cls, ntree):
        return True;
        #return (ntree.bl_idname == IMDJS_nodes_m.bl_idname);

    def init(self, context):
        卐IMDJS_NODES.init(self, context);
        #==============================================================
        INPUT=self.inputs.new(卐颜色接口卐NodeSocket.bl_idname,"INPUT");#NodeSocket.bl_idname
        START=self.inputs.new("NodeSocketIntUnsigned","START TIME","start_frame");#如果有link 开始时间按这个算
        START.hide_value=True;
        LIMIT=self.inputs.new("NodeSocketIntUnsigned","LIMIT TIME","limit_frame");#限制时间
        LIMIT.hide_value=True;LIMIT.hide=True;
        self.outputs.new(卐颜色接口卐NodeSocket.bl_idname,"OUTPUT");
        self.outputs.new("NodeSocketIntUnsigned","NO_STOP").hide_value=True;
        self.label=self.name;self.use_custom_color=True;
        #----初始化值--------------------------------------------------------------
        INPUT.ip接口开始时刻=1;

        #self.cp物序此节点关键帧记录[i物序].location=self.cp物序此节点关键帧记录[i物序].fvp3euler=( 0.0, 0.0,0.0);self.fvp4q=(1.0, 0.0, 0.0,0.0);
        #self.cp物序此节点关键帧记录[i物序].scale=( 1.0, 1.0,1.0);
        self.ip指数=1;
        self.sp节点类型="PSR";

    #--------------------------------------------------------------------------
    def Δ检查时间(self,nt,n开始,o群父,o,i延时):
        #print("b",self.bp是禁用节点);
        b是禁用节点=bΔΔ是禁用节点(nt,self,o群父,o,i延时) ;
        ns本节点input= self.inputs["INPUT"];#print(">>>>>>",G.Li当前帧GG[0], self.ip实际帧 );
        n节点前面 = ns本节点input.links[0].from_node;
        """"""
        if(i延时==0):
            i本节点开始时刻=ns本节点input.ip接口开始时刻;
            i运动时刻end=ns本节点input.ip接口开始时刻+ self.ip节点时间;
            i超出时间=G.Li当前帧GG[0]-ns本节点input.ip接口开始时刻;        
            
        else:
            i本节点开始时刻=ns本节点input.ip接口开始时刻+i延时;
            i运动时刻end=i本节点开始时刻+ self.ip节点时间;
            i超出时间=G.Li当前帧GG[0]-i本节点开始时刻;
            #print("delay==",i延时);
        """
        if (i超出时间 <=0):
            if(self.use_custom_color):
                self.use_custom_color=False;
        """
        #----TEMP---------------------------------------------------------------
        """
        ns本节点input.ip接口开始时刻=ns本节点input.ip接口开始时刻;
        self.ip实际帧=self.ip实际帧;self.ip节点时间=self.ip节点时间;self.ip停止时间=self.ip停止时间;
        #print("real frame",self.ip实际帧);
        if(not hasattr(self,'ip实际帧')):self.ip实际帧=1;
        if(not hasattr(self,'ip节点时间')):self.ip节点时间=1;
        G.Lb是要updateGG[0]=False;
        """
        
        #----未画---------------------------------------------------------------
        if(LIB.Li显示2dLIB[0]==1):
            if(LIB.space节点LIB==None):
                screen=bpy.context.screen;
                for area in screen.areas:
                    if(area.type=="NODE_EDITOR"):      
                        print("find area==",area);
                        for space in area.spaces:
                            #print("space==",space);
                            if(space.type=="NODE_EDITOR"):
                                LIB.space节点LIB=space;
                                break;
                                
            #print("space节点LIB",LIB.space节点LIB);
            if(LIB.space节点LIB):
                #print("LIB.space节点LIB.node_tree==",nt,LIB.space节点LIB.node_tree);
                if(nt==LIB.space节点LIB.node_tree):
                    if(LIB.region节点LIB==None):
                        screen=bpy.context.screen;
                        for area in screen.areas:
                            if(area.type=="NODE_EDITOR"):   
                                for space in area.spaces:
                                    if(space.type=="NODE_EDITOR"):
                                        for region in area.regions:
                                            if(region.type=="WINDOW"):
                                                LIB.region节点LIB=region;
                                                break;
                    #print("LIB.region节点LIB",LIB.region节点LIB,self.name);#√
                    #print("G.Li当前帧GG[0]<=i运动时刻end",G.Li当前帧GG[0],i运动时刻end);
                    #----升级位置--------------------------------------------------------------
                    if(LIB.region节点LIB):#●●不能  LIB.region节点LIB==True
                        v2d=LIB.region节点LIB.view2d;v2宽高=self.dimensions;
                        if(G.Li当前帧GG[0]<=i运动时刻end):
                            f2节点屏位左上pre=v2d.view_to_region(n节点前面.location.x, n节点前面.location.y, clip=False);
                            f2节点屏位右下pre=v2d.view_to_region(n节点前面.location.x+n节点前面.dimensions.x, n节点前面.location.y-n节点前面.dimensions.y, clip=False);
                            f2节点屏位左上this=v2d.view_to_region(self.location.x, self.location.y, clip=False);
                            f2节点屏位右下this=v2d.view_to_region(self.location.x+v2宽高.x, self.location.y-v2宽高.y, clip=False);
                            cf2结果=(c_float*2)();
                            LIB.dllIMDJS.ΔΔ计算前后节点位置(cf2__f2(f2节点屏位左上pre),cf2__f2(f2节点屏位右下pre),cf2__f2(f2节点屏位左上this),cf2__f2(f2节点屏位右下this),c_float(i超出时间/self.ip节点时间),cf2结果);
                            LIB.Dn开始f2画LIB[n开始]=f2__cf2(cf2结果);
                        else:
                            f2节点屏位左上this=v2d.view_to_region(self.location.x, self.location.y, clip=False);
                            f2节点屏位右下this=v2d.view_to_region(self.location.x+self.dimensions.x, self.location.y-self.dimensions.y, clip=False);
                            f2结果=f2__f2十f2Ξ2(f2节点屏位左上this,f2节点屏位右下this);
                            LIB.Dn开始f2画LIB[n开始]=f2结果;
                        
        #----添加手柄--------------------------------------------------------------
        else:
            if(LIB.Li显示2dLIB[0]< 1):
                bpy.ops.op.draw_line_2d_lib("INVOKE_DEFAULT");

        #--------------------------------------------------------------------------
        return n节点前面,i运动时刻end,i超出时间,i本节点开始时刻,ns本节点input,b是禁用节点;
        #print("CHECK TIME",self.label);














