

import bpy,os,sys
from bpy.types import NodeTree, Node
from bpy.props import*

from .function_node import *

if("IMDJS_nodes_m.global_var" in sys.modules):
    print("find IMDJS_nodes_m.global_var",);
    G = sys.modules["IMDJS_nodes_m.global_var"];
else:
    import IMDJS_nodes_m.global_var as G;


#////////////////////////////////////////////////
class 卐更新旧节点卐Operator(bpy.types.Operator):
    bl_idname = "op.update_old_nodes"
    bl_label = "update_old_nodes"
    bl_options = {"REGISTER", "UNDO"}
    bl_description="update old nodes to the new nodes so that they can run again in the new version"

    sp=StringProperty(name="note", description="", default="are you sure to update old nodes？");

    Ls排除键=["bl_idname"];
    #--------------------------------------------------------------------------
    def draw(self, context):    self.layout.prop(self, "sp");

    def invoke(self, context, event):   return context.window_manager.invoke_props_dialog(self,400,50);#召唤

    def execute(self, context):
        if(len(G.LntIMDJS节点GG)==0):
            Δ填充LntIMDJS节点GG();
        scene=bpy.context.scene;
        for nt in G.LntIMDJS节点GG:
            for n in nt.nodes:
                if("TIME" in n.inputs.keys()):
                    ns时间=n.inputs["TIME"];
                    if(hasattr(n,'ip节点时间')):
                        n.ip节点时间=ns时间.default_value;
                        self.report({"ERROR"},"find time node  %s"%(n.label));#"INFO" "ERROR" "DEBUG" "WARNING"
                        n.inputs.remove(ns时间);
                #--------------------------------------------------------------------------
                if("FACTOR" in n.inputs.keys()):
                    ns=n.inputs["FACTOR"];
                    n.inputs.remove(ns);
                #----更新start节点----------------------------------------------------------------
                if(n.bl_idname=="IMDJS_NodeStartPre"):
                    n开始new=nt.nodes.new(type="IMDJS_NodeStart");#type->bl_idname
                    #ns输入=n开始.inputs["INPUT"];
                    #Llink=nt.links;
                    #Llink.new(ns输出,ns输入);

                    Δ复制节点属性(self, context,nt,n,n开始new.name,False);
                    ns输入new=n开始new.inputs["INPUT"];ns输出new=n开始new.outputs["OUTPUT"];

                    if(n.inputs["INPUT"].links):
                        ns输出group=n.inputs["INPUT"].links[0].from_socket;
                    else:
                        ns输出group=None;

                    if(n.outputs["OUTPUT"].links):
                        ns输入=n.outputs["OUTPUT"].links[0].to_socket;
                    else:
                        ns输入=None;

                    nt.nodes.remove(n);

                    Llink=nt.links;
                    Llink.new(ns输出group,ns输入new);Llink.new(ns输出new,ns输入);
                #----更新cp记录PSR-------------------------------------------------------------
                if(n.sp节点类型  in ["PSR"] or n.bl_idname not in ["IMDJS_NodeOutPutGroup"]):
                    
                    n群组=nΔΔ找到群组节点(n);
                    if(n群组!=None):
                        for s物名,oG  in G.Ds物oGG.items():
                            if(s物名 in n群组.cp群组物体.keys()):
                                if(s物名 not in n.cp物序此节点关键帧记录.keys()):
                                    pg关键帧记录=n.cp物序此节点关键帧记录.add();
                                    pg关键帧记录.name=s物名;
                                    if(n.bl_idname in ["IMDJS_NodeStartPre","IMDJS_NodeStartPost","IMDJS_NodeStart"]):
                                        print("n.keys()==",n.name,oG.pp物PSRo.keys());
                                        if('fvp3位置初始' in oG.pp物PSRo.keys()):
                                            
                                            oG.pp物PSRo.fvp3初始loc=oG.pp物PSRo.fvp3位置初始;
                                            oG.pp物PSRo.fvp3初始scale=oG.pp物PSRo.fvp3缩放初始;
                                            oG.pp物PSRo.fvp3初始euler=oG.pp物PSRo.fvp3旋转初始;
                                            print("hasattr==",s物名,oG.pp物PSRo.fvp3初始loc);
                                            
                                        pg关键帧记录.fvp3loc=oG.pp物PSRo.fvp3初始loc;
                                        pg关键帧记录.scale=oG.pp物PSRo.fvp3初始scale;                                        
                                        pg关键帧记录.fvp3euler=oG.pp物PSRo.fvp3初始euler;
                                        
                                    elif(n.bl_idname=="IMDJS_NodeLocation"):
                                        if("END_LOC" in n.inputs.keys()):
                                            pg关键帧记录.fvp3loc=n.inputs["END_LOC"].default_value;

                                    elif(n.bl_idname=="IMDJS_NodeRotate"):
                                        if("END_ROT" in n.inputs.keys()):
                                            pg关键帧记录.fvp3euler=n.inputs["END_ROT"].default_value;                                    

                                    elif(n.bl_idname=="IMDJS_NodeScale"):
                                        if("END_SCALE" in n.inputs.keys()):
                                            pg关键帧记录.scale=n.inputs["END_SCALE"].default_value;                                    
                                        
                                    elif(n.bl_idname=="IMDJS_NodePSR"):
                                        if("END_SCALE" in n.inputs.keys()):
                                            pg关键帧记录.fvp3loc=n.inputs["END_LOC"].default_value;
                                            pg关键帧记录.fvp3euler=n.inputs["END_ROT"].default_value;
                                            pg关键帧记录.scale=n.inputs["END_SCALE"].default_value;  
                                            
                                    
                                    self.report({"ERROR"},"update node== %s"%n.label);#"INFO" "ERROR" "DEBUG" "WARNING"
                                        
        return {"FINISHED"};




