import bpy,math,os,sys
from bpy.props import *

path目录NODE = os.path.dirname(__file__) #本py文件所在目录 #如 E"\blender\addons\Object Presets
文件夹此NODE=os.path.basename(path目录NODE);  #Object Presets

"""
if (文件夹此NODE+".function_node" in sys.modules):
    del sys.modules[文件夹此NODE+".function_node"];#先卸载此子模块\
"""

#if(文件夹此NODE+".function_node" not in locals()):  #卸载后再载入
from .function_node import*

dllpathB = os.path.abspath("B:/cloth_node64.dll");
dllpath64 = os.path.abspath("%s/cloth_node64.dll" % path目录NODE);#

try:
    import PYLIB.global_var as LIB;
except:
    import IMDJS_nodes_m.PYLIB.global_var as LIB;

try:
    from PYLIB.PYLIB_attribute import dllΔΔ载入dllLIB,dllΔΔ卸载dllLIB;
except:
    from .PYLIB.PYLIB_attribute import   dllΔΔ载入dllLIB,dllΔΔ卸载dllLIB;
"""
try:
    import IMDJS_nodes_m.global_var as G;
except:    
    if("IMDJS_nodes_m.global_var" in sys.modules):
        print("find IMDJS_nodes_m.global_var",);
        G = sys.modules["IMDJS_nodes_m.global_var"];
"""
#LIB=卐DLL类型();


try:
    LIB.dllCloth;
except:
    LIB.dllCloth=None;
    

        
#////////////////////////////////////////////////
class 卐布料init卐Operator(bpy.types.Operator):
    bl_idname = "op.imdjs_cloth_init"
    bl_label = "ClothInit"

    sp = StringProperty(name='',default='are you sure to init the active object as a cloth?',maxlen=0,subtype='NONE',update=None,get=None,set=None);

    @classmethod
    def poll(self,context):
        return context.active_object;
    def draw(self,context):
        uil=self.layout.row(align=False);
        uil.prop(data=self,property="sp",text='',translate=True,icon='NONE',slider=False,toggle=False);
    def invoke(self,context,event):
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();
        self.nThis=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        return context.window_manager.invoke_props_dialog(self,400,50);
    
    def execute(self, context):
        #global G.LoN物GG,G.LoN物之前GG;G.LoN物GG=[];
        LIB.dllCloth=dllΔΔ载入dllLIB(LIB,"dllCloth",dllpathB,dllpath64);

        #for o in context.selected_objects:
        if( self.nThis!=None):
            n群组输入=nΔΔ找到群组节点( self.nThis);            
            if(not n群组输入):
                print("NO GROUP COLLIDER",);
                return {"FINISHED"};
            
            Ls布料物名group=n群组输入.cp群组物体.keys();
            for o in G.LoN物GG:
                if(o.name in Ls布料物名group):
                    if(o.type=="MESH" ):#组物有MT节点
                        #----激活SK----------------------------------------------------------------
                        if(not o.active_shape_key):
                            o.shape_key_add(name="base", from_mix=True);
                            sk=o.shape_key_add(name="key1", from_mix=True);
                            o.active_shape_key_index=1;
                            sk.value=1.0;
                            #o.active_shape_key_index=1;
                            if(o.active_shape_key.value!=1.0):
                                o.active_shape_key.value=1.0;
                        #----建立CLOTH_SIM---------------------------------------------------------
                        b找到=False;Csk=o.data.shape_keys.key_blocks;
                        for sk in Csk:
                            if("CLOTH_SIM" ==sk.name):
                                b找到=True;break;
                        if(b找到==False):
                            sk=o.shape_key_add(name="CLOTH_SIM", from_mix=True);
                            sk.value=1;
                        
                        
                        #----添加属性----------------------------------------------------------
                        cvpA=c_void_p(o.as_pointer());
                        if("gCLOTH" not in o.keys()):
                            o["gCLOTH"]={};
                        #----f距离阈值----------------------------------------------------------
                        x,y,z=o.dimensions;
                        f距离阈值=(x+y+z)/3/2;print("radius==",f距离阈值);
                        o["gCLOTH"]["CHECK_DISTANCE"]=[f距离阈值];
                        #----NUM----------------------------------------------------------------
                        Lmv=o.data.vertices;Lmp=o.data.polygons;
                        i网点数=len(Lmv);#i三角面数=len(Lmp);
                        i三角面数=LIB.dllCloth.iΔ收集三角面点ξLIB(cvpA);print("iTRI FACE NUM==",i三角面数);#√
                        o["gCLOTH"]["VERT_NUM"]=i网点数;
                        o["gCLOTH"]["TRI_NUM"]=i三角面数;
                        L点位=[[0.0]*3]*i网点数;#点序[[x,y,z],[0.0,0.0,0.0],...]
                        o["gCLOTH"]["L_INIT_V_CO"]=L点位;#清空 填充空数据
                        #----自碰撞属性-------------------------------------------------------
                        if( self.nThis.ip绑定面数>i三角面数): self.nThis.ip绑定面数=i三角面数-2;
                        f自碰撞检测距离fac=0.0;
                        if(30>i三角面数>4):
                            i一半=i三角面数//2+1;
                        else:#大于30点
                            i一半=20;
                        i相加次数=0;
                        #print("Len==",len(Lmp),i一半);
                        for i in range(i一半):
                            if(i==i一半-1):break;#最后一点
                            mp=Lmp[i];
                            i面点数=len(mp.loop_indices);
                            for i步3 in range(i面点数):
                                i步3下步 = (i步3+1) % i面点数;#4%4==0
                                i点ξ = mp.vertices[i步3];
                                i点ξ下 = mp.vertices[i步3下步];
                                f自碰撞检测距离fac+=(Lmv[i点ξ].co-Lmv[i点ξ下].co).length;
                                i相加次数+=1;
                                
                        f自碰撞检测距离fac=f自碰撞检测距离fac/(i相加次数)*2;#平均距离的2倍

                        #print("fPER==",f自碰撞检测距离fac);
                        o["gCLOTH"]["CHECK_SELF_DISTANCE"]=[f自碰撞检测距离fac];#自碰撞检测距离 

                        if(o.data.shape_keys):
                            i激活SKξ=o.active_shape_key_index;
                            print("SK ==",o.data.shape_keys);
                            print("iA SK==",o.active_shape_key_index,o);
                        else:
                            i激活SKξ=-1;
                            print("iA SK2==",i激活SKξ,o);
                        L面序Lf4面位f3法线=[[[0.0]*4,[0.0]*3]]*i三角面数;
                        o["gCLOTH"]["L面序Lf4面位f3法"]=L面序Lf4面位f3法线;#清空
                        iSp=LIB.dllCloth.iΔΔ初始化cloth(cvpA,i三角面数, i激活SKξ);
                        #for L in o["gCLOTH"]["L_INIT_V_CO"]:print("L记录",list(L));#√
                        #----填充,希疏面ξ--------------------------------------------------------------
                        i希疏面数=int(i三角面数* self.nThis.fp希疏比);Lciξ希疏_=(c_int*i希疏面数)();#LLciξ希疏绑定_=((c_float*3)*i希疏面数)();
                        #print("hash NUM==",i希疏面数);#√
                        LIB.dllCloth.Δ收集稀疏面ξ(cvpA,c_float(f距离阈值),c_float( self.nThis.fp希疏比));
                        
                        LIB.dllCloth.Δ返回希疏ξ(Lciξ希疏_);#,LLciξ希疏绑定_
                        Lciξ绑定面=(c_int* self.nThis.ip绑定面数)();
                        o["gCLOTH"]["D_HASH"]={};#清空
                        for i,ciξ希疏 in enumerate(Lciξ希疏_):
                            o["gCLOTH"]["D_HASH"][str(ciξ希疏)]=list(Lciξ绑定面);#先填充  #{"iξ希疏面":[0,0,0],"iξ希疏面":[0,0,0]}
                        #print("o[gCLOTH][D_HASH]==",o["gCLOTH"]["D_HASH"].keys());
                        LIB.dllCloth.Δ写入希疏到属性(cvpA, self.nThis.ip绑定面数,"gCLOTH");#{"iξ希疏面":[iξ,iξ,iξ],"iξ希疏面":[iξ,iξ,iξ]}
                        #----记录sp值到prop------------------------------------------------------
                        o["gCLOTH"]["SPRING"]={};#清空
                        L_iV=[[-1]*2]*iSp;#[[iV1,iV2],[iV1,iV2],...]
                        #print("L_iV",L_iV);
                        o["gCLOTH"]["SPRING"]["L_iV"]=L_iV;#2
                        LiTYPE=[-1]*iSp;
                        o["gCLOTH"]["SPRING"]["iTYPE"]=LiTYPE;#[iTYPE,iTYPE,...]
                        L_fFAC=[[-1.0]*2]*iSp;
                        o["gCLOTH"]["SPRING"]["L_fFAC"]=L_fFAC;#2
                        LfLENGTH=[-1.0]*iSp;
                        o["gCLOTH"]["SPRING"]["fLENGTH"]=LfLENGTH;#1
                        o["gCLOTH"]["SPRING"]["NUM_SP"]=iSp;
                        LIB.dllCloth.Δ记录spring到py(cvpA);
                        #----记录V点序卍点G到prop-----------------------------------------------------
                        o["gCLOTH"]["V_POINT"]={};#清空     
                        Vi25=[[-1]*25]*i网点数;#[[i点ξ,i点ξ,i点ξ,i点ξ],[i点ξ,i点ξ,i点ξ,i点ξ],...]
                        Vi8=[[-1]*8]*i网点数;
                        o["gCLOTH"]["V_POINT"]["L_ViP3"]=Vi25;#连点连点点ξ           
                        #return {"FINISHED"};
                        o["gCLOTH"]["V_POINT"]["L_ViF"]=Vi8  #连点面ξ
                        LIB.dllCloth.Δ记录V点序卍点到py(cvpA,False);
                        #----记录面点ξprop-----------------------------------------------------
                        L面序Li面点ξ=[[-1]*3]*i三角面数;#面序[[i点ξ,i点ξ,i点ξ,i点ξ,-1],[i点ξ,i点ξ,i点ξ,i点ξ,-1],...]
                        o["gCLOTH"]["L面序Li面点索"]=L面序Li面点ξ;
                        LIB.dllCloth.Δ记录面点ξ到py(cvpA);
                        #----打印--------------------------------------------------------------
                        """
                        for i in range(i三角面数): 
                            L=o["gCLOTH"]["L面序Li面点索"][i];
                            print("F",i,"L面序Li面点索==",L[0],L[1],L[2],L[3],L[4]);#√
                            mp=Lmp[i];print("mp=",list(mp.vertices));#√
                                
                        
                        for i in range(i网点数):
                            for j in range(25):
                                if(i==35):
                                    print("PY  L_ViP3=",o["gCLOTH"]["V_POINT"]["L_ViP3"][i][j]);#√
                        """
                        """
                        for i in range(iSp):
                            #if(i>3):break;
                            fLENGTH=o["gCLOTH"]["SPRING"]["fLENGTH"][i];
                            print("after fLENGTH==",fLENGTH);
                            iTYPE=o["gCLOTH"]["SPRING"]["iTYPE"][i];
                            print("after iTYPE==",iTYPE);
                        """
                        """
                        Li2两点=((c_int*2)*iSp)();Lfp1长2=(c_float*iSp)();Lf2Fac=((c_float*2)*iSp)();LipTYPE=(c_int*iSp)();
                        for i in range(iSp):
                            #pg=o.cpSPRING.add();
                            
                            pg.ivp2V1V2[0]=Li2两点[i][0];pg.ivp2V1V2[1]=Li2两点[i][1];
                            pg.fp1长2=Lfp1长2[i];
                            pg.fvp2Fac[0]=Lf2Fac[i][0];pg.fvp2Fac[1]=Lf2Fac[i][1];
                            pg.ipTYPE=LipTYPE[i];
                        """
                        
                        
                        o.active_shape_key_index=Csk.keys().index("CLOTH_SIM");
                    
        #LIB.dllCloth=dllΔΔ卸载dllLIB(LIB,"dllCloth");
        return {'FINISHED'};
        
#////////////////////////////////////////////////
class 卐布料还原卐Operator(bpy.types.Operator):
    bl_idname = "op.imdjs_clothzero"
    bl_label = "Cloth_0"
   
    def invoke(self,context,event):
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();
        self.nThis=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        return self.execute( context);
        
    def execute(self, context):
        if( self.nThis!=None):
            if(LIB.dllCloth==None):LIB.dllCloth=dllΔΔ载入dllLIB(LIB,"dllCloth",dllpathB,dllpath64);
            n群组输入=nΔΔ找到群组节点( self.nThis);            
            if(not n群组输入):
                print("NO GROUP COLLIDER",);
                return {"FINISHED"};
            
            Ls布料物名group=n群组输入.cp群组物体.keys();
            for o in G.LoN物GG:
                if(o.name in Ls布料物名group):
                    i碰撞物数=0;b是第一帧=True;cl=(c_long*1)();i迭代次数=1;b是自碰撞=False;
                    LIB.dllCloth.ΔΔΔ布料模拟(c_void_p(o.as_pointer()),cl,i碰撞物数,c_float(0.1),c_float(0.1) ,i迭代次数,b是自碰撞,b是第一帧,2);
                    o.data.update();

        return {"FINISHED"};
      
#////////////////////////////////////////////////
class 卐碰撞物init卐Operator(bpy.types.Operator):
    bl_idname = "op.imdjs_set_collider"
    bl_label = "set_collider"
    
    sp = StringProperty(name='',default='are you sure to set the active object as a collider?',maxlen=0,subtype='NONE',update=None,get=None,set=None);
    
    @classmethod
    def poll(self,context):
        return context.active_object;
    def draw(self,context):
        uil=self.layout.row(align=False);
        uil.prop(data=self,property="sp",text='',translate=True,icon='NONE',slider=False,toggle=False);
    def invoke(self,context,event):
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();
        self.nThis=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        return context.window_manager.invoke_props_dialog(self,400,50);
    
    def execute(self, context):
        LIB.dllCloth=dllΔΔ载入dllLIB(LIB,"dllCloth",dllpathB,dllpath64);
        if( self.nThis!=None):
            if( self.nThis.inputs["COLLIDER"].links):
                #self.ip实际帧 = self.ip节点时间;
                n群组输入= self.nThis.inputs["COLLIDER"].links[0].from_node;
                #print("GROUP==",n群组输入.name);
                if(not n群组输入):
                    print("NO GROUP COLLIDER",);
                    return {"FINISHED"};
                #----不等------------------------------------------------------------
                Ls碰撞物名group=n群组输入.cp群组物体.keys();
                i碰撞物数=len(Ls碰撞物名group);
                if( self.nThis.name not in G.Ds碰撞节点cl群组物指针GG):
                    G.Ds碰撞节点cl群组物指针GG[ self.nThis.name]={};

                if(len(G.Ds碰撞节点cl群组物指针GG[ self.nThis.name])!=i碰撞物数):
                    #return ;
                    print("DsGG!=Ls colli", self.nThis.name,G.Ds碰撞节点cl群组物指针GG[ self.nThis.name],i碰撞物数,Ls碰撞物名group);
                    print("LsNGG==",G.LoN物GG);#Χ如果没有从function_node导入总局变量,这里会崩溃
                    #bpy.ops.op.imdjs_reflash_group(bp不弹出=True);
                    #Ls碰撞物名group=n群组输入.cp群组物体.keys();
                    G.Ds碰撞节点cl群组物指针GG[ self.nThis.name]=(c_long*i碰撞物数)();#清空,重建

                    #----填充本节点群组物GG-------------------------------------------------------
                    i物ξ=0;
                    for o碰撞 in G.LoN物GG:
                        if(o碰撞.name in Ls碰撞物名group):
                            G.Ds碰撞节点cl群组物指针GG[ self.nThis.name][i物ξ]=o碰撞.as_pointer();#填充物体指针为long
                            i物ξ+=1;
                            print("APPEND O",o碰撞.name);
                    
                for s碰撞物名 in Ls碰撞物名group:
                    o=G.Ds物oGG[s碰撞物名];
                    #====添加属性====================================================
                    if("gCOLLIDER" not in o.keys()):
                        o["gCOLLIDER"]={};

                    cvpA=c_void_p(o.as_pointer());
                    #----f距离阈值----------------------------------------------------------
                    x,y,z=o.dimensions;
                    f距离阈值=(x+y+z)/3/2;print("radius==",f距离阈值);
                    o["gCOLLIDER"]["CHECK_DISTANCE"]=[f距离阈值];
                    #----NUM----------------------------------------------------------------
                    i网点数=len(o.data.vertices);#i三角面数=len(o.data.polygons);
                    i三角面数=LIB.dllCloth.iΔΔ收集三角面点ξ(cvpA);print("iTRI FACE NUM==",i三角面数);#√
                    #o["gCOLLIDER"]["VERT_NUM"]=i三角面数;
                    o["gCOLLIDER"]["TRI_NUM"]=i三角面数;
                    #----初始化----------------------------------------------------------------
                    #return {"FINISHED"};
                    if( self.nThis.ip绑定面数>i三角面数): self.nThis.ip绑定面数=i三角面数-2;
                    #o["gCOLLIDER"]["BIND_F_NUM"]= self.nThis.ip绑定面数;
                    
                    L点位=[[0.0]*3]*i网点数;L面序Lf4面位f3法线=[[[0.0]*4,[0.0]*3]]*i三角面数;#面序[[[x,y,z,f边长],[n,n,n]],[[x,y,z,f边长],[n,n,n]],...]
                    L面序Lf3面点位=[[[0.0]*3]*3]*i三角面数;#[面序[点序[[x,y,z],[x,y,z],[x,y,z]],点序[[x,y,z],[x,y,z],[x,y,z]],...],...];
                    #L面序Liξ绑定面=[[-1]* self.nThis.ip绑定面数]*i三角面数;#面序[[i面,i面,i面,i面],[i面,i面,i面,i面],...]
                    #L希疏Liξ绑定面=[[-1]* self.nThis.ip绑定面数]*int(i三角面数* self.nThis.fp希疏比);
                    #o["gCOLLIDER"]["L_INIT_V_CO"]=L点位;#清空
                    o["gCOLLIDER"]["L面序Lf4面位f3法"]=L面序Lf4面位f3法线;#清空
                    o["gCOLLIDER"]["L面序Lf3面点位"]=L面序Lf3面点位;
                    #----记录面点ξ  到prop-----------------------------------------------------
                    L面序Li面点ξ=[[-1]*3]*i三角面数;#面序[[i点ξ,i点ξ,i点ξ,i点ξ,-1],[i点ξ,i点ξ,i点ξ,i点ξ,-1],...]
                    o["gCOLLIDER"]["L面序Li面点索"]=L面序Li面点ξ;
                    LIB.dllCloth.Δ记录面点ξ到py(cvpA);
                    #----记录V点序卍点G   到prop-----------------------------------------------------
                    o["gCOLLIDER"]["V_POINT"]={};#清空     
                    Vi8=[[-1]*8]*i网点数;
                    o["gCOLLIDER"]["V_POINT"]["L_ViF"]=Vi8  #连点面ξ
                    LIB.dllCloth.Δ记录V点序卍点到py(cvpA,True);
                    #----SK----------------------------------------------------------------
                    #o["gCOLLIDER"]["L面序i绑定面索"]=L面序Liξ绑定面;
                    if(o.data.shape_keys):
                        i激活SKξ=o.active_shape_key_index;
                        print("SK ==",o.data.shape_keys);
                        print("iA SK==",o.active_shape_key_index,o);
                    else:
                        i激活SKξ=-1;
                        print("iA SK2==",i激活SKξ,o);
                    LIB.dllCloth.ΔΔ初始化colli(cvpA,i三角面数,i激活SKξ, self.nThis.ip绑定面数,c_float(f距离阈值));

                    #----填充,希疏面ξ--------------------------------------------------------------
                    i希疏面数=int(i三角面数* self.nThis.fp希疏比);Lciξ希疏_=(c_int*i希疏面数)();#LLciξ希疏绑定_=((c_float*3)*i希疏面数)();
                    print("hash NUM==",i希疏面数);#√
                    i绑定面数=int(i希疏面数*0.2);
                    if(i绑定面数<4):
                        i绑定面数=4;
                    o["gCOLLIDER"]["HASH_F_NUM"]=i希疏面数;
                    o["gCOLLIDER"]["BIND_F_NUM"]=i绑定面数;
                    LIB.dllCloth.Δ收集稀疏面ξ(cvpA,c_float(f距离阈值),c_float( self.nThis.fp希疏比));
                    
                    LIB.dllCloth.Δ返回希疏ξ(Lciξ希疏_);#,LLciξ希疏绑定_
                    Lciξ绑定面=(c_int* i绑定面数)();
                    o["gCOLLIDER"]["D_HASH"]={};#清空
                    for i,ciξ希疏 in enumerate(Lciξ希疏_):
                        o["gCOLLIDER"]["D_HASH"][str(ciξ希疏)]=list(Lciξ绑定面);#先填充  #{"i面ξ希疏":[0,0,0],"i面ξ希疏":[0,0,0]}
                    print("o[gCOLLIDER][D_HASH]==",o["gCOLLIDER"]["D_HASH"].keys());
                    LIB.dllCloth.Δ写入希疏到属性(cvpA, i绑定面数,"gCOLLIDER");#{"i面ξ希疏":[i面ξ,i面ξ,i面ξ],"i面ξ希疏":[i面ξ,i面ξ,i面ξ]}  ●● i面ξ可能重叠
                        
                    #return {"FINISHED"};
                    
                    ΔΔ刷新界面LIB(area="VIEW_3D",region="WINDOW");
                    #o.data.update();
                    
                    #----打印--------------------------------------------------------------
                    #for L in o["gCOLLIDER"]["L面序i绑定面索"]:print("L",list(L));
                    for s,D in o["gCOLLIDER"]["D_HASH"].items():
                        print("D==",s,D);
                    
                    """
                    for L in o["gCOLLIDER"]["L面序Lf4面位f3法"]:
                        #print("L==",L);
                        for l in L:print("l==",list(l));
                    """

                    #print("L面序Lf4面位f3法",list(o["gCOLLIDER"]["L面序Lf4面位f3法"]));
                #LIB.dllCloth=dllΔΔ卸载dllLIB(LIB,"dllCloth");
        return {"FINISHED"};
        
#////////////////////////////////////////////////
class 卐TEST_cloth卐Operator(bpy.types.Operator):
    bl_idname ="op.test_dll_cloth";
    bl_label = "TESTcloth";
    
    @classmethod
    def poll(self,context):
        return context.active_object;

    def execute(self, context):
        LIB.dllCloth=dllΔΔ载入dllLIB(LIB,"dllCloth",dllpathB,dllpath64);
        o=context.active_object;o["sImdjs"]="DJS";o["iImdjs"]=12346;
        cvpA=c_void_p(o.as_pointer());
        LIB.dllCloth.ΔΔTEST_clothi(cvpA);
        
        o.data.update();
        LIB.dllCloth.bΔΔ释放clib();
        LIB.dllCloth=dllΔΔ卸载dllLIB(LIB,"dllCloth");
        return {"FINISHED"};
        
#////////////////////////////////////////////////        
class 卐TEST碰撞卐Operator(bpy.types.Operator):
    bl_idname = "op.imdjs_cloth_test"
    bl_label = "cloth_test"

    def execute(self, context): 
        o=context.active_object;
        try:
            o["gCOLLIDER"]["V_POINT"];
        except:
            self.report({"ERROR"},"没有gCloth属性");#"INFO" "ERROR" "DEBUG" "WARNING"
            LIB.dllCloth=dllΔΔ卸载dllLIB(LIB,"dllCloth");
            return {"FINISHED"};
        #----添加属性----------------------------------------------------------
        Lmv=o.data.vertices;Lmp=o.data.polygons;
        i三角面数=len(Lmp);

        #----自碰撞属性-------------------------------------------------------
        f自碰撞检测距离fac=0.0;
        if(30>i三角面数>4):
            i一半=i三角面数//2+1;
        else:#大于30点
            i一半=20;
        i相加次数=0;
        for i in range(i一半):
            if(i==i一半-1):break;#最后一点
            mp=Lmp[i];
            i面点数=len(mp.loop_indices);
            for i步3 in range(i面点数):
                i步3下步 = (i步3+1) % i面点数;#4%4==0
                i点ξ = mp.vertices[i步3];
                i点ξ下 = mp.vertices[i步3下步];
                f自碰撞检测距离fac+=(Lmv[i点ξ].co-Lmv[i点ξ下].co).length;
                i相加次数+=1;
                
        f自碰撞检测距离fac=f自碰撞检测距离fac/(i相加次数)*2;
        
        
        print("fPER=",f自碰撞检测距离fac);
                
        LIB.dllCloth=dllΔΔ载入dllLIB(LIB,"dllCloth",dllpathB,dllpath64);
        
        
        LIB.dllCloth.ΔΔTEST碰撞(c_void_p(context.as_pointer()),c_void_p(o.as_pointer()),c_float(f自碰撞检测距离fac));
        o.data.update();
        
        LIB.dllCloth.bΔΔ释放clib();
        LIB.dllCloth=dllΔΔ卸载dllLIB(LIB,"dllCloth");
        return {"FINISHED"};
        
#////////////////////////////////////////////////
class 卐布料清除数据卐Operator(bpy.types.Operator):
    bl_idname = "op.imdjs_cloth_clear"
    bl_label = "cloth_clear"
    """
    @classmethod
    def poll(self,context):
        return context.active_object["gCLOTH"];
    """
    def execute(self, context):
        oA=context.active_object;
        del oA["gCLOTH"];
        LIB.dllCloth.ΔΔ清空布料G变量();
        oA.data.update();

        return {"FINISHED"};
        

#////画画////////////////////////////////////////
from bpy_extras import view3d_utils
global areaG;areaG=None;
class 卐画画法线卐Operator(bpy.types.Operator):
    bl_idname = "op.draw_normal"
    bl_label = "draw normal"
    bl_description = "draw normal"
    #cp群组物体= CollectionProperty(type=卐群组物体卐PropertyGroup);
    _handle = None;_handle字= None;

    vZ=Vector((0.0,0.0,0.0));Lv2屏位=[None,None];
    bp是colli=BoolProperty(name='',description='',default=True,subtype='NONE',update=None,get=None,set=None);
    #======================================================
    @classmethod
    def poll(cls, context):
        return context.mode=="OBJECT";

    def modal(self, context, event):
        global  areaG;
        #if (context.area):context.area.tag_redraw();
        #----刷新界面--------------------------------------------------------
        """"""
        if(not areaG):
            screen=bpy.context.screen;
            for a in screen.areas:
                if(a.type=="VIEW_3D"):
                    areaG=a;
                    a.tag_redraw();
        else:
            areaG.tag_redraw();#为了不用每次都找 area
        
        #----停止--------------------------------------------------------------
        """"""
        if(LIB.Li显示LIB[0]==-1):
            bpy.types.SpaceView3D.draw_handler_remove(self._handle, 'WINDOW');
            bpy.types.SpaceView3D.draw_handler_remove(self._handle字, 'WINDOW');
            LIB.Li显示LIB[0]=0;
            #print("REMOVE modal==",self._handle);
            ΔΔ清除glLIB();
            print("remove handle 1 ~~~~",len(LIB.Lv位实物LIB));
            
            #return {"CANCELLED"};
            return {"FINISHED"};
        
        return {"PASS_THROUGH"};
        
    #==============================================================
    def invoke(self, context, event):
        print("BP invoke==",LIB.Li显示LIB[0],len(LIB.Lv法线位LIB),len(LIB.Lv法线顶位LIB));#return {"FINISHED"};
        if(LIB.Li显示LIB[0]<1):#0 或 -1
            LIB.Li显示LIB[0]=1;
            self.nThis=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
            if( self.nThis):
                if((self.bp是colli and self.nThis.inputs["COLLIDER"].links) or self.bp是colli==False):
                    if(self.bp是colli):
                        n群组输入= self.nThis.inputs["COLLIDER"].links[0].from_node;
                    else:
                        n群组输入=nΔΔ找到群组节点( self.nThis);
                    if(n群组输入):
                        for s碰撞物名 in  n群组输入.cp群组物体.keys():
                            if(s碰撞物名 in context.scene.objects.keys()):
                                print("o==",s碰撞物名);
                                o碰撞=context.scene.objects[s碰撞物名];
                                if(self.bp是colli):
                                    sCLOTHoCOLLI="gCOLLIDER";
                                else:
                                    sCLOTHoCOLLI="gCLOTH";
                                L面序Lf4面位f3法线=o碰撞[sCLOTHoCOLLI]["L面序Lf4面位f3法"];
                                print("len L面序Lf4面位f3法线==",len(L面序Lf4面位f3法线));
                                for Lf4面位f3法线 in L面序Lf4面位f3法线:
                                    LIB.Lv法线位LIB.append(Lf4面位f3法线[0][:3]);LIB.Lv三角面位LIB.append(Vector(Lf4面位f3法线[0][:3]));
                                    LIB.Lv法线顶位LIB.append([Lf4面位f3法线[0][0]+Lf4面位f3法线[1][0],Lf4面位f3法线[0][1]+Lf4面位f3法线[1][1],Lf4面位f3法线[0][2]+Lf4面位f3法线[1][2]]);
                                    print(" Lv三角面位LIB==",LIB.Lv三角面位LIB);
                                #print("len Lv法线位LIB==",len(LIB.Lv法线位LIB));
                            break;
                            
            #----增加手柄----------------------------------------------------------------
            self._handle = bpy.types.SpaceView3D.draw_handler_add(ΔΔ画线LIB,(self, context), 'WINDOW', 'POST_PIXEL');
            self._handle字 = bpy.types.SpaceView3D.draw_handler_add(ΔΔ画字LIB,(self, context), 'WINDOW', 'POST_PIXEL');
            context.window_manager.modal_handler_add(self);#(self==Operator) to call  Return type: boolean
            print("add handle+++",);
        
        else:
            LIB.Li显示LIB[0]=-1;

        return {"RUNNING_MODAL"};

        
bpy.utils.register_class(卐画画法线卐Operator) ;

#////end////end////end////end////end////end////end////end////



