import bpy,math,os,sys
from bpy.props import *



"""
if (文件夹此NODE+".function_node" in sys.modules):
    del sys.modules[文件夹此NODE+".function_node"];#先卸载此子模块\
"""

#if(文件夹此NODE+".function_node" not in locals()):  #卸载后再载入
from .function_node import*
"""
dllpathB = os.path.abspath("B:/cloth_node64.dll");
dllpath64 = os.path.abspath("%s/cloth_node64.dll" % path目录NODE);

CLIB = os.path.abspath("B:/IMDJS_function64.dll");
CLIB64 = os.path.abspath("%s/CLIB64.dll" % path目录NODE);
"""
try:
    from PYLIB.PYLIB_main import LIB;
except:
    from .PYLIB.PYLIB_main import  LIB;

try:
    from PYLIB.PYLIB_attribute import dllΔΔ载入dllLIB,dllΔΔ卸载dllLIB;
except:
    from .PYLIB.PYLIB_attribute import   dllΔΔ载入dllLIB,dllΔΔ卸载dllLIB;

"""
try:
    import IMDJS_nodes_m.global_var as G;
except:
    if("IMDJS_nodes_m.global_var" in sys.modules):
        print("find IMDJS_nodes_m.global_var",);
        G = sys.modules["IMDJS_nodes_m.global_var"];
"""

#LIB=卐DLL类型();


try:
    LIB.dllCloth;LIB.dllIMDJS;
except:
    LIB.dllCloth=None;LIB.dllIMDJS=None;


#/////////////////////////////////////////////////

class 卐name卐PropertyGroup(bpy.types.PropertyGroup):
    name = StringProperty(name="Name");
    idx=IntProperty(default= -1);


class 卐PSR记录卐PropertyGroup(bpy.types.PropertyGroup):
    name = StringProperty(name="cache");
    #----缓存--------------------------------------------------------------
    fvp3loc = FloatVectorProperty(size=3,default=(-100000.0, -100000.0, -100000.0) );
    fvp3euler = FloatVectorProperty(size=3,default=(-100000.0, 1.0, 1.0));
    fvp4q = FloatVectorProperty(size=4,default=(-100000.0, 0.0, 0.0,0.0));
    fvp3scale = FloatVectorProperty(size=3, default=(-100000.0, 1.0, 1.0));

class 卐Cpsr记录卐PropertyGroup(bpy.types.PropertyGroup):
    name = StringProperty(name="Ccache");#物名
    idx=IntProperty(default= -1);
    cpPSR=CollectionProperty(type=卐PSR记录卐PropertyGroup,name='C缓存曲线loc',description='');
    
class 卐PSR物体设定卐PropertyGroup(bpy.types.PropertyGroup):
    name = StringProperty(description = "---", update=None);#ΔΔUPDATE_初始化

    bp是初始化了PSR=BoolProperty(default=False);
    fvp3位置初始 = FloatVectorProperty(size=3,default=(0.0, 0.0, 0.0) );#fvp3位置初始
    fvp3旋转初始 = FloatVectorProperty(size=3, default=(0.0, 0.0, 0.0));#fvp3旋转初始
    fvp4旋转初始 = FloatVectorProperty(size=4,default=(0.0, 0.0, 0.0,1.0) );#fvp4旋转初始
    fvp3缩放初始 = FloatVectorProperty(size=3, default=(1.0, 1.0, 1.0));#fvp3缩放初始

    fvp16矩阵父动态初始=FloatVectorProperty(size=16,);
    fvp16矩阵父前帧=FloatVectorProperty(size=16,);
    #----LOD--------------------------------------------------------------
    bp是LOD = BoolProperty(default=False);
    bp已应用修改器 = BoolProperty();
    ip细分级数=IntProperty(default=0);
    iip当前段数=IntProperty(default=0);

    #----缓存-------------------------------------------------------------
    bp开始了 = BoolProperty(name='',description='',default=False,subtype='NONE',update=None,get=None,set=None);
    bp是隐藏动画 = BoolProperty(name='是隐藏动画',description='是隐藏动画',default=False,subtype='NONE',update=None,get=None,set=None);
    ip时刻成为父子=IntProperty(default=-1);

    iip长度当前缓存=IntProperty(default=0);#1,2,3,4
    cp缓存PSR=CollectionProperty(type=卐PSR记录卐PropertyGroup);#每个物每帧一个缓存
    

#==============================================================
class 卐缓存cloth卐PropertyGroup(bpy.types.PropertyGroup):
    name = StringProperty(name="cache");
    #----缓存--------------------------------------------------------------
    fvp3loc = FloatVectorProperty(size=3,default=(-100000.0, -100000.0, -100000.0) );

class 卐布料spring卐PropertyGroup(bpy.types.PropertyGroup):#单个预置 cpSK预置id
    name = StringProperty(name="spring", default="",update=None);
    ivp2V1V2 = IntVectorProperty(size=2,default=(-1, -1) );
    fp1长2=FloatProperty(name="", description="", default=0.0, min=sys.float_info.min, max=sys.float_info.max, step=3, precision=2, subtype="NONE", unit="NONE", update=None);
    fvp2Fac = FloatVectorProperty(size=2,default=(0.0, 0.0) );
    ipTYPE=IntProperty(default=0);

class 卐pp布料卐PropertyGroup(bpy.types.PropertyGroup):#单个预置 cpSK预置id
    name = StringProperty(name="布料", default="",update=None);
    cp布料缓存 = bpy.props.CollectionProperty(type=卐缓存cloth卐PropertyGroup,name='',description='',);
    #pp物动力学o = bpy.props.PointerProperty(type=卐动力学卐PropertyGroup);
    #cpSPRING = bpy.props.CollectionProperty(type=卐布料spring卐PropertyGroup,name='',description='',);
    #ip迭代次数=bpy.props.IntProperty(name='iteration',description='iteration of cloth simulation',default=3,min=1, max=10, step=1,);

    fp点积阈值=FloatProperty(name="dot fac", description="dot fac", default=0.005, min=0.001, max=1, precision=3, subtype="NONE", unit="NONE", update=None);
    f碰撞法线偏移=FloatProperty(name="collide offset", description="collide offset", default=0.01, min=0.001, max=0.5, precision=3, subtype="NONE", unit="NONE", update=None);
    #bp是自碰撞=BoolProperty(name="self-collide", default=False );
#--------------------------------------------------------------------------
class 卐ppSK卐PropertyGroup(bpy.types.PropertyGroup):#单个预置 cpSK预置id
    name = StringProperty(name="SK", default="",update=None);
    cpSK = bpy.props.CollectionProperty(type=卐缓存cloth卐PropertyGroup,name='',description='',);
    
#//////////////////////////////////////////////////

class 卐刷新所有群组名称卐Operator(bpy.types.Operator):
    bl_idname = "op.imdjs_reflash_group"
    bl_label = "reflash group object name"

    bp不弹出=BoolProperty(name='',description='',default=False,subtype='NONE',update=None,get=None,set=None);
    """"""
    def invoke(self, context, event):
        if(not self.bp不弹出):
            return context.window_manager.invoke_props_dialog(self)#把自身加入到dialog
        else:
            return self.execute(context);

    def execute(self, context):
        Δ填充LntIMDJS节点GG();
        #print("LoMTG==",G.LoN物GG);
        Ls物名实有=[];
        Co总=bpy.data.objects[:];
        #----改名群组物体--如果改了物名 但有id 就把名改成现在物名的-----------------------------
        for o in G.LoN物GG:
            Ls物名实有.append(o.name);
            if(o not in Co总):
                ΔΔ从LoN物GG删物(o.name);
                Ls物名实有.remove(o.name);
                continue;
            #----改pg名--------------------------------------------------------------
            for nt in G.LntIMDJS节点GG:
                for n in nt.nodes:
                    if (n.bl_idname == "IMDJS_NodeOutPutGroup" ):#如果是群组节点
                        if(o.name not in n.cp群组物体.keys()):#物体名与列表名不同
                            print("NOT IN==",o.name,n.name);
                            if(o.data!=None):
                                if(o.data.users==0):
                                    for pg in n.cp群组物体:
                                        #print("===",o.data.name,pg.spID名);
                                        if(o.data.name==pg.spID名):
                                            pg.name=o.name;
                                            print("RENAME==",pg.name);
                                            break;
                        else:
                            print("IN==",o.name,n.name);

        #----看看群组内是否有这个物体-没有就删除----------------------------------------
        #print("Ls物名实有==",Ls物名实有);
        for nt in G.LntIMDJS节点GG:
            for n in nt.nodes:
                if (n.bl_idname == "IMDJS_NodeOutPutGroup" ):#如果是群组节点
                    Ls要删除的物名=[];
                    for pg in n.cp群组物体:#物体名与列表名不同
                        #print("CP NAME==",pg.name);
                        if(pg.name not in Ls物名实有):
                            print("REMOVE==",pg.name);
                            Ls要删除的物名.append(pg.name);

                    for s in Ls要删除的物名:
                        iξ=n.cp群组物体.keys().index(s);n.cp群组物体.remove(iξ);

                    if (n.ip激活群组物体ξ> len(n.cp群组物体)-1):
                        n.ip激活群组物体ξ = len(n.cp群组物体)-1;

        #ΔΔUPDATE激活的预置名(self, context);#这个必须
        self.bp不弹出=False;
        #--------------------------------------------------------------------------
        return {'FINISHED'};
        pass
        
#//////////////////////////////////////////////////
class 卐激活IMDJS_node卐Operator(bpy.types.Operator):#刷新按钮
    bl_idname = "op.active_imdjsnode"
    bl_label = "active"
    bl_description="active IMDJS_node"
    #--------------------------------------------------------------------------
    ip序号=IntProperty(name='',description='',default=0,min=-1,max=10,step=1,subtype='NONE',update=None,get=None,set=None);

    def execute(self, context):
        wm=context.window_manager;
        Lnt我的=[nt for nt in bpy.data.node_groups if(nt.bl_idname=="imdjs_nodes")];
        space = context.space_data;space.tree_type = "imdjs_nodes";
        i长=len(Lnt我的);i长cp=len(wm.cp节点列表w);
        if(i长<1):
            self.report({"INFO"},"NONE");#"INFO" "ERROR" "DEBUG" "WARNING"
            return {"FINISHED"};
        else:
            i减=i长-i长cp;
            if(i减>0):
                for i in range(i减):
                    wm.cp节点列表w.add();
            for i,nt in enumerate(Lnt我的):
                wm.cp节点列表w[i].name=nt.name;

        if(self.ip序号==-1):
            idx=Lnt我的.index(space.node_tree);
            print("idx==",idx);
            if(i长<idx+2):
                space.node_tree=Lnt我的[0];
                #self.report({"ERROR"},"out of range");#"INFO" "ERROR" "DEBUG" "WARNING"
                return {"FINISHED"};
            space.node_tree=Lnt我的[idx+1];
            return {"FINISHED"};
        if(i长<self.ip序号+1):
            self.report({"ERROR"},"out of range");#"INFO" "ERROR" "DEBUG" "WARNING"
            return {"FINISHED"};
        nt=Lnt我的[self.ip序号];
        #----激活节点树--------------------------------------------------------------
        space.node_tree=nt;
        return {'FINISHED'};

#////////////////////////////////////////////////
class 卐删除IMDJS_node卐Operator(bpy.types.Operator):#刷新按钮
    bl_idname = "op.delete_imdjsnode"
    bl_label = "delete"
    bl_description="delete IMDJS_node"
    sp=StringProperty(name="note:", description="", default="are you sure delete node ? :");
    #--------------------------------------------------------------------------
    def draw(self, context):    self.layout.prop(self, "sp");

    def invoke(self, context, event):
        space = context.space_data;nt=space.node_tree;
        self.sp+=nt.name;
        return context.window_manager.invoke_props_dialog(self,400,50);#召唤

    def execute(self, context):
        ΔΔ清空LsNGG();
        wm=context.window_manager;
        space = context.space_data;nt=space.node_tree;
        Lnt我的=[nt for nt in bpy.data.node_groups if(nt.bl_idname=="imdjs_nodes")];
        i长=len(Lnt我的);
        if(nt.bl_idname=="imdjs_nodes"):
            idx=Lnt我的.index(nt);wm.cp节点列表w.remove(idx);
            if(i长<idx+2):
                idx=idx-1;#前一个
            else:
                idx=idx+1;
            nt下一个=Lnt我的[idx];
            nt.use_fake_user=False;
            nt.user_clear();
            bpy.data.node_groups.remove(nt);#Lnt我的.remove(nt);
            space.node_tree=nt下一个;
            #ΔΔ刷新界面LIB("NLA_EDITOR","HEADER");
        return {"FINISHED"};
        
#////////////////////////////////////////////////
class 卐删除IMDJS_node_root卐Operator(bpy.types.Operator):#刷新按钮
    bl_idname = "op.delete_imdjsnode_root"
    bl_label = "delete"
    bl_description="delete IMDJS_node_root"
    sp=StringProperty(name="note:", description="", default="are you sure delete node of this root ? :");
    #--------------------------------------------------------------------------
    def draw(self, context):    self.layout.prop(self, "sp");

    def invoke(self, context, event):
        return context.window_manager.invoke_props_dialog(self,400,50);#召唤
  
    def execute(self, context):
        ΔΔ清空LsNGG();Ln要删除node=[];Ls已经删除node=[];
        wm=context.window_manager;
        space = context.space_data;nt=space.node_tree;
        if(nt.bl_idname=="imdjs_nodes"):
            for n in nt.nodes:
                if(n.select ):
                    #----找n 所有链接node-------------------------------------------------------
                    if(n not in Ln要删除node):
                        n开始=nΔΔ找到开始节点up(n);
                        if(n开始):
                            Ln要删除node.append(n开始);Ls已经删除node.append(n开始.name);
                            if(n开始.inputs["INPUT"].links):
                                n群组=n开始.inputs["INPUT"].links[0].from_node;
                                if(n群组 not in Ln要删除node):
                                    Ln要删除node.append(n群组);Ls已经删除node.append(n群组.name);
                            #--------------------------------------------------------------------------
                            def Δ循环删除(link):
                                #print("link.to_socket.bl_idname==",link.to_socket.identifier);
                                if(link.to_socket.identifier=="INPUT"):
                                    n下一个=link.to_node;
                                    if(n下一个):
                                        if(n下一个 not in Ln要删除node):
                                            Ln要删除node.append(n下一个);Ls已经删除node.append(n下一个.name);
                                        if(n下一个.outputs["OUTPUT"].links):
                                            for link in n下一个.outputs["OUTPUT"].links:
                                                Δ循环删除(link);
                                        else:
                                            return ;
                            #--------------------------------------------------------------------
                            for link in n开始.outputs["OUTPUT"].links:
                                Δ循环删除(link);

        #--------------------------------------------------------------------------
        for n in Ln要删除node:
            nt.nodes.remove(n);
        for s in Ls已经删除node:
            self.report({"ERROR"},"have deleted nodes: %s"%s);#"INFO" "ERROR" "DEBUG" "WARNING"
        Ln要删除node.clear();
        return {"FINISHED"};
        
#///////////////////////////////////////////////
class 卐删除IMDJS_node_this卐Operator(bpy.types.Operator):#刷新按钮
    bl_idname = "op.delete_imdjsnode_this"
    bl_label = "delete"
    bl_description="delete_imdjsnode_this"

    def execute(self, context):
        ΔΔ清空LsNGG();Ls已经删除node=[];
        wm=context.window_manager;
        space = context.space_data;nt=space.node_tree;
        if(nt.bl_idname=="imdjs_nodes"):
            for n in nt.nodes:
                if(n.select ):
                    Ls已经删除node.append(n.name);
                    nt.nodes.remove(n);
            #ΔΔ刷新界面LIB("NLA_EDITOR","HEADER");
            
        for s in Ls已经删除node:
            self.report({"ERROR"},"have deleted nodes: %s"%s);#"INFO" "ERROR" "DEBUG" "WARNING"
        return {"FINISHED"};
        

        
#////////////////////////////////////////////////
class 卐INSERT前面一个节点卐Operator(bpy.types.Operator):
    bl_idname = "op.insert_node_psr";
    bl_label = "insert_node_psr";
    bl_description= "insert_node__psr"
    bl_options={'UNDO'};
    bl_context='object';

    sp=StringProperty(name="note!", description="", default="are you sure get the PSR of active object?");
    sp类型=StringProperty(name="type", description="", default="");
    ep插入类型 = EnumProperty( name="value type", description="value type",items=  [("LOC","loc","---","NONE",0),("ROT", "rot","---.","NONE",1) ,("SCALE", "scale","---.","NONE",2),("PSR", "psr","---.","NONE",3),("ATTRIBUTE", "attribute","---.","NONE",4),("SHAPE", "shape","---.","NONE",5) ],default="LOC");

    ip新节点时间=IntProperty(name='node time',description='',default=25,min=1,max=5000,step=1,subtype='NONE',update=None,get=None,set=None);
    #--------------------------------------------------------------------------
    def draw(self, context):
        self.layout.prop(self, "sp");
        self.layout.prop(self, "ep插入类型", emboss=True);
        uil=self.layout.row(align=True);
        uil.prop(self, "ip插入的帧",); uil.prop(self, "ip新节点时间",);

    def invoke(self, context, event):
        self.nThis=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        if(self.nThis):
            if(self.nThis.inputs["INPUT"].links):
                self.n前面=self.nThis.inputs["INPUT"].links[0].from_node;
                if(self.n前面==None):
                    self.report({"ERROR"},"there is no node front");#"INFO" "ERROR" "DEBUG" "WARNING"
                    return {"CANCELLED"};

                return context.window_manager.invoke_props_dialog(self,300,50);#召唤

        return {"CANCELLED"};

    def execute(self, context):
        space = context.space_data;nt=space.node_tree;
        i减时间=self.nThis.ip节点时间-self.ip新节点时间;
        if(i减时间<0):
            self.ip新节点时间=self.nThis.ip节点时间;

        f时间Ξ=self.ip新节点时间/self.nThis.ip节点时间;
        
        n群组=nΔΔ找到群组节点( self.nThis);
        if(n群组!=None):
            if(self.ep插入类型=="LOC"):
                nNew=nt.nodes.new(type="IMDJS_NodeLocation");
            elif(self.ep插入类型=="ROT"):
                nNew=nt.nodes.new(type="IMDJS_NodeRotate");
            elif(self.ep插入类型=="SCALE"):
                nNew=nt.nodes.new(type="IMDJS_NodeScale");
            elif(self.ep插入类型=="PSR"):
                nNew=nt.nodes.new(type="IMDJS_NodePSR");
            elif(self.ep插入类型=="ATTRIBUTE"):
                nNew=nt.nodes.new(type="IMDJS_NodeSetAttri");
            elif(self.ep插入类型=="SHAPE"):
                nNew=nt.nodes.new(type="IMDJS_CurveSK");      
            #====位置与link=======================================================
            nNew.location=f2__f2十f2Ξ2(self.nThis.location,self.n前面.location);
            Llink=nt.links;
            ns输入=nNew.inputs["INPUT"];
            ns输出=self.n前面.outputs["OUTPUT"];
            Llink.new(ns输出,ns输入);
            ns输入=self.nThis.inputs["INPUT"];
            ns输出=nNew.outputs["OUTPUT"];
            Llink.new(ns输出,ns输入);
            #----时间----------------------------------------------------------------
            nNew.ip节点时间=self.ip新节点时间;
            self.nThis.ip节点时间-=self.ip新节点时间;
            
            ns本节点input= nNew.inputs["INPUT"];#print(">>>>>>",G.Li当前帧GG[0], self.ip实际帧 );
            i本节点开始时刻=ns本节点input.ip接口开始时刻 = self.n前面.ip节点时间;
            if(ns本节点input.ip接口开始时刻!=i本节点开始时刻):
                ns本节点input.ip接口开始时刻=i本节点开始时刻;
            i运动时刻end=i本节点开始时刻+ nNew.ip节点时间;
            if(nNew.ip实际帧 !=i运动时刻end+nNew.ip停止时间):
                nNew.ip实际帧=nNew.ip实际帧 =i运动时刻end+nNew.ip停止时间;
            #--------------------------------------------------------------------------
            for s物名,o  in G.Ds物oGG.items():
                if(s物名 in n群组.cp群组物体.keys()):
                    idx当前物ξ=n群组.cp群组物体.keys().index(s物名);
  
                    pg关键帧记录=self.nThis.cp物序此节点关键帧记录[idx当前物ξ];
                    pg关键帧记录前面=self.n前面.cp物序此节点关键帧记录[idx当前物ξ];

                    #----LOC------------------------------------------------------------------
                    if(self.ep插入类型=="LOC"):
                        f3插值=f3__f3十f3(pg关键帧记录前面.fvp3loc, f3__f3Χf(f3__f3一f3(pg关键帧记录.fvp3loc, pg关键帧记录前面.fvp3loc),f时间Ξ));
                    #----ROT------------------------------------------------------------------
                    elif(self.ep插入类型=="ROT"):
                        f3插值=f3__f3十f3(pg关键帧记录前面.fvp3euler,f3__f3Χf(f3__f3一f3(pg关键帧记录.fvp3euler, pg关键帧记录前面.fvp3euler),f时间Ξ) );
                    #----SCALE------------------------------------------------------------------
                    elif(self.ep插入类型=="SCALE"):
                        f3插值=f3__f3十f3(pg关键帧记录前面.fvp3scale,f3__f3Χf(f3__f3一f3(pg关键帧记录.fvp3scale, pg关键帧记录前面.fvp3scale),f时间Ξ));

                    #----PSR-----------------------------------------------------------------
                    elif(self.ep插入类型=="PSR"):
                        f3插值Loc=f3__f3十f3(pg关键帧记录前面.fvp3loc,f3__f3Χf(f3__f3一f3(pg关键帧记录.fvp3loc, pg关键帧记录前面.fvp3loc),f时间Ξ));
                        f3插值Rot=f3__f3十f3( pg关键帧记录前面.fvp3euler,f3__f3Χf(f3__f3一f3(pg关键帧记录.fvp3euler, pg关键帧记录前面.fvp3euler),f时间Ξ));
                        f3插值Scale=f3__f3十f3(pg关键帧记录前面.fvp3scale,f3__f3Χf(f3__f3一f3(pg关键帧记录.fvp3scale, pg关键帧记录前面.fvp3scale),f时间Ξ));

                    #----少则add-------------------------------------------------------------
                    i缺了多少物=(idx当前物ξ+1)-len( nNew.cp物序此节点关键帧记录);
                    if(i缺了多少物>0):
                        for i in range(i缺了多少物):
                            nNew.cp物序此节点关键帧记录.add();
                            #print("add",len(nNew.cp物序此节点关键帧记录));#√
                    pg关键帧记录new=nNew.cp物序此节点关键帧记录[idx当前物ξ];
                    #----赋值----------------------------------------------------------------
                    if(self.ep插入类型=="LOC"):
                        pg关键帧记录new.fvp3loc=f3插值;
                        pg关键帧记录new.fvp3euler=pg关键帧记录前面.fvp3euler;
                        pg关键帧记录new.fvp4q=pg关键帧记录前面.fvp4q;
                        pg关键帧记录new.fvp3scale=  pg关键帧记录前面.fvp3scale;
                    elif(self.ep插入类型=="ROT"):
                        pg关键帧记录new.fvp3euler=f3插值;
                        pg关键帧记录new.fvp4q=pg关键帧记录前面.fvp4q;
                        pg关键帧记录new.fvp3loc=pg关键帧记录前面.fvp3loc;
                        pg关键帧记录new.fvp3scale=pg关键帧记录前面.fvp3scale;
                    elif(self.ep插入类型=="SCALE"):
                        pg关键帧记录new.fvp3scale=f3插值;
                        pg关键帧记录new.fvp3loc=pg关键帧记录前面.fvp3loc;
                        pg关键帧记录new.fvp3euler=pg关键帧记录前面.fvp3euler;
                        pg关键帧记录new.fvp4q=pg关键帧记录前面.fvp4q;
                    elif(self.ep插入类型=="PSR"):
                        pg关键帧记录new.fvp3loc=f3插值Loc;
                        pg关键帧记录new.fvp3euler=f3插值Rot;
                        pg关键帧记录new.fvp4q=pg关键帧记录前面.fvp4q;
                        pg关键帧记录new.fvp3scale=f3插值Scale;
                        
                    elif(self.ep插入类型 in["SHAPE","ATTRIBUTE"]):
                        pg关键帧记录new.fvp3euler=pg关键帧记录前面.fvp3euler;
                        pg关键帧记录new.fvp4q=pg关键帧记录前面.fvp4q;
                        pg关键帧记录new.fvp3loc=pg关键帧记录前面.fvp3loc;
                        pg关键帧记录new.fvp3scale=pg关键帧记录前面.fvp3scale;      
                        

        #ΔΔ更新所有节点时刻(None);
        return {"FINISHED"};
        
#////////////////////////////////////////////////
class 卐PICK_TIME卐Operator(bpy.types.Operator):
    bl_idname = "op.pick_current_time";
    bl_label = "pick_current_time";
    bl_description = "pick the current time to this node end time";
    bl_options= {"REGISTER", "UNDO"};
    #ip当前帧=IntProperty(name='',description='',default=0,min=0,max=100000step=1,subtype='NONE',update=None,get=None,set=None);
    bp是保持后面节点时间不变=BoolProperty(name='',description="perserve the following node's time is no change",default=False,subtype='NONE',update=None,get=None,set=None);
    #--------------------------------------------------------------------------
    nThis=None;
    @classmethod
    def poll(cls, context):
        return  context.active_object;
    def draw(self, context):
        uil界= self.layout;
        uil界.prop(self, "bp是保持后面节点时间不变",text="perserve time", emboss=True);

    def invoke(self, context, event):
        #bpy.ops.object.select_all(action='DESELECT');
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();
        self.nThis=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        return context.window_manager.invoke_props_dialog(self,200,50);#召唤
        #return {'CANCELLED'}

    def execute(self, context):
        #ΔΔ更新所有节点时刻(None);
        scene=context.scene;space = context.space_data;
        if(self.nThis!=None):
            if(self.nThis.bl_idname=="IMDJS_NodeStart"):
                self.nThis.ip节点时间=scene.frame_current;#=self.ip当前帧;
            #----不是开始节点------------------------------------------------------------
            else:
                n开始=nΔΔ找到开始节点up(self.nThis);n开始.Δ升级节点(space.node_tree,scene);#更新节点时刻
                if(n开始==None):
                    self.report({"ERROR"},"没有开始节点");#"INFO" "ERROR" "DEBUG" "WARNING"
                    return {"FINISHED"};
                #--------------------------------------------------------------------------
                n前面=self.nThis.inputs["INPUT"].links[0].from_node;
                i时间偏移相对前节点=scene.frame_current-n前面.ip实际帧;
                print("iOffset==",i时间偏移相对前节点,n前面.ip实际帧,self.nThis.label);#i时间偏移相对前节点==ip节点时间+ip停止时间
                #----负数,就要移动前面节点时间-------------------------------------------------
                if(i时间偏移相对前节点<0):
                    #----开始节点-------------------------------------------------------------
                    if(n前面.bl_idname=="IMDJS_NodeStart"):
                        if(self.bp是保持后面节点时间不变):
                            n前面.ip节点时间+=i时间偏移相对前节点;
                            n前面.ip实际帧 =n前面.ip节点时间;
                            self.nThis.ip节点时间=0;
                        else:
                            i相差运动时间=n前面.ip节点时间+i时间偏移相对前节点;
                            #----开始节点时间够多--------------------------------------------------
                            if(i相差运动时间>0):#┃==┃<----
                                #ns前面.ip接口开始时刻=n前面.ip节点时间=i相差运动时间;#Χ 这个不是指针
                                self.nThis.ip实际帧=n前面.ip实际帧 =n前面.ip节点时间=i相差运动时间;
                                self.nThis.ip节点时间=0;
                                for link in self.nThis.outputs["OUTPUT"].links:
                                    link.to_node.inputs["INPUT"].ip接口开始时刻 =self.nThis.ip实际帧;#把本节点尾时刻传给下一节点
                            else:self.report({"ERROR"},"开始节点时间不够多:%s"%(n前面.label));#"INFO" "ERROR" "DEBUG" "WARNING"
                    #----正常节点--------------------------------------------------------------
                    else:
                        if(self.bp是保持后面节点时间不变):
                            n前面.ip节点时间+=i时间偏移相对前节点;
                            n前面.ip实际帧 =n前面.ip节点时间+n前面.ip停止时间;
                            self.nThis.ip节点时间=0;

                        else:
                            i相差运动时间=n前面.ip节点时间+i时间偏移相对前节点;#+n前面.ip停止时间
                            #----前面节点时间够多--------------------------------------------------
                            if(i相差运动时间>0):
                                #ns前面.ip接口开始时刻=n前面.ip节点时间=i相差运动时间;#Χ 这个不是指针
                                n前面.ip节点时间=i相差运动时间;
                                self.nThis.ip实际帧=n前面.ip实际帧 =n前面.inputs["INPUT"].ip接口开始时刻+n前面.ip节点时间+n前面.ip停止时间;
                                self.nThis.ip节点时间=0;
                                for link in self.nThis.outputs["OUTPUT"].links:
                                    link.to_node.inputs["INPUT"].ip接口开始时刻 =self.nThis.ip实际帧;#把本节点尾时刻传给下一节点
                            else:self.report({"ERROR"},"前面节点时间不够移位:%s"%(n前面.label));#"INFO" "ERROR" "DEBUG" "WARNING"

                #----正数,i时间偏移相对前节点,影响下一节点-----------------------------------------------
                else:
                    i减了多少时间=(self.nThis.ip节点时间+self.nThis.ip停止时间)-i时间偏移相对前节点;
                    if(i减了多少时间!=0):
                        self.nThis.ip节点时间=i时间偏移相对前节点-self.nThis.ip停止时间;
                        self.nThis.ip实际帧 =scene.frame_current;
                        print("nThis",self.nThis.ip实际帧,i时间偏移相对前节点,self.nThis.label);

                        if(self.bp是保持后面节点时间不变):
                            for link in self.nThis.outputs["OUTPUT"].links:
                                n下一个=link.to_node;
                                i前后减=n下一个.ip节点时间+i减了多少时间;
                                if(i前后减>=0):
                                    n下一个.inputs["INPUT"].ip接口开始时刻 =self.nThis.ip实际帧;
                                    n下一个.ip节点时间+=i减了多少时间;
                                #----后面的节点不够减------------------------------------------------------------
                                else:
                                    self.report({"ERROR"},"后面的节点不够减 %s"%(n下一个.label));#"INFO" "ERROR" "DEBUG" "WARNING"
                                    self.nThis.ip节点时间+=i前后减;scene.frame_current+=i前后减;
                                    self.nThis.ip实际帧 =scene.frame_current;


                        else:
                            for link in self.nThis.outputs["OUTPUT"].links:
                                link.to_node.inputs["INPUT"].ip接口开始时刻 =self.nThis.ip实际帧;#把本节点尾时刻传给下一节点

            if(self.bp是保持后面节点时间不变==False):ΔΔ更新所有节点时刻(None);

            ΔΔ刷新界面LIB(area="NODE_EDITOR",region="WINDOW");

        return {"FINISHED"};

#////////////////////////////////////////////////
class 卐GOTO本节点尾卐Operator(bpy.types.Operator):
    bl_idname = "op.go_to_node_end";
    bl_label = "go_to_node_end";
    bl_description= "execute the node's max value  of active node"
    bl_options={'UNDO'};
    bl_context='object';

    sp=StringProperty(name="note!", description="", default="execute the node's max value  of active node?");

    #--------------------------------------------------------------------------
    def draw(self, context):    self.layout.prop(self, "sp");

    def invoke(self, context, event):
        self.nThis=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        return context.window_manager.invoke_props_dialog(self,300,50);#召唤

    def execute(self, context):
        
        scene=context.scene;space = context.space_data;
        if(self.nThis):
            ΔΔ更新所有节点时刻(self.nThis);#有可能是这个让crash
            if(self.nThis.bl_idname=="IMDJS_NodeStart"):
                G.Li当前帧GG[0]=scene.frame_current=self.nThis.ip节点时间;
                self.nThis.Δ升级节点(space.node_tree,scene);
            else:
                """
                ns本节点input= self.nThis.inputs["INPUT"];
                i本节点开始时刻=ns本节点input.ip接口开始时刻 = ns本节点input.links[0].from_socket.ip接口开始时刻;#●●只取第一个的时间
                i运动时刻end=i本节点开始时刻+ self.nThis.ip节点时间;
                self.nThis.ip实际帧 =i运动时刻end+self.nThis.ip停止时间;#上个节点时间+持续时间为本节点结束时间
                """
                G.Li当前帧GG[0]=scene.frame_current=self.nThis.ip实际帧;
                print("time==",self.nThis.inputs["INPUT"].ip接口开始时刻,self.nThis.ip实际帧);

        return {"FINISHED"};

#////////////////////////////////////////////////
class 卐TIME整体缩放偏移卐Operator(bpy.types.Operator):
    bl_idname = "op.imdjs_nodes_offset";
    bl_label = "imdjs_nodes_offset";
    bl_description= "scale or offset all the node's time or only for selected nodes"
    bl_options={'UNDO'};
    bl_context='object';

    sp=StringProperty(name="note!", description="", default="are you sure to scale or offset the node's time?");
    ip从第几帧开始=IntProperty(name='',description='from what frame to count',default=0,min=0,max=10000,step=1,subtype='NONE',update=None,get=None,set=None);

    ep类型 = EnumProperty( name="type", description="what type to do",items=  [("SCALE","scale","","MAN_SCALE",0), ("OFFSET", "offset","","MAN_TRANS",1) ],default="SCALE");
    #--------------------------------------------------------------------------
    ip偏移帧数=IntProperty(name='',description='',default=0,min=-3000,max=3000,step=1,subtype='NONE',update=None,get=None,set=None);
    fp缩放倍数=FloatProperty(name='',description='',default=1.0,min=0.01,max=10.0,step=3,precision=2,subtype='NONE',unit='NONE',update=None,get=None,set=None);
    ep类型选择 = EnumProperty( name="SCALE type", description="what type to SCALE",items=  [("SELECTED","selected","only for selected nodes","RESTRICT_SELECT_OFF",0), ("ACTIVE_TREE", "active_tree","all nodes of current node tree","PMARKER_SEL",1) , ("ALL", "all","all the nodes ","ZOOM_ALL",2)  ],default="ALL");
    #--------------------------------------------------------------------------
    def draw(self, context):
        self.layout.prop(self, "sp");
        uil行 = self.layout.row(align=True);
        uil行.prop_enum(self,  "ep类型", value="SCALE", text="Scale", text_ctxt="", translate=True, icon="MAN_SCALE");
        uil行.prop_enum(self,  "ep类型", value="OFFSET", text="Offset", text_ctxt="", translate=True, icon="MAN_TRANS");

        uil行 = self.layout.row(align=True);
        uil行.prop_enum(self,  "ep类型选择", value="SELECTED", text="selected", text_ctxt="", translate=True, icon="RESTRICT_SELECT_OFF");
        uil行.prop_enum(self,  "ep类型选择", value="ACTIVE_TREE", text="active_tree", text_ctxt="", translate=True, icon="PMARKER_SEL");
        uil行.prop_enum(self,  "ep类型选择", value="ALL", text="all", text_ctxt="", translate=True, icon="ZOOM_ALL");

        #if(self.ep类型=="SCALE"):
        self.layout.prop(data=self,property="ip从第几帧开始",text='from what frame',text_ctxt='',translate=True,icon='NONE',expand=False,slider=True,toggle=False,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);
        uil行 = self.layout.row(align=True);
        uil行.prop(data=self,property="fp缩放倍数",text='scale',text_ctxt='',translate=True,icon='NONE',expand=False,slider=True,toggle=False,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);
        #elif(self.ep类型=="OFFSET"):
        uil行.prop(data=self,property="ip偏移帧数",text='offset',text_ctxt='',translate=True,icon='NONE',expand=False,slider=False,toggle=False,icon_only=False,event=False,full_event=False,emboss=True,index=-1,icon_value=0);

    def invoke(self, context, event):

        return context.window_manager.invoke_props_dialog(self,300,50);#召唤

    def execute(self, context):
        G.Lb是要updateGG[0]=False;
        scene=context.scene;space = context.space_data;
        if(G.LntIMDJS节点GG==[]):
            Δ填充LntIMDJS节点GG();

        for nt in G.LntIMDJS节点GG:#nodetree
            if(self.ep类型选择=="ACTIVE_TREE"  and space.node_tree!=nt):continue;
            for n in nt.nodes:
                #----普通节点--------------------------------------------------------------
                if(self.ep类型选择=="ALL" or ( self.ep类型选择=="SELECTED" and n.select)):
                    if(n.bl_idname not in ["IMDJS_NodeStart","IMDJS_NodeOutPutGroup"]):
                        if(self.ep类型=="SCALE"):
                            if(self.ip从第几帧开始>0):
                                if(n.ip实际帧>=self.ip从第几帧开始>n.inputs["INPUT"].ip接口开始时刻):#找到这个节点
                                    i右边多少帧=n.ip实际帧-self.ip从第几帧开始;
                                    i右Ξ=i右边多少帧/(n.ip节点时间 +n.ip停止时间);
                                    n.ip节点时间 =(int)(n.ip节点时间 *(1-i右Ξ+self.fp缩放倍数*i右Ξ));
                                    #print("this node  ",n.label,n.ip实际帧,self.ip从第几帧开始,n.inputs["INPUT"].ip接口开始时刻,i右Ξ);
                                    if(hasattr(n,'ip停止时间')):
                                        n.ip停止时间 =(int)(n.ip停止时间*(1-i右Ξ+self.fp缩放倍数*i右Ξ));
                                else:
                                    if(n.ip实际帧>self.ip从第几帧开始):
                                        print("oter node  ",n.label,n.ip实际帧,self.ip从第几帧开始,n.inputs["INPUT"].ip接口开始时刻);
                                        n.ip节点时间 =(int)(n.ip节点时间 *self.fp缩放倍数);
                                        if(hasattr(n,'ip停止时间')):
                                            n.ip停止时间 =(int)(n.ip停止时间*self.fp缩放倍数);
                        #--------------------------------------------------------------------------
                        elif(self.ep类型=="OFFSET"):
                            print("OFFSET---------",);
                            if(self.ip从第几帧开始>0):
                                #print("offset",n.ip实际帧, n.inputs["INPUT"].ip接口开始时刻 );
                                if(n.ip实际帧>=self.ip从第几帧开始>n.inputs["INPUT"].ip接口开始时刻):
                                    if(n.ip节点时间+self.ip偏移帧数>0):#偏移后不能是负数
                                        n.ip节点时间+=self.ip偏移帧数;
                                        self.report({"ERROR"},"成功偏移 %s   %d  %d"%(n.name,n.ip实际帧,n.inputs["INPUT"].ip接口开始时刻));#"INFO" "ERROR" "DEBUG" "WARNING"

                                    else:
                                        self.report({"ERROR"},"偏移帧数少于此节点时间 :%s %d %d"%(n.name,n.ip节点时间,self.ip偏移帧数));#"INFO" "ERROR" "DEBUG" "WARNING"

                    #----开始节点--------------------------------------------------------------
                    else:
                        if(n.bl_idname in ["IMDJS_NodeStart"]):
                            
                            if(self.ep类型=="SCALE"):
                                if(self.ip从第几帧开始==0):
                                    n.ip节点时间=(int)(n.ip节点时间*self.fp缩放倍数);
                            elif(self.ep类型=="OFFSET"):
                                #if(self.ip从第几帧开始==0):
                                    #print("is IMDJS_NodeStart",n.ip节点时间,self.ip偏移帧数);
                                    if(n.ip节点时间+self.ip偏移帧数>0):#偏移后不能是负数
                                        n.ip节点时间+=self.ip偏移帧数;
                                        self.report({"ERROR"},"成功偏移了开始节点:%s  %d"%(n.name,self.ip偏移帧数));#"INFO" "ERROR" "DEBUG" "WARNING"
                                    else:
                                        self.report({"ERROR"},"偏移帧数少于开始帧 :%s"%(n.name));#"INFO" "ERROR" "DEBUG" "WARNING"


            #if(self.ep类型选择=="SELECTED"):
        #----升级所有开始节点,计算节点时刻--------------------------------------------
        G.Lb是要updateGG[0]=True;ΔΔ更新所有节点时刻(None);

        return {"FINISHED"};

#////////////////////////////////////////////////
class 卐UPDATE旧节点卐Operator(bpy.types.Operator):
    bl_idname = "op.update_exe";
    bl_label = "update_exe";
    bl_description = "update old nodes";

    nA=None;
    @classmethod
    def poll(cls, context):
        return  context.active_object;

    def invoke(self, context, event):
        #bpy.ops.object.select_all(action='DESELECT');
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();
        self.nThis=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        return self.execute(context);
        #return {'CANCELLED'}

    def execute(self, context):
        #oA=context.active_object;
        scene=context.scene;

        if(self.nThis!=None):
            n群组=nΔΔ找到群组节点(self.nThis);
            if(n群组!=None):
                for s物名,o  in G.Ds物oGG.items():
                    if(s物名 in n群组.cp群组物体.keys()):
                        self.nThis.Δ升级节点(scene,"",o);
            #self.report({"ERROR"},"升级节点");#"INFO" "ERROR" "DEBUG" "WARNING"
        return {"FINISHED"};

#////////////////////////////////////////////////
class 卐UPDATE节点debug卐Operator(bpy.types.Operator):
    bl_idname = "op.update_node_debug";
    bl_label = "update_node_debug";
    bl_description = "try to excute the node to check if there are something wrong with it";

    #--------------------------------------------------------------------------
    n开始=None;
    @classmethod
    def poll(cls, context):
        return  context.active_object;

    def invoke(self, context, event):
        #bpy.ops.object.select_all(action='DESELECT');
        #if(G.LntIMDJS节点GG==[]):Δ填充LntIMDJS节点GG();
            
        self.n开始=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        #----其它节点--------------------------------------------------------------
        if(self.n开始.bl_idname!="IMDJS_NodeStart"):
            self.n开始=nΔΔ找到开始节点up(self.n开始);

        return self.execute(context);
        #return {'CANCELLED'}

    def execute(self, context):
        scene=context.scene;space = context.space_data;
        if(self.n开始!=None):
            G.Li当前帧GG[0]=scene.frame_current#=self.ip当前帧;
            self.n开始.Δ升级节点(space.node_tree,scene);
            ΔΔ刷新界面LIB(area="VIEW_3D",region="WINDOW");
            #----update MUSH---------------------------------------------------------
            oA=context.active_object;
            if(oA.type=="MESH"):
                oA.data.update();
        return {"FINISHED"};

#////////////////////////////////////////////////
class 卐UNDO_REDO卐Operator(bpy.types.Operator):
    bl_idname = "op.undo_redo";
    bl_label = "undo_redo";
    bl_description = "using this  undo_redo  operator  to prevent cashing";
    #bl_options={'UNDO'};
    bl_context='object';

    ipUndoStep=IntProperty(name='UndoStep',description='UndoStep',default=1,min=0,max=10,step=1,subtype='NONE',update=None,get=None,set=None);
    bp是undo=BoolProperty(name='',description='',default=True,subtype='NONE',update=None,get=None,set=None);
    #--------------------------------------------------------------------------
    n开始=None;
    @classmethod
    def poll(cls, context):
        return  context.active_object;
    def  draw(self,context):
        self.layout.prop(data=self,property="ipUndoStep",text='',text_ctxt='',translate=True,icon='NONE',);
        
    def invoke(self, context, event):
        return context.window_manager.invoke_props_dialog(self,400,50);

    def execute(self, context):
        ΔΔ清空LsNGG();

        #--------------------------------------------------------------------------
        if(self.bp是undo):
            for i in range(self.ipUndoStep):
                bpy.ops.ed.undo();
                
        else:
            for i in range(self.ipUndoStep):
                bpy.ops.ed.redo();

        return {"FINISHED"};
        
#//////////////////////////////////////////////////
class 卐TEMPLATE新建节点GG卐Operator(bpy.types.Operator):#刷新按钮
    bl_idname = "op.imdjs_build_node_template"
    bl_label = "'new node template"
    bl_description="reflash and build new base node template"
    
    ep插入类型 = EnumProperty( name="tamplate type", description="node tamplate type",items=  [("LOC","loc","---","NONE",0),("ROT", "rot","---.","NONE",1) ,("SCALE", "scale","---.","NONE",2),("PSR", "psr","---.","NONE",3)  ,("ATTRIBUTE", "attribute","---.","NONE",4) ],default="LOC");
    
    #def invoke(self, context, event):
        #return context.window_manager.invoke_props_dialog(self,width=200);
    #--------------------------------------------------------------------------
    def draw(self, context):
        self.layout.props_enum(data=self, property="ep插入类型");#单行切换按钮
    def invoke(self, context, event):
        return context.window_manager.invoke_props_dialog(self,200,50);#召唤

    def execute(self, context):
        
        Δ填充LntIMDJS节点GG();
        if(G.Do物m3修改器单个GG=={}):
            Δ填充Do物m3修改器单个2GG();
        #print("REFLASH LoMT==",G.LoN物GG);
        #print("REFLASH G.Do物m3修改器单个GG==",G.Do物m3修改器单个GG);
        #----测试--新建MT 节点-----------------------------------------------------------
        space = context.space_data;
        Lnt我的=bpy.data.node_groups;
        if(G.LntIMDJS节点GG==[]):
            nt=Lnt我的.new(name="IMDJS", type="imdjs_nodes");#type->bl_idname
        else:
            nt=space.node_tree;
        Cn=nt.nodes;
        n开始=Cn.new(type="IMDJS_NodeStart");#type->bl_idname
        ns输入=n开始.inputs["INPUT"];
        n群组=Cn.new(type="IMDJS_NodeOutPutGroup");
        n群组.location[0]=n开始.location[0]-230;
        ns输出=n群组.outputs["OUTPUT"];
        Llink=nt.links;
        Llink.new(ns输出,ns输入);
        #----建输出节点---------------------------------------------------------------
        if(self.ep插入类型=="LOC"):
            n输出=Cn.new(type="IMDJS_NodeLocation");
        elif(self.ep插入类型=="ROT"):
            n输出=Cn.new(type="IMDJS_NodeRotate");
        elif(self.ep插入类型=="SCALE"):
            n输出=Cn.new(type="IMDJS_NodeScale");            
        elif(self.ep插入类型=="PSR"):
            n输出=Cn.new(type="IMDJS_NodePSR");
        elif(self.ep插入类型=="ATTRIBUTE"):
            n输出=Cn.new(type="IMDJS_NodeSetAttri");
            
        
        n输出.location[0]=n开始.location[0]+230;
        ns输出=n开始.outputs["OUTPUT"];
        ns输入=n输出.inputs["INPUT"];
        Llink.new(ns输出,ns输入);
        #----打印-----------------------------------------------------------------
        nA=context.active_node;
        """
        for nt in bpy.data.node_groups:
            if(nt.bl_idname=="imdjs_nodes"):
                for n in nt.nodes:
        """
        if(nA):
            if (nA.bl_idname == "IMDJS_NodeOutPutGroup" ):#如果是群组节点
                for pg in  nA.cp群组物体:
                    #print("PG==",pg);
                    pass;

        print("LoNGG",len(G.LoN物GG));
        return {'FINISHED'};
        
#//////////////////////////////////////////////////
class 卐重新建父子层级卐Operator(bpy.types.Operator):#刷新按钮
    bl_idname = "op.imdjs_rebuild_parent"
    bl_label = "imdjs_rebuild_parent"
    bl_description="rebuild parent relationship if your scene objects's parent relationship have been changed"
    #name = StringProperty();

    #def invoke(self, context, event):
        #return context.window_manager.invoke_props_dialog(self,width=200);

    def execute(self, context):
        Δ填充LntIMDJS节点GG();
    
        return {"FINISHED"};
        
#////////////////////////////////////////////////
class 卐去除MT属性卐Operator(bpy.types.Operator):
    bl_idname = "op.imdjs_remove"
    bl_label = "remove LoNGG"

    #name = StringProperty();

    #def invoke(self, context, event):
        #return context.window_manager.invoke_props_dialog(self,width=200);

    def execute(self, context):
        #global G.LoN物GG,G.LoN物之前GG;G.LoN物GG=[];
        for o in context.scene.objects:
            if(o.dupli_group ):#组物有MT节点
                for o in o.dupli_group.objects:
                    if(not o.dupli_group and o in G.LoN物GG):
                        G.LoN物GG.remove(o);
                    else:
                        for o in o.dupli_group.objects:
                            if(not o.dupli_group and o in G.LoN物GG):
                                G.LoN物GG.remove(o);
            #--------------------------------------------------------------------------
            if(o in G.LoN物GG):
                    G.LoN物GG.remove(o);

        print("LoMTg==",G.LoN物GG);
        return {'FINISHED'};




#======================================================
class 卐禁用所选节点卐Operator(bpy.types.Operator):
    bl_idname = "op.imdjs_disable"
    bl_label = "disable  selected nodes"
    def execute(self, context):
        for nt in bpy.data.node_groups:
            #print("nt.bl_idname==",nt.bl_idname,nt.name,bpy.data.node_groups);
            if(nt.bl_idname=="imdjs_nodes"and  nt==context.space_data.node_tree):
                for n in nt.nodes:
                    if(n.select):
                        n.bp是禁用节点=not n.bp是禁用节点;
                        print("DISABLE==",n.bp是禁用节点,not n.bp是禁用节点);
                        n.use_custom_color=n.bp是禁用节点;
                        if(n.bp是禁用节点):
                            n.color=(1.0, 0.0, 0.0);#红色
                        self.report({"ERROR"},"disable  selected nodes=="+str(n.bp是禁用节点));#"INFO" "ERROR" "DEBUG" "WARNING"
        return {'FINISHED'};


#//////////////////////////////////////////////////
class 卐升级设置卐Operator(bpy.types.Operator):
    bl_idname = 'op.imdjs_group_update'
    bl_label = 'update'
    bl_description = 'update group'

    def invoke(self, context, event):
        return context.window_manager.invoke_props_dialog(self)#把自身加入到dialog

    def execute(self, context):
        bpy.ops.op.imdjs_objects_add_to_group(bp升级=True);

        return {'FINISHED'}


#//////////////////////////////////////////
def ΔΔ设置初始PSR(o):
    o.pp物PSRo.fvp3位置初始 = o.location;
    o.pp物PSRo.fvp3缩放初始 = o.scale;
    o.pp物PSRo.fvp3旋转初始 = [ math.degrees(o.rotation_euler[0]),math.degrees(o.rotation_euler[1]),math.degrees(o.rotation_euler[2])];
    b细分=False;
    for m3 in o.modifiers:
        if(b细分==False and  m3.type=="SUBSURF"and m3.show_render):
            b细分=True;
            o.pp物PSRo.ip细分级数=m3.render_levels;
            print("SET SUF", o.pp物PSRo.ip细分级数);
    o.pp物PSRo.bp是初始化了PSR=True;

class 卐初始化PSR卐Operator(bpy.types.Operator):
    bl_idname = "op.imdjs_set_init_psr" #刚加入物体 或刷新时运行
    bl_label = "init PSR"

    bp是选物 = BoolProperty(default = False); # bp本地 0 to Active, bp本地 1 to Selected

    @classmethod
    def poll(cls, context):
        return (context.active_object is not None);

    def execute(self,context):
        if (self.bp是选物):
            for o in context.selected_objects:
                ΔΔ设置初始PSR(o);
        else:
            ΔΔ设置初始PSR(context.active_object);
        #----初始化-----------------------------------------------------------------
        print("G.LoN物GG==",G.LoN物GG);
        #for o in G.LoN物GG:
            #if(o.dupli_group ):#组物有MT节点
                #o=o.dupli_group.objects[0];#第壹个是父物体
            #if(o.pp物PSRo.name != ""):
                #print("O==",o);
                #bpy.context.scene.pp场景物体MT设定s2.sp物名 = o.bp是选物;
                #bdnt = bpy.data.node_groups[o.pp物PSRo.name]#BlendDataNodeTrees #从节点树中找到属性中的节点组名
        #----升级找到的节点组中每个节点----------------------------------------------------------
        for nt in G.LntIMDJS节点GG:
            for n in nt.nodes:
                if (n.bl_idname == "IMDJS_NodeRandomPSR"):#如果是开始节点
                    n.Δ初始化();#升级开始节点

        return {"FINISHED"};

#=============================================================
def Δ复制节点属性(self, context,nt,nΩ,s节点名其它,b是link):
    for s属性键 in dir(nΩ):#主物的所有属性键
        if(s属性键 not in self.Ls排除键):
            print("ATTR==",s属性键);
            try:
                setattr(nt.nodes[s节点名其它], s属性键, getattr(nΩ, s属性键))
            except:
                pass;
    if(b是link):
        for NodeSocket in nΩ.inputs:
            if(NodeSocket.name in nt.nodes[s节点名其它].inputs.keys()):
                for NodeSocket2 in nt.nodes[s节点名其它].inputs:
                    if(NodeSocket.bl_idname==NodeSocket2.bl_idname and NodeSocket.name==NodeSocket2.name):
                        try:
                            NodeSocket2.default_value =NodeSocket.default_value;
                        except:
                            pass;
                            
        for NodeSocket in nΩ.outputs:
            if(NodeSocket.name in nt.nodes[s节点名其它].outputs.keys()):
                for NodeSocket2 in nt.nodes[s节点名其它].outputs:
                    if(NodeSocket.bl_idname==NodeSocket2.bl_idname and NodeSocket.name==NodeSocket2.name):
                        try:
                            NodeSocket2.default_value =NodeSocket.default_value;
                        except:
                            pass;



class 卐复制节点属性PSR卐Operator(bpy.types.Operator):
    bl_idname = "op.imdjs_copy_attrir" #刚加入物体 或刷新时运行
    bl_label = "copy attri"
    bl_options = {"REGISTER", "UNDO"}
    bl_description="copy and paste the active node attributes to the selected nodes";

    bp是选物 = BoolProperty(default = False); # bp本地 0 to Active, bp本地 1 to Selected

    sp=StringProperty(name="warning", description="", default="copy and paste the active node attributes to the selected nodes?:");
    spΩ=StringProperty(name="source", description="", default="");
    #spω=StringProperty(name="target", description="", default="");
    cp选节点=CollectionProperty(type=卐name卐PropertyGroup,name='',description='');
    Ls排除键=["location","name","label","select","parent","inputs","outputs"];

    @classmethod
    def poll(cls, context):
        return True;
    #--------------------------------------------------------------------------
    def draw(self, context):
        self.layout.prop(self, "sp");

    def invoke(self, context, event):
        #print("self.cp选节点",self.cp选节点);
        space = context.space_data;
        self.cp选节点.clear();
        if(G.LntIMDJS节点GG==[]):Δ填充LntIMDJS节点GG();#刚开始时
        for nt in G.LntIMDJS节点GG:
            if(space.node_tree==nt):
                for n in nt.nodes:
                    if(nt.nodes.active==n):
                        self.spΩ=n.name;
                        self.sp+=n.label;
                    elif(n.select):
                        pg=self.cp选节点.add();
                        pg.name=n.name;

        return context.window_manager.invoke_props_dialog(self,400,50);#召唤

    def execute(self,context):
        space = context.space_data;
        for nt in G.LntIMDJS节点GG:
            if(space.node_tree==nt):
                nΩ=nt.nodes[self.spΩ];
                for pg in self.cp选节点:
                    Δ复制节点属性(self, context,nt,nΩ,pg.name,True);

        return {"FINISHED"};

#////////////////////////////////////////////////
class 卐选择群组物体卐Operator(bpy.types.Operator):
    bl_idname = "op.select_group_objects";
    bl_label = "select group ojects";
    bl_description = "select group ojects";

    #sp激活预置名=StringProperty();
    #cp群组物体= CollectionProperty(type=卐群组物体卐PropertyGroup);
    #ip激活群组物体ξ= IntProperty(default=0,update=ΔΔUPDATE激活的预置名);
    bp是选=BoolProperty(name='',description='',default=True,subtype='NONE',update=None,get=None,set=None);
    n群组=None;

    @classmethod
    def poll(cls, context):
        return context.mode=="OBJECT";

    def invoke(self, context, event):
        #print("G.LoN物GG group==",G.LoN物GG);
        #for o in G.LoN物GG:print("o==",o.name);
            
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();
        self.n群组=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");
        return self.execute(context);
        #return {'CANCELLED'}

    def execute(self, context):
        if(self.n群组!=None):
            if(self.n群组.bl_idname!="IMDJS_NodeOutPutGroup"):
                self.n群组=nΔΔ找到群组节点(self.n群组);
                if(self.n群组==None):
                    #self.report({"ERROR"},"前面没有群组物!!!");#"INFO" "ERROR" "DEBUG" "WARNING"
                    return {"FINISHED"};

            bpy.ops.object.select_all(action='DESELECT');
            if(self.bp是选==False):return {"FINISHED"};
            #i个物体=0;
            b群组有物体=False;s激活物=self.n群组.cp群组物体.keys()[self.n群组.ip激活群组物体ξ];
            for o  in G.LoN物GG:
                if(o.name in self.n群组.cp群组物体.keys() ):#
                    if(self.n群组.bp只激活物==True):
                        if(o.name!=s激活物):
                            continue;
                            
                    if(o.hide):
                        o.hide=False;o.hide_select=False;#o.hide_render=False;
                        
                    if(o.name==s激活物):
                        context.scene.objects.active=o;
                    o.select=True;
                    b群组有物体=True;
                    
                    #i个物体+=1;
                    #print("o.select",o.select);
            if(b群组有物体==False):
                Δ填充LntIMDJS节点GG();
            #self.report({"ERROR"},"有 %s  个物体在群组"%());#"INFO" "ERROR" "DEBUG" "WARNING"
        return {"FINISHED"};

#////////////////////////////////////////////////
class 卐选择3d物群组卐Operator(bpy.types.Operator):
    bl_idname = "op.select_object_group";
    bl_label = "select_object_group";
    bl_description = "select the group node whitch active object is in the list";

    #sp激活预置名=StringProperty();
    #cp群组物体= CollectionProperty(type=卐群组物体卐PropertyGroup);
    #ip激活群组物体ξ= IntProperty(default=0,update=ΔΔUPDATE激活的预置名);
    bp是选=BoolProperty(name='',description='',default=True,subtype='NONE',update=None,get=None,set=None);
    n群组=None;

    @classmethod
    def poll(cls, context):
        return context.mode=="OBJECT";

    def execute(self, context):
        if(len(G.LoN物GG)==0):
            Δ填充LntIMDJS节点GG();
            
        oA=context.active_object;space = context.space_data;Lnt找到未选中=[];i个找到=0;
        bpy.ops.node.select_all(action='DESELECT');
        for nt in G.LntIMDJS节点GG:
            #if(space.node_tree==nt):
                for n群组 in nt.nodes:
                    if(n群组.bl_idname=="IMDJS_NodeOutPutGroup"):
                        for s物名 in n群组.cp群组物体.keys():
                            if(s物名==oA.name):
                                if(space.node_tree!=nt):
                                    Lnt找到未选中.append(nt);
                                    break;
                                else:
                                    n群组.select=True;i个找到+=1;
                                    #return {"FINISHED"};
        #----如果在本树找不到----------------------------------------------------------
        if(i个找到==0):
            for nt in Lnt找到未选中:
                for n群组 in nt.nodes:
                    if(n群组.bl_idname=="IMDJS_NodeOutPutGroup"):
                        for s物名 in n群组.cp群组物体.keys():
                            if(s物名==oA.name):
                                if(space.node_tree!=nt):
                                    space.node_tree=nt;
                                    bpy.ops.node.select_all(action='DESELECT');
                                    n群组.select=True;
                                    if(len(Lnt找到未选中)>1):
                                        self.report({"ERROR"},"有%d 个nt未选中"%(len(Lnt找到未选中),Lnt找到未选中));#"INFO" "ERROR" "DEBUG" "WARNING"
                                    return {"FINISHED"};
        bpy.ops.node.view_selected();
        #--------------------------------------------------------------------------
        if(i个找到==0):
            self.report({"ERROR"},"此选物不在群组列表");#"INFO" "ERROR" "DEBUG" "WARNING"
        
        if(i个找到>0):
            self.report({"INFO"},"找到 %d  个物体"%(i个找到));#"INFO" "ERROR" "DEBUG" "WARNING"
        return {"FINISHED"};
        
#////画线///////////////////////////////////////
import bgl,blf;
vX=Vector((2.2,0.0,0.0));vY=Vector((0.0,0.2,0.0));vZ=Vector((0.0,0.0,5.0));
v零=Vector((0.0,0.0,0.0));
Lv2屏位=[None,None];

def ΔΔ画画(self,context):#L2v位
    #font_id = 0
    #if(self.v物位==Vector()):return ;

    bgl.glEnable(bgl.GL_BLEND);
    bgl.glBegin(bgl.GL_LINES);
    for i,v物位 in enumerate(self.Lv物位):
        Lv2屏位[0] = view3d_utils.location_3d_to_region_2d(context.region, context.space_data.region_3d,v物位);
        #Lv2屏位[1] = view3d_utils.location_3d_to_region_2d(context.region, context.space_data.region_3d,self.v物位+vZ);
        Lv2屏位[1]=Lv2屏位[0].copy();
        Lv2屏位[1][1] =Lv2屏位[0][1]+50.0;

        L2v位=[self.Lv2屏位[0],self.Lv2屏位[1]];

        #bgl.glColor4f(self.f4颜色);#青色;
        if(self.ip激活群组物体ξ==i):
            bgl.glColor4f(1.0, 1.0, 0.0,1.0);#黄色
        else:
            bgl.glColor4f(0.0, 1.0, 1.0,0.6);#青色;

        #bgl.glLineWidth(3);


        for v位 in Lv2屏位:
            bgl.glVertex2f(v位[0], v位[1]);

    #--------------------------------------------------------------------------
    bgl.glDisable(bgl.GL_BLEND);
    bgl.glEnd();
    #print("DRAW",v物位[0],v物位[1]);


from bpy_extras import view3d_utils
global  i显示G,areaG;i显示G=0;areaG=None;
class 卐画画选卐Operator(bpy.types.Operator):
    bl_idname = "op.draw_line_selected"
    bl_label = "show group objects"
    bl_description = "show group objects"

    #cp群组物体= CollectionProperty(type=卐群组物体卐PropertyGroup);

    _handle = None;
    #ip显示=IntProperty(name='',description='',default=0,subtype='NONE',update=None,get=None,set=None);
    ip激活群组物体ξ= IntProperty(default=-1);
    #self.f3颜色=None;
    Lv物位 =[];
    vZ=Vector((0.0,0.0,0.0));Lv2屏位=[None,None];

    #======================================================
    @classmethod
    def poll(cls, context):
        return context.mode=="OBJECT";

    def modal(self, context, event):
        global  i显示G,areaG;
        #if (context.area):context.area.tag_redraw();
        #----刷新--------------------------------------------------------------
        if(not areaG):
            screen=bpy.context.screen;
            for a in screen.areas:
                if(a.type=="VIEW_3D"):
                    areaG=a;
                    a.tag_redraw();
        else:
            areaG.tag_redraw();
        #----停止--------------------------------------------------------------
        if(i显示G==-1):
            bpy.types.SpaceView3D.draw_handler_remove(self._handle, 'WINDOW');
            #bgl.glDisable(bgl.GL_BLEND);
            i显示G=0;print("REMOVE modal==",i显示G);
            return {"CANCELLED"};

        return {"PASS_THROUGH"};
    #==============================================================
    def invoke(self, context, event):
        global  i显示G;
        if(i显示G< 1):
            i显示G=1;print("BP invoke0==",i显示G);
            #--------------------------------------------------------------------------
            self.n群组=nΔΔ找节点鼠标位置(self,context,event,s节点树类型="imdjs_nodes",s节点类型="");self.Lv物位 =[];
            if(self.n群组!=None):
                if(self.n群组.bl_idname!="IMDJS_NodeOutPutGroup"):
                    self.n群组=nΔΔ找到群组节点(self.n群组);
                    if(self.n群组==None):
                        #self.report({"ERROR"},"前面没有群组物!!!");#"INFO" "ERROR" "DEBUG" "WARNING"
                        return {"CANCELLED"};

                i=0;i找到几个物体=0;
                if(len(G.LoN物GG)==0):
                    Δ填充LntIMDJS节点GG();
                for o in G.LoN物GG:
                    for s物名 in self.n群组.cp群组物体.keys():
                        if(o.name==s物名):
                            if(o.name==self.n群组.cp群组物体.keys()[self.n群组.ip激活群组物体ξ]):
                                self.ip激活群组物体ξ=self.n群组.ip激活群组物体ξ=i;
                                #self.v物位=o.location;
                                #break;
                            print("o.name==",o.name,s物名,i,self.n群组.ip激活群组物体ξ,self.n群组.sp激活预置名);
                            m=o.matrix_world;
                            self.Lv物位.append(Vector((m[0][3],m[1][3],m[2][3])));#这个是引用
                            i+=1;i找到几个物体+=1;
                            break;

                if(i找到几个物体==0):
                    self.report({"ERROR"},"can't find object in the list %d"%(i找到几个物体));#"INFO" "ERROR" "DEBUG" "WARNING"
                    return {"RUNNING_MODAL"};
                else:
                    self.report({"INFO"},"find object in the list  %d"%(i找到几个物体));#"INFO" "ERROR" "DEBUG" "WARNING"
            #--------------------------------------------------------------------------
            self._handle = bpy.types.SpaceView3D.draw_handler_add(ΔΔ画画,(self, context), 'WINDOW', 'POST_PIXEL');
            context.window_manager.modal_handler_add(self);#(self==Operator) to call  Return type: boolean

            return {"RUNNING_MODAL"};

        else:
            i显示G=-1;print("BP invoke1==",i显示G);
            return {'RUNNING_MODAL'};


#////////////////////////////////////////////////
class 卐载入DLL卐Operator(bpy.types.Operator):
    bl_idname ="op.load_dll_cloth";
    bl_label = "load cloth dll";
    bl_options = {"REGISTER", "UNDO"};

    @classmethod
    def poll(cls, context):return True; #(obj and obj.type == "MESH")

    def execute(self, context):
        LIB.dllCloth=dllΔΔ载入dllLIB(LIB,"dllCloth",dllpathB,dllpath64);
        return {"FINISHED"};

class 卐卸载DLL卐Operator(bpy.types.Operator):
    bl_idname ="op.del_dll_cloth";
    bl_label = "unload cloth dll";
    bl_options = {"REGISTER", "UNDO"};

    @classmethod
    def poll(cls, context):
        return True; #(obj and obj.type == "MESH")
    def execute(self, context):
        #bpy.ops.op.imdjs_clothzero("INVOKE_DEFAULT");
        while(LIB.dllCloth):
            LIB.dllCloth.ΔΔ清空布料G变量();#清空局部变量
            try:
                LIB.dllCloth.bΔΔ释放clib();#有可能没有载入DLL_wrapper
            except:pass;    
            
            
            LIB.dllCloth=dllΔΔ卸载dllLIB(LIB,"dllCloth");

        while(LIB.dllIMDJS):
            LIB.dllIMDJS=dllΔΔ卸载dllLIB(LIB,"dllIMDJS");

        return {"FINISHED"};

#--------------------------------------------------------------------------
Lt4方向 =  [   ("X", "X", "", 1),
            ("-X", "-X", "", 2),
            ("Y", "Y", "", 3),
            ("-Y", "-Y", "", 4),
            ("Z", "Z", "", 5),
            ("-Z", "-Z", "", 6),
        ];

class 卐设置方向ID组卐Operator(bpy.types.Operator):
    """ Set the a name and ip组ID to selected Objects """
    bl_idname = "op.imdjs_setdiridgroup"
    bl_label = "direction"

    name = StringProperty();
    ip组ID = IntProperty();
    ep方向 = EnumProperty(items=Lt4方向);

    @classmethod
    def poll(cls, context):
        return (context.active_object !=None);

    def invoke(self, context, event):
        return context.window_manager.invoke_props_dialog(self,width=200);

    def execute(self,context):
        if (self.name != ""):
            ΔΔ添加ID组("direction",bpy.context.selected_objects,len(bpy.context.selected_objects),self.name,self.ip组ID,self.ep方向);
        return{"FINISHED"};

    def draw(self,context):
        layout = self.layout;

        #Mt = context.active_object.pp物PSRo.pp物体组;
        pp场景物体MT设定s2 = context.scene.pp场景物体MT设定s2;
        name = context.active_object.pp物PSRo.pp物体组;

        row = layout.row();
        row.prop_search(self,"name", ppMT场景组s2, "cp场景组", text = "", icon = "MESH_CUBE");

        row = layout.row();
        row.prop(self,"ep方向");






#////end////end////end////end////end////end////end////end////







